// AboutDlg.cpp : implementation file
//
/*
  This Evaluation kit software is available free of charge and can be used,
  edited, or reproduced as you see fit. Dallas Semiconductor does not
  assume any liability for the accuracy or correctness of this code.

  It is free to use at your own risk.
  */

#include "stdafx.h"
#include "sample.h"
#include "AboutDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif




struct FileInfo {
	CString fileName;
	CString version;
	CString date;
};

struct LANGANDCODEPAGE {
	WORD wLanguage;
	WORD wCodePage;
};

#define VERINFO_comments "comments"
#define VERINFO_CompanyName "CompanyName"
#define VERINFO_FileDescrib "FileDescription"
#define VERINFO_FileVersion "FileVersion"
#define VERINFO_InternalName "InternalName"
#define VERINFO_LegalCopyright "LegalCopyright"
#define VERINFO_LegalTrademarks "LegalTrademarks"
#define VERINFO_OriginalFilename "OriginalFilename"
#define VERINFO_ProductName "ProductName"
#define VERINFO_ProductVersion "ProductVersion"
#define VERINFO_PrivateBuild "PrivateBuild"
#define VERINFO_SpecialBuild "SpecialBuild"
CString GetFileVersionInfoString(LPCSTR fileFullName,LPCSTR verInfoString);



CString GetFileVersionInfoString(LPCSTR fileFullName,LPCSTR verInfoString) {
	char *rcData = 0; 
	DWORD dwSize;
	UINT wSize;
	LANGANDCODEPAGE *lpTranslate;

	LPTSTR fileName = (LPTSTR)fileFullName;

	//file name and path
	CFileStatus status;
	CString verInfo = "Unavailable";
	if( CFile::GetStatus(fileName, status ) ) {
		//Version
		LPDWORD handle1 = 0;
		dwSize = ::GetFileVersionInfoSize(fileName, handle1);
		if (! dwSize)
		return verInfo;

		rcData = new char[dwSize];

		// get valid resource data using path, handle, and size
		int result = ::GetFileVersionInfo(fileName, 0, dwSize, (LPVOID)rcData);
		if (result) {
			result = ::VerQueryValue(rcData,TEXT("\\VarFileInfo\\Translation" ),
			(LPVOID*)&lpTranslate, &wSize);
			if (result == 0 || wSize == 0) {
				delete []rcData;
				return verInfo;
			}
		}
		// Read the file description for each language and code page.
		char SubBlock[100];
		LPVOID lpBuffer;
		for( unsigned i=0; i < (wSize/sizeof(struct LANGANDCODEPAGE)); i++ ) {
			wsprintf( SubBlock, 
			TEXT("\\StringFileInfo\\%04x%04x\\%s"),
			lpTranslate[i].wLanguage,lpTranslate[i].wCodePage,verInfoString);

			result = VerQueryValue(rcData, SubBlock, (LPVOID*)&lpBuffer, &wSize);
			if (!result) 
			break;
			verInfo = (LPCSTR)lpBuffer;
		}
		delete []rcData;
	}

	return verInfo;
}







/////////////////////////////////////////////////////////////////////////////
// AboutDlg dialog


AboutDlg::AboutDlg(CWnd* pParent /*=NULL*/)
	: CDialog(AboutDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(AboutDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void AboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(AboutDlg)
	DDX_Control(pDX, IDC_HYPERLINK_WEB2, m_hyperlink_ftp);
	DDX_Control(pDX, IDC_HYPERLINK_WEB, m_hyperlink_web);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(AboutDlg, CDialog)
	//{{AFX_MSG_MAP(AboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// AboutDlg message handlers

void AboutDlg::OnOK() 
{
	// TODO: Add extra validation here

//m_hyperlink_web
	
	CDialog::OnOK();
}

BOOL AboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	char str[128];
	bool bExeFound = false;
	FILE *exefile;
	char appname[128];

	strcpy(appname,AfxGetAppName());
	strcat(appname,".EXE");	
	

// if this is debug version then check for the executable in the
//  ".\debug" directory... else if release then check the ".\release"
// directory.  Lastly if both of the above fail then we are not in a 
// VC++ development enviroment and check for the version in the default
// current directory.
#ifdef _DEBUG
	GetCurrentDirectory(128,str);
	strcat(str,"\\Debug\\");
	strcat(str,appname);
	exefile = fopen(str,"rb");
	if (exefile) {
//		AfxMessageBox("exe found in debug");
		bExeFound = true;
		fclose(exefile);
	}
#endif

#ifndef _DEBUG
	GetCurrentDirectory(128,str);
	strcat(str,"\\Release\\");
	strcat(str,appname);
	exefile = fopen(str,"rb");
	if (exefile) {
//		AfxMessageBox("exe found in release");
		bExeFound = true;
		fclose(exefile);
	}
#endif

	if (bExeFound == false) {
//		AfxMessageBox("exe found in current");
		GetCurrentDirectory(128,str);
		strcat(str,"\\");	
		strcat(str,appname);
		//AfxMessageBox(str);
	}


//	AfxMessageBox(str);

	CString sInfo = "Unavailable ";

	CString fullFilename;
//	fullFilename = TEXT("D:\\DS161x\\Curtis\\debug\\DS161x.exe"); 
	fullFilename = str; 

	sInfo = GetFileVersionInfoString(fullFilename,VERINFO_FileDescrib); 
	GetDlgItem(IDC_FILEDESCRIPTION)->SetWindowText((LPCTSTR)sInfo);
	sInfo = GetFileVersionInfoString(fullFilename,VERINFO_CompanyName); 
	GetDlgItem(IDC_COMPANYNAME)->SetWindowText((LPCTSTR)sInfo);
	sInfo = GetFileVersionInfoString(fullFilename,VERINFO_LegalCopyright); 
	GetDlgItem(IDC_LEGALCOPYRIGHT)->SetWindowText((LPCTSTR)sInfo);
	sInfo = "Version ";
	sInfo += GetFileVersionInfoString(fullFilename,VERINFO_FileVersion); 
	GetDlgItem(IDC_FILEVERSION)->SetWindowText((LPCTSTR)sInfo);

	sprintf(str,"%s , %s",__DATE__,__TIME__);
	GetDlgItem(IDC_BUILD_DATE_TIME)->SetWindowText(str);

	// TODO: Add extra initialization here

//ftp://ftp.dalsemi.com/pub/datalogging/
/*	CString str1;
	str1 = _T("ftp://ftp.dalsemi.com/pub/datalogging");
	TCHAR* ch = str1.GetBuffer(str1.GetLength());  

	// Use shell to invoke Web browser on the HTML help file.
	int iRes = (int) ShellExecute(
		NULL,
		_T("open"),
		ch,
		NULL,
		NULL,
		SW_SHOWNORMAL);


	if(iRes <= 32)
		AfxMessageBox(_T("An error occured. Please browse ") + str1 + _T(" manually from your Microsoft Internet Explorer !"), MB_ICONEXCLAMATION);
	str1.ReleaseBuffer(); */
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
