/*
  This Evaluation kit software is available free of charge and can be used,
  edited, or reproduced as you see fit. Dallas Semiconductor does not
  assume any liability for the accuracy or correctness of this code.

  It is free to use at your own risk.
  */
#define MODE_NONE       0
#define MODE_RS232_COM1 1
#define MODE_RS232_COM2 2
#define MODE_3WIRE_COM1 3
#define MODE_3WIRE_COM2 4




extern int io_mode;


int Read_RTC_Page(unsigned char * pbuffer);
int DS1615_Read_Histogram(unsigned int *dat);
int DS1615_Read_Datalog(unsigned int *dat);
int DS1615_Write_Byte(unsigned int address, unsigned char data);
void DS1615_Clear_Memory(unsigned char old_value);
void DS1615_Clear_STEnable(unsigned char old_value);
void DS1615_Begin_Mission(unsigned char rate);
void DS1615_End_Mission();
void DS1615_Start_Delay(unsigned int delay);
unsigned int DS1615_Get_Start_Delay();
unsigned int DS1615_Get_Sample_Rate();
void DS1615_Temp_Command();
unsigned long DS1615_Get_Current_Sample();
int Read_Page(int page,unsigned char * pbuffer);
void Read_RTC_CMD();
void Read_User_CMD();
void Read_Page_CMD(int page);

unsigned int DS1615BufferToTimeStamp(unsigned char *buffer,LPSYSTEMTIME lpSystemTime);
VOID DS1615BufferToCurrentTime(unsigned char *buffer,LPSYSTEMTIME lpSystemTime);
unsigned long DS1615BufferToCurrentSample(unsigned char *buffer);
unsigned long DS1615BufferToTotalSamples(unsigned char *buffer);
unsigned int DS1615BufferToSampleDelay(unsigned char *buffer);
unsigned int DS1615BufferToSampleRate(unsigned char *buffer);
void DS1615_Write_Control(unsigned char dat);
void DS1615_Write_Status(unsigned char dat);
void DS1615_Write_RTC(LPSYSTEMTIME lpSystemTime);
VOID DS1615BufferToAlarmTime(unsigned char *buffer,LPSYSTEMTIME lpSystemTime,
						unsigned char *MS,
						unsigned char *MM,
						unsigned char *MH,
						unsigned char *MD
						);


