/*
  This Evaluation kit software is available free of charge and can be used,
  edited, or reproduced as you see fit. Dallas Semiconductor does not
  assume any liability for the accuracy or correctness of this code.

  It is free to use at your own risk.
  */
#include "stdafx.h"
#include "GCClock.h"
#include "DS1678.h"
#include "Serial.h"


void OnSetbreak() 
{
	// TODO: Add your control notification handler code here
	Com_set_break();
}

void OnClearbreak() 
{
	// TODO: Add your control notification handler code here
	Com_clear_break();
}


VOID Init_DS1678_Port(int port) {
	int status;
	status = Com_InitPort("COM1", 9600, 1);		
    if (status == COM_OPEN_ERROR) {
      AfxMessageBox("Error: Can not open Port 1");
//	  io_mode = MODE_NONE;
	  return;
	}

 // now turn on power to part by setting break on TXD
	OnSetbreak();

}



unsigned char data = 0xFF;



// 10000 = 100uS
// 20000 =  50uS
clock_t wait = CLOCKS_PER_SEC / (clock_t) 20000;
double delay;
double delay2 = 9.99;
#define DELAY()  delay = delay2 / 1.1111; delay = delay2 / 1.1111; delay = delay2 / 1.1111; delay = delay2 / 1.1111; delay = delay2 / 1.1111; delay = delay2 / 1.1111; delay = delay2 / 1.1111; delay = delay2 / 1.1111 

// delay
void Delay(){
/*   clock_t goal = wait + clock();   
   while( goal > clock() )   ;*/
	DELAY();
	DELAY();
	DELAY();
	DELAY();
	DELAY();
	DELAY();
	DELAY();
	DELAY();
	DELAY();
	DELAY();
	DELAY();
	DELAY();
	DELAY();
}



#define clk(c)     Com_dtr(c); Delay() 
#define dataout(d) Com_rts(d); Delay()
#define datain()   Com_get_cts(); Delay()
//#define datadirout() Delay(); Com_clear_break()
//#define datadirin()  Delay(); Com_set_break()



void TWire_Start() {
	clk(1);
	dataout(1);
  // send start
	dataout(0);
}

void TWire_Stop() {
	dataout(0);
	clk(1);
	dataout(1);
}




int TWire_Write(unsigned char d) {
	int read;
	data = d;
	// TODO: Add your control notification handler code here
  // send bit 7	
	clk(0);
	dataout(data & 0x80);  data = data << 1;
	clk(1);
	clk(0);
  // send bit 6
	dataout(data & 0x80);  data = data << 1;
	clk(1);
	clk(0);
  // send bit 5	
	dataout(data & 0x80);  data = data << 1;
	clk(1);
	clk(0);
  // send bit 4	
	dataout(data & 0x80);  data = data << 1;
	clk(1);
	clk(0);
  // send bit 3	
	dataout(data & 0x80);  data = data << 1;
	clk(1);
	clk(0);
  // send bit 2	
	dataout(data & 0x80);  data = data << 1;
	clk(1);
	clk(0);
  // send bit 1	
	dataout(data & 0x80);  data = data << 1;
	clk(1);
	clk(0);
  // send bit 0	
	dataout(data & 0x80);  data = data << 1;
	clk(1);
	clk(0);

	dataout(1);  // release data-out to read data-in
	clk(1);
	read = datain();
	clk(0);
	if (read) return 1; else return 0;

}

unsigned char TWire_Read() {
	int i;
	int read;
	data = 0x00;
  // release data line 
	dataout(1);
	clk(0);
	for (i = 0; i < 8; i ++) {
	  data = data << 1; 
	  clk(1);
	  read = datain();
	  clk(0);
	  if (read == 0) { data |= 0x01; }  
	}
  // ack 2wire part
	dataout(0);
	clk(1);
	clk(0);
	return data;
}

unsigned char TWire_Read_Nack() {
	int i;
	int read;
	data = 0x00;
  // release data line 
	dataout(1);
	clk(0);
	for (i = 0; i < 8; i ++) {
	  data = data << 1; 
	  clk(1);
	  read = datain();
	  clk(0);
	  if (read == 0) { data |= 0x01; }  
	}
  // nack 2wire part
	dataout(1);
	clk(1);
	clk(0);
	return data;
}


void TWire_Fill_Memory(unsigned char d) {
	int i;

  // enter test mode    
	TWire_Start();
	TWire_Write(0x94);
	TWire_Write(0x9D);
	TWire_Write(0xAD);
	TWire_Write(0x57);
	TWire_Write(0x0F);
    TWire_Stop();

    
    TWire_Start();
	TWire_Write(0x94);
	TWire_Write(0x41);
	TWire_Write(0x00);
	TWire_Write(0x00);
	for (i = 0; i < 2048; i++) {
	  TWire_Write(d);
	}
    TWire_Stop();

	
  // exit test mode	
	TWire_Start();
	TWire_Write(0x94);
	TWire_Write(0x9D);
	TWire_Write(0xAD);
	TWire_Write(0x57);
	TWire_Write(0x8F);
    TWire_Stop();

}


int bcd_to_bin(unsigned char d) {
  int i;
  unsigned char c;

  c = d >> 4;
  i = (int)((c & 0x0F) * 10);
  i += (int)(d & 0x0F);
  return i;
}



unsigned char bin_to_bcd(int d) {
  int i;
  unsigned char c;

  i = d / 10;
  c = (unsigned char)(i * 16);
  i = d % 10;
  c += (unsigned char)i;
  return c;
}



VOID GetDS1678Time(LPSYSTEMTIME lpSystemTime) {

unsigned char tim[8];

	lpSystemTime->wYear = 1980;
	lpSystemTime->wMonth = 1;
	lpSystemTime->wDayOfWeek = 1;
	lpSystemTime->wDay = 1;
	lpSystemTime->wHour = 0;
	lpSystemTime->wMinute = 0;
	lpSystemTime->wSecond = 0;
	lpSystemTime->wMilliseconds = 1;

	TWire_Start();
	TWire_Write(0x94);
	TWire_Write(0x00);
	TWire_Stop();	
	TWire_Start();
	TWire_Write(0x95);
	tim[0] = TWire_Read();
	tim[1] = TWire_Read();
	tim[2] = TWire_Read();
	tim[3] = TWire_Read();
	tim[4] = TWire_Read();
	tim[5] = TWire_Read();
	tim[6] = TWire_Read();
	tim[7] = TWire_Read_Nack();
	//TWire_Read_Nack();
	TWire_Stop();	

	if (tim[0] != 255) {
	  lpSystemTime->wSecond = bcd_to_bin(tim[0]);
	  lpSystemTime->wMinute = bcd_to_bin(tim[1]);
	  lpSystemTime->wHour   = bcd_to_bin(tim[2]);
	  lpSystemTime->wDayOfWeek   = bcd_to_bin(tim[3]);
	  lpSystemTime->wDay	     = bcd_to_bin(tim[4]);
	  lpSystemTime->wMonth	     = bcd_to_bin(tim[5]);
	  lpSystemTime->wYear	     = bcd_to_bin(tim[7]) * 100 + bcd_to_bin(tim[6]);
	}

}


VOID SetCurrentDS1678Time() {

SYSTEMTIME SystemTime;

    GetLocalTime(&SystemTime);

	int year,cent;

	year = SystemTime.wYear % 100;
	cent = SystemTime.wYear / 100;

    TWire_Start();
	TWire_Write(0x94);
	TWire_Write(0x00);
	TWire_Write(bin_to_bcd(SystemTime.wSecond));
	TWire_Write(bin_to_bcd(SystemTime.wMinute));
	TWire_Write(bin_to_bcd(SystemTime.wHour));
	TWire_Write(bin_to_bcd(SystemTime.wDayOfWeek));
	TWire_Write(bin_to_bcd(SystemTime.wDay));
	TWire_Write(bin_to_bcd(SystemTime.wMonth));
	TWire_Write(bin_to_bcd(year));
	TWire_Write(bin_to_bcd(cent));
	TWire_Stop();	
}


VOID GetDS1678AlarmTime(LPSYSTEMTIME lpSystemTime,
						unsigned char *MS,
						unsigned char *MM,
						unsigned char *MH,
						unsigned char *MD
						) {

unsigned char tim[8];

	lpSystemTime->wYear = 1980;
	lpSystemTime->wMonth = 1;
	lpSystemTime->wDayOfWeek = 1;
	lpSystemTime->wDay = 1;
	lpSystemTime->wHour = 0;
	lpSystemTime->wMinute = 0;
	lpSystemTime->wSecond = 0;
	lpSystemTime->wMilliseconds = 1;

	TWire_Start();
	TWire_Write(0x94);
	TWire_Write(0x08);
	TWire_Stop();	
	TWire_Start();
	TWire_Write(0x95);
	tim[0] = TWire_Read();
	tim[1] = TWire_Read();
	tim[2] = TWire_Read();
	tim[3] = TWire_Read_Nack();
//	TWire_Read_Nack();
	TWire_Stop();	

  // Look at the alarm mask bits and mask them off
	*MS = tim[0] & 0x80;
	tim[0] &= 0x7F;
	*MM = tim[1] & 0x80;
	tim[1] &= 0x7F;
	*MH = tim[2] & 0x80;
	tim[2] &= 0x7F;
	*MD = tim[3] & 0x80;
	tim[3] &= 0x7F;

	if (tim[0] != 127) {
	  lpSystemTime->wSecond = bcd_to_bin(tim[0]);
	  lpSystemTime->wMinute = bcd_to_bin(tim[1]);
	  lpSystemTime->wHour   = bcd_to_bin(tim[2]);
	  lpSystemTime->wDay   = bcd_to_bin(tim[3]);
	}

}


VOID SetDS1678AlarmTime(SYSTEMTIME SystemTime,
						unsigned char MS,
						unsigned char MM,
						unsigned char MH,
						unsigned char MD
						) {

	int year,cent;

	year = SystemTime.wYear % 100;
	cent = SystemTime.wYear / 100;

    TWire_Start();
	TWire_Write(0x94);
	TWire_Write(0x08);
	TWire_Write(bin_to_bcd(SystemTime.wSecond) | MS);
	TWire_Write(bin_to_bcd(SystemTime.wMinute) | MM);
	TWire_Write(bin_to_bcd(SystemTime.wHour)   | MH);
	TWire_Write(bin_to_bcd(SystemTime.wDay) | MD);
	TWire_Stop();	
}



VOID GetDS1678StampTime(LPSYSTEMTIME lpSystemTime) {

unsigned char tim[8];

	lpSystemTime->wYear = 1980;
	lpSystemTime->wMonth = 1;
	lpSystemTime->wDayOfWeek = 1;
	lpSystemTime->wDay = 1;
	lpSystemTime->wHour = 0;
	lpSystemTime->wMinute = 0;
	lpSystemTime->wSecond = 0;
	lpSystemTime->wMilliseconds = 1;

	TWire_Start();
	TWire_Write(0x94);
	TWire_Write(0x30);
	TWire_Stop();	
	TWire_Start();
	TWire_Write(0x95);
	tim[0] = TWire_Read();
	tim[1] = TWire_Read();
	tim[2] = TWire_Read();
	tim[3] = TWire_Read();
	tim[4] = TWire_Read();
	tim[5] = TWire_Read();
	tim[6] = TWire_Read();
	tim[7] = TWire_Read_Nack();
	//TWire_Read_Nack();
	TWire_Stop();	

	if (tim[7] != 0)  // filter out all zeros
		if (tim[0] != 255) {
		  lpSystemTime->wSecond = bcd_to_bin(tim[0]);
		  lpSystemTime->wMinute = bcd_to_bin(tim[1]);
		  lpSystemTime->wHour   = bcd_to_bin(tim[2]);
		  lpSystemTime->wDayOfWeek   = bcd_to_bin(tim[3]);
		  lpSystemTime->wDay	     = bcd_to_bin(tim[4]);
		  lpSystemTime->wMonth	     = bcd_to_bin(tim[5]);
		  lpSystemTime->wYear	     = bcd_to_bin(tim[7]) * 100 + bcd_to_bin(tim[6]);
		}

}






VOID DS1678WriteByte(   unsigned char Addr,
						unsigned char Data
						) {

	TWire_Start();
	TWire_Write(0x94);
	TWire_Write(Addr);
	TWire_Write(Data);
	TWire_Stop();	
}


unsigned char DS1678ReadByte(unsigned char Addr) {

	unsigned char d;

	TWire_Start();
	TWire_Write(0x94);
	TWire_Write(Addr);
	TWire_Stop();	
	TWire_Start();
	TWire_Write(0x95);
	d = TWire_Read_Nack();
//	TWire_Read_Nack();
	TWire_Stop();	

	return d;
}



VOID DS1678ClearMemory( void ) {

    unsigned char d1,d2;

	d1 = DS1678ReadByte(0x0E);
	d2 = DS1678ReadByte(0x0F);
	    #ifdef _DEBUG
		   _CrtDbgReport(_CRT_WARN,"DS1678.cpp",__LINE__,"Demo",":  %02X %02X\n",d1,d2);
	    #endif
  // set clr enable bit and set clock osc enable bit
	d1 |= 0x41;
  // set clear memory bit
	d2 |= 0x10;
	    #ifdef _DEBUG
		   _CrtDbgReport(_CRT_WARN,"DS1678.cpp",__LINE__,"Demo",":  %02X %02X\n",d1,d2);
	    #endif


	TWire_Start();
	TWire_Write(0x94);
	TWire_Write(0x0E);
	TWire_Write(d1);
	TWire_Write(d2);
	TWire_Stop();	



/*	TWire_Start();
	TWire_Write(0x94);
	TWire_Write(0x0E);
	TWire_Write(0x13);
	TWire_Stop();	

	TWire_Start();
	TWire_Write(0x94);
	TWire_Write(0x0E);
	TWire_Write(0x53);
	TWire_Write(0x10);
	TWire_Stop();	
*/
}

int  bytes_read = 0;

void DS1678ReadLogMemory(unsigned char *array) 
{
	int i;
	int bytes = 0;
	int read;
	char str[2550];
	char str2[2550];
	data = 0x90;
    str[0] = 0;
    str2[0] = 0;
	// TODO: Add your control notification handler code here
    TWire_Start();
	TWire_Write(0x94);
	TWire_Write(0x41);
	TWire_Write(0x00);
	TWire_Write(0x00);
	TWire_Stop();	
    TWire_Start();
	TWire_Write(0x95);
	for (i = 0; i < 2048; i++) {
	  bytes_read = i;
	  array[i] = TWire_Read();
	}
	TWire_Read_Nack();
	TWire_Stop();	
//	UpdateData(FALSE);
//	AfxMessageBox("Done");
}
