// DataSource.cpp : implementation file
//
/*
  This Evaluation kit software is available free of charge and can be used,
  edited, or reproduced as you see fit. Dallas Semiconductor does not
  assume any liability for the accuracy or correctness of this code.

  It is free to use at your own risk.
  */

#include "stdafx.h"
#include "sample.h"
#include "DataSource.h"
#include "Common.h"
#include "Cmd_Pipe.h"
#include "DS1615io.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern bool auto_poll;
/////////////////////////////////////////////////////////////////////////////
// CDataSource dialog


CDataSource::CDataSource(CWnd* pParent /*=NULL*/)
	: CDialog(CDataSource::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDataSource)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDataSource::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDataSource)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDataSource, CDialog)
	//{{AFX_MSG_MAP(CDataSource)
	ON_BN_CLICKED(IDC_GETFILE, OnGetfile)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDataSource message handlers


int verifyfile(char *filename) {
	FILE *memoryimagefile;
	int length, pos;

	memoryimagefile = fopen(filename,"rb");
	if (memoryimagefile == NULL) return -1;
	// check to see if the length of the file is exactly 6144
	pos = ftell(memoryimagefile);
	fseek(memoryimagefile, 0, SEEK_END);
	// get the length of the file
	length = ftell(memoryimagefile);
	// set the position back to the beginning
	fseek(memoryimagefile, pos, SEEK_SET);
	if (length != 6144) {
		// opps, length of file doesn't match
		fclose(memoryimagefile);
		return -1;
	}
	fclose(memoryimagefile);
	return 0;
}
void CDataSource::OnOK() 
{
	// TODO: Add extra validation here
/*	char str[10];
	int selection;

	m_Temp.GetWindowText(str,9);
	sscanf(str,"%f",&temperature);
*/
	CButton* check;
	check = (CButton*)GetDlgItem(IDC_CHECK_SPOLL);
	if (check->GetCheck() == 1) auto_poll = true; else auto_poll = false;

	m_selection = GetCheckedRadioButton(IDC_RADIO_KEY,IDC_RADIO_DISK);
	GetDlgItem(IDC_EDIT_FILENAME)->GetWindowText(m_filename,128);

	if (m_selection == IDC_RADIO_DISK) {
		if (verifyfile(m_filename) < 0) {
			MessageBox("Valid filename needed","Using Data file as source",MB_OK | MB_ICONEXCLAMATION);
			return;
		}
	}

	CDialog::OnOK();
}

void CDataSource::OnGetfile() 
{
	char filename[128];
	// TODO: Add your control notification handler code here
	if (GetFilename(filename,"Use File as Data Source","DataDump.hex","Data files *.hex\0*.hex\0All Files *.*\0*.*\0\0","hex") == -1) return;
	GetDlgItem(IDC_EDIT_FILENAME)->SetWindowText(filename);

}

void CDataSource::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}


BOOL CDataSource::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	CheckRadioButton(IDC_RADIO_KEY,IDC_RADIO_DISK,m_selection);	
	GetDlgItem(IDC_EDIT_FILENAME)->SetWindowText(m_filename);

	CButton* check;
	check = (CButton*)GetDlgItem(IDC_CHECK_SPOLL);
	if (auto_poll)
		check->SetCheck(1);
	else
		check->SetCheck(0);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

