// EditUserSimple.cpp : implementation file
//
/*
  This Evaluation kit software is available free of charge and can be used,
  edited, or reproduced as you see fit. Dallas Semiconductor does not
  assume any liability for the accuracy or correctness of this code.

  It is free to use at your own risk.
  */

#include "stdafx.h"
#include "sample.h"
#include "EditUserSimple.h"
#include "Cmd_Pipe.h"
	
#include "Cdebug.h"
extern CDebug Debug;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditUserSimple dialog
extern bool suspend_timers;
extern bool suspend_due_to_error;
static int CLOCK_UPDATE_TIMER_ID = 21;
static int InitControls = 1;
static int TIMER_ID = 0;

static unsigned char lastseconds = 0;
static bool read_datahist_queued = false;
static int read_timeout = 0;
static DWORD tick;
static int read_page_status = STATUS_IDLE;
static int page_processed = -1;
static unsigned char buffer[64];
static unsigned char page_start = 2;
static unsigned char page_end   = 2;
/*unsigned char ro_modify;
int Flag_RollOver = 0;
int Start_Pin_Enable = 0;
int Start_Software = 0;
unsigned char sample_rate = 1;*/
static int mission_stopped_event = STATUS_IDLE;
static char temp_scale = 'F';
static char filename[256];
#define MEMSIZE 32
static unsigned char data[256];
static unsigned char rdata[256];
static bool read_datalog = false;


CEditUserSimple::CEditUserSimple(CWnd* pParent /*=NULL*/)
	: CDialog(CEditUserSimple::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditUserSimple)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CEditUserSimple::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditUserSimple)
	DDX_Control(pDX, IDC_EDIT_LINE, m_Edit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditUserSimple, CDialog)
	//{{AFX_MSG_MAP(CEditUserSimple)
	ON_BN_CLICKED(IDC_READ, OnRead)
	ON_BN_CLICKED(IDC_WRITE, OnWrite)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditUserSimple message handlers

void CEditUserSimple::OnRead() 
{
	// TODO: Add your control notification handler code here
	Debug.Printf0("read_datalog = true");
	read_datalog = true;
}

void CEditUserSimple::OnWrite() 
{
	// TODO: Add your control notification handler code here
	static unsigned char addr[32];
	int i,j,k;

	// get the data from the control
	m_Edit.GetWindowText((char *)data,34);

	k = strlen((char *)data);
	for (i = k; i < 32; i++)
		data[i] = 0;

	// init addresses to write to
	for (i = 0x40,j = 0; i < 0x60; i++, j++) 
		addr[j] = i;
	for (i = 0; i < 32; i++)
		Cmd_Insert(CMD_WRITE_REGISTER,&addr[i],&data[i],NULL,NULL,NULL);

	read_datalog = true;
}

void CEditUserSimple::OnOK() 
{
	// TODO: Add extra validation here
	int response, cmp;

	while (read_datalog == true)
		Refresh();

	m_Edit.GetWindowText((char *)data,34);
	cmp = strcmp((char *)data,(char *)rdata);
	if (cmp != 0){
		response = MessageBox("Save Data?","Edit User Memory",MB_YESNO | MB_ICONQUESTION);
		if (response == IDYES)
			OnWrite();
	}

	suspend_timers = false;
//	CDC* ptrDC;
//	ptrDC = GetDC();
//	ptrDC->SelectObject(m_Font_Old);
//	ReleaseDC(ptrDC);
	this->KillTimer(TIMER_ID);
	CDialog::OnOK();
}


void CEditUserSimple::Refresh()  {
	// TODO: Add your control notification handler code here

	int returnval;

		//if (!read_datahist_queued) {
		returnval = Cmd_Process();
		if (returnval == CMD_SUSPEND) {
			return;
		}
		if (returnval == CMD_SHUTDOWN) {
			return;
		}
		//}
		if (read_datalog == true) {
			if (read_page_status == STATUS_IDLE) {
				page_processed = -1;  // init this var for our progress control
				Debug.Printf0("Cmd_Insert");
				Cmd_Insert(CMD_READ_PAGE,buffer,&page_start,&page_end,&page_processed,&read_page_status);
			}
		}
		// if a read is queued then show progress
/*		if (read_page_status == STATUS_QUEUED) {
			if (page_processed != -1) {
				m_DataLog_Progress.SetPos((page_processed - page_start) + 1);
			} else {
				m_DataLog_Progress.SetPos(0);
			}
		}*/
		if (read_page_status == STATUS_DONE) {
				Debug.Printf0("STATUS_DONE");
			    read_page_status = STATUS_IDLE;
				for (int i = 0; i < MEMSIZE; i++){
					data[i] = buffer[i];
					rdata[i] = buffer[i];
				}
				data[i] = 0;
				rdata[i] = 0;
				m_Edit.SetWindowText((char *)data);
				//m_Edit.RedrawWindow();
				read_datalog = false;
		}
}



void CEditUserSimple::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if (nIDEvent == CLOCK_UPDATE_TIMER_ID) {
//		if (TStackedPage::IsPageActive()) {
			Debug.Printf0("CEditUserMemory tick");
//			if (InitControls) {
//				OnInit();
//				InitControls = 0;
//			} else {
				if (!suspend_due_to_error)
					Refresh();
//			}
//		}
	}
	
	CDialog::OnTimer(nIDEvent);
}

BOOL CEditUserSimple::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	TIMER_ID = this->SetTimer(CLOCK_UPDATE_TIMER_ID,100,NULL);
	suspend_timers = true;
	read_datalog = true;
	m_Edit.SetLimitText(32);
	m_Edit.LimitText(32);

	//CDC* ptrDC;
	//ptrDC = GetDC();
	m_Font.CreateFont(-14, 0,0,0,0,0,0,0,0,0,0,0,0, "Courier New");
	//m_Font_Old = (CFont *)ptrDC->SelectObject(&m_Font);
	SetFont(&m_Font);
	//ReleaseDC(ptrDC);

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
