 // MemoryToFile.cpp : implementation file
//
/*
  This Evaluation kit software is available free of charge and can be used,
  edited, or reproduced as you see fit. Dallas Semiconductor does not
  assume any liability for the accuracy or correctness of this code.

  It is free to use at your own risk.
  */

#include "stdafx.h"
#include "sample.h"
#include "MemoryToFile.h"
#include "Cmd_Pipe.h"

#include "Cdebug.h"
extern CDebug Debug;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMemoryToFile dialog
extern bool suspend_timers;
extern bool suspend_due_to_error;
static int CLOCK_UPDATE_TIMER_ID = 22;
static int InitControls = 1;
static int TIMER_ID = 0;


CMemoryToFile::CMemoryToFile(CWnd* pParent /*=NULL*/)
	: CDialog(CMemoryToFile::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMemoryToFile)
	//}}AFX_DATA_INIT
}


void CMemoryToFile::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMemoryToFile)
	DDX_Control(pDX, IDC_DATALOGPROGRESS, m_DataLog_Progress);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMemoryToFile, CDialog)
	//{{AFX_MSG_MAP(CMemoryToFile)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMemoryToFile message handlers


BOOL CMemoryToFile::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_DataLog_Progress.SetRange(0,190);

	TIMER_ID = this->SetTimer(CLOCK_UPDATE_TIMER_ID,10,NULL);
	suspend_timers = true;
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

static unsigned char lastseconds = 0;
static bool read_datahist_queued = false;
static int read_timeout = 0;
static DWORD tick;
static int read_page_status = STATUS_IDLE;
static int page_processed = -1;
static unsigned char buffer[8000];
static unsigned char page_start = 0;
static unsigned char page_end   = 191;
/*unsigned char ro_modify;
int Flag_RollOver = 0;
int Start_Pin_Enable = 0;
int Start_Software = 0;
unsigned char sample_rate = 1;*/
static int mission_stopped_event = STATUS_IDLE;
static char temp_scale = 'F';
static char filename[256];
static bool read_datalog = false;
#define MEMSIZE 6144

void CMemoryToFile::Refresh()  {
	// TODO: Add your control notification handler code here

	int returnval;

		//if (!read_datahist_queued) {
		returnval = Cmd_Process();
		if (returnval == CMD_SUSPEND) {
			return;
		}
		if (returnval == CMD_SHUTDOWN) {
			return;
		}
		//}
		if (read_datalog == true) {
			if (read_page_status == STATUS_IDLE) {
				page_processed = -1;  // init this var for our progress control
				Cmd_Insert(CMD_READ_PAGE,buffer,&page_start,&page_end,&page_processed,&read_page_status);
			}
		}
		// if a read is queued then show progress
		if (read_page_status == STATUS_QUEUED) {
			if (page_processed != -1) {
				m_DataLog_Progress.SetPos((page_processed - page_start) + 1);
			} else {
				m_DataLog_Progress.SetPos(0);
			}
		}
		if (read_page_status == STATUS_DONE) {
			    read_page_status = STATUS_IDLE;
				static unsigned char old_control_register2 = buffer[0x0E];
				if (!(buffer[0x14] & 0x40))
					Cmd_Insert(CMD_CLEAR_STENABLE,&old_control_register2,NULL,NULL,NULL,NULL);
				FILE *outfile = fopen(filename,"wb");
				for (int i = 0; i < MEMSIZE; i++)
					putc(buffer[i],outfile);
				fclose(outfile);
				read_datalog = false;
				strcat(filename, " Saved.");
				MessageBox(filename,"Hex Memory Image to File");
				OnOK();
		}
}



void CMemoryToFile::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if (nIDEvent == CLOCK_UPDATE_TIMER_ID) {
//		if (TStackedPage::IsPageActive()) {
			Debug.Printf1("CMemoryToFile tick");
//			if (InitControls) {
//				OnInit();
//				InitControls = 0;
//			} else {
				if (!suspend_due_to_error)
					Refresh();
//			}
//		}
	}
	
	CDialog::OnTimer(nIDEvent);
}

int		open_stat;

void CMemoryToFile::GetFilename(char *filename) 
{
	// TODO: Add your command handler code here

	char	FileName[500];
	char	FileTitle[100];


//	AfxMessageBox("Option Currently Not Implemented");
//		return;
	
	OPENFILENAME ofn;	// Filename structure
	memset(&ofn, 0, sizeof(ofn));
	ofn.lStructSize = sizeof(OPENFILENAME);

	ofn.hwndOwner=NULL;

	ofn.hInstance = NULL;

	ofn.lpstrFilter =
		TEXT("Hex files *.hex\0*.hex\0All Files *.*\0*.*\0\0");

	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter = 0;
	ofn.nFilterIndex = 1;
	ofn.lpstrFile = FileName;
	ofn.nMaxFile = 500;
	ofn.lpstrFileTitle = FileTitle;
	ofn.nMaxFileTitle = 99;
	ofn.lpstrInitialDir = NULL;
	ofn.lpstrTitle = "Save The DS161x Hex Dump Data File";
	ofn.lpstrDefExt = "hex";
	ofn.lCustData = NULL;
	ofn.lpfnHook = NULL;
	ofn.lpTemplateName = NULL;

	strcpy(FileName, "datadump.hex");
	
	open_stat = GetOpenFileName(&ofn);

	if (open_stat == 0)
		return;

	strcpy(filename,FileName);

}

void CMemoryToFile::OnOK() 
{
	// TODO: Add extra validation here
	suspend_timers = false;
	this->KillTimer(TIMER_ID);
	CDialog::OnOK();
}

void CMemoryToFile::OnCancel() 
{
	// TODO: Add extra cleanup here
//	if (read_page_status == STATUS_QUEUED)
//		return;
	suspend_timers = false;

	this->KillTimer(TIMER_ID);
	CDialog::OnCancel();
}

void CMemoryToFile::OnSave() 
{
	// TODO: Add your control notification handler code here
//	if (read_page_status == STATUS_QUEUED)
//		return;

	int response = AfxMessageBox("This Operation Will Terminate a Mission in Progress and will take approximately 15 seconds to complete.",MB_OKCANCEL | MB_ICONEXCLAMATION);
	if (response != IDOK) {
		OnCancel();
		return;
	}
	GetFilename(filename);
	if (open_stat == 0){
		OnCancel();
		return;
	}
	CWnd *pWnd;
	pWnd = GetDlgItem(IDCANCEL);  pWnd->EnableWindow(FALSE);
	pWnd = GetDlgItem(IDC_SAVE);  pWnd->EnableWindow(FALSE);
	Cmd_Insert(CMD_END_MISSION,NULL,NULL,NULL,NULL,&mission_stopped_event);
	suspend_timers = true;
	read_datalog = true;
}
