// PageEightDialog.cpp : implementation file
//
/*
  This Evaluation kit software is available free of charge and can be used,
  edited, or reproduced as you see fit. Dallas Semiconductor does not
  assume any liability for the accuracy or correctness of this code.

  It is free to use at your own risk.
  */

#include "stdafx.h"
#include "sample.h"
#include "PageEightDialog.h"
#include "DS1615io.h"
#include "Cmd_Pipe.h"
#include "Common.h"
#include "PrintInformation.h"
#include "PrintDlg.h"

#include "Cdebug.h"
extern CDebug Debug;
//#include "TestOScope.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern bool suspend_timers;
extern bool suspend_due_to_error;
static int CLOCK_UPDATE_TIMER_ID = 23;
static int InitControls = 1;
static int TIMER_ID = 0;

extern bool auto_poll;
#define READFROM_KEY  1
#define READFROM_FILE 2
extern int datasource;


bool g_bSaveAsVoltage;
/////////////////////////////////////////////////////////////////////////////
// CPageEightDialog dialog


CPageEightDialog::CPageEightDialog(CWnd* pParent /*=NULL*/)
	: TStackedPage(CPageEightDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPageEightDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CPageEightDialog::DoDataExchange(CDataExchange* pDX)
{
	TStackedPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageEightDialog)
	DDX_Control(pDX, IDC_COMBO_AVERAGE, m_Combo_Average);
	DDX_Control(pDX, IDC_DATALOGPROGRESS, m_DataLog_Progress);
	DDX_Control(pDX, IDC_TREE, m_Tree);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageEightDialog, TStackedPage)
	//{{AFX_MSG_MAP(CPageEightDialog)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_DEGREE_C, OnButtonDegreeC)
	ON_BN_CLICKED(IDC_BUTTON_DEGREE_F, OnButtonDegreeF)
	ON_BN_CLICKED(IDC_BUTTON_FILESAVE, OnButtonFilesave)
	ON_BN_CLICKED(IDC_PRINT, OnPrint)
	ON_CBN_SELCHANGE(IDC_COMBO_AVERAGE, OnSelchangeComboAverage)
	ON_BN_CLICKED(IDC_BUTTON_PRINT, OnButtonPrint)
	ON_BN_CLICKED(IDC_BUTTON_TICKS, OnButtonTicks)
	ON_BN_CLICKED(IDC_BUTTON_ZOOMIN, OnButtonZoomin)
	ON_BN_CLICKED(IDC_BUTTON_ZOOMOUT, OnButtonZoomout)
	ON_BN_CLICKED(IDC_BUTTON_ZOOMALL, OnButtonZoomall)
	ON_BN_CLICKED(IDC_BUTTON_ZOOMALLTHRESHOLDS, OnButtonZoomallthresholds)
	ON_BN_CLICKED(IDC_CS0, OnCs0)
	ON_BN_CLICKED(IDC_CS1, OnCs1)
	ON_BN_CLICKED(IDC_CS2, OnCs2)
	ON_BN_CLICKED(IDC_CS3, OnCs3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPageEightDialog message handlers

BOOL CPageEightDialog::OnInitDialog() 
{
	TStackedPage::OnInitDialog();

	// TODO: Add extra initialization here
	HTREEITEM htroot = m_Tree.InsertItem("Test root");
	m_Tree.InsertItem("Child A", htroot);
	m_Tree.InsertItem("Child B", htroot);

	CheckRadioButton(IDC_CS0,IDC_CS3,IDC_CS0);	
    m_OScopeCtrl.SetGraphUnits(TEMPERATURE);

	// TODO: Add extra initialization here
	// determine the rectangle for the control
	CRect rect;
	GetDlgItem(IDC_OSCOPE)->GetWindowRect(rect) ;
	ScreenToClient(rect) ;
	// create the control
	m_OScopeCtrl.Create(WS_VISIBLE | WS_CHILD, rect, this) ; 
	// customize the control
	m_OScopeCtrl.SetDataLog() ;
	m_OScopeCtrl.SetRange(-10.0, 10.0, 1) ;
	m_OScopeCtrl.SetYUnits("Temperature") ;
	m_OScopeCtrl.SetXUnits("Samples") ;
	m_OScopeCtrl.SetBackgroundColor(RGB(0, 0, 0)) ;
	m_OScopeCtrl.SetGridColor(RGB(192, 192, 255)) ;
	m_OScopeCtrl.SetPlotColor(RGB(255, 255, 255)) ;
	m_OScopeCtrl.SetF();	
//	m_OScopeCtrl.SetBackgroundColor(RGB(255, 255, 255)) ;
//	m_OScopeCtrl.SetGridColor(RGB(0, 0, 0)) ;
//	m_OScopeCtrl.SetPlotColor(RGB(0, 0, 0)) ;

	m_DataLog_Progress.SetRange(0,63);

	TIMER_ID = this->SetTimer(CLOCK_UPDATE_TIMER_ID,10,NULL);

  // initialize graphical buttons
	m_button_degree_c.SubclassDlgItem( IDC_BUTTON_DEGREE_C, this );
	m_button_degree_c.SetIcon( IDI_ICON_DEGREE_C, 16, 16 );
	m_button_degree_c.SetMaskedBitmap( IDI_ICON_DEGREE_C, 40, 150, RGB( 255, 0, 0 ) );

	m_button_degree_f.SubclassDlgItem( IDC_BUTTON_DEGREE_F, this );
	m_button_degree_f.SetIcon( IDI_ICON_DEGREE_F, 16, 16 );
	m_button_degree_f.SetMaskedBitmap( IDI_ICON_DEGREE_F, 40, 150, RGB( 255, 0, 0 ) );

	m_button_savefile.SubclassDlgItem( IDC_BUTTON_FILESAVE, this );
	m_button_savefile.SetIcon( IDC_BUTTON_FILESAVE, 16, 16 );
	m_button_savefile.SetMaskedBitmap( IDI_ICON_FILESAVE, 40, 150, RGB( 255, 0, 0 ) );

	m_button_print.SubclassDlgItem( IDC_BUTTON_PRINT, this );
	m_button_print.SetIcon( IDI_ICON_PRINT, 16, 16 );
	m_button_print.SetMaskedBitmap( IDI_ICON_PRINT, 40, 150, RGB( 255, 0, 0 ) );

	m_button_ticks.SubclassDlgItem( IDC_BUTTON_TICKS, this );
	m_button_ticks.SetIcon( IDI_ICON_TICKS, 16, 16 );
	m_button_ticks.SetMaskedBitmap( IDI_ICON_TICKS, 40, 150, RGB( 255, 0, 0 ) );

	m_button_zoomin.SubclassDlgItem( IDC_BUTTON_ZOOMIN, this );
	m_button_zoomin.SetIcon( IDI_ICON_ZOOMIN, 16, 16 );
	m_button_zoomin.SetMaskedBitmap( IDI_ICON_ZOOMIN, 40, 150, RGB( 255, 0, 0 ) );

	m_button_zoomout.SubclassDlgItem( IDC_BUTTON_ZOOMOUT, this );
	m_button_zoomout.SetIcon( IDI_ICON_ZOOMOUT, 16, 16 );
	m_button_zoomout.SetMaskedBitmap( IDI_ICON_ZOOMOUT, 40, 150, RGB( 255, 0, 0 ) );

	m_button_zoomall.SubclassDlgItem( IDC_BUTTON_ZOOMALL, this );
	m_button_zoomall.SetIcon( IDI_ICON_ZOOMALL, 16, 16 );
	m_button_zoomall.SetMaskedBitmap( IDI_ICON_ZOOMALL, 40, 150, RGB( 255, 0, 0 ) );

	m_button_zoomallthreshold.SubclassDlgItem( IDC_BUTTON_ZOOMALLTHRESHOLDS, this );
	m_button_zoomallthreshold.SetIcon( IDI_ICON_ZOOMALLTHRESHOLD, 16, 16 );
	m_button_zoomallthreshold.SetMaskedBitmap( IDI_ICON_ZOOMALLTHRESHOLD, 40, 150, RGB( 255, 0, 0 ) );

	m_Combo_Average.AddString("none");
	m_Combo_Average.AddString("2 points");
	m_Combo_Average.AddString("4 points");
	m_Combo_Average.AddString("8 points");
	m_Combo_Average.AddString("16 points");
	m_Combo_Average.SetCurSel(0);

	return TRUE;	// return TRUE unless you set the focus to a control
					// EXCEPTION: OCX Property Pages should return FALSE
}

static unsigned int DataLog_Data[3000];
static bool read_datalog = false;

void CPageEightDialog::OnButton1() 
{
	read_datalog = true;
	m_OScopeCtrl.Zoomall();
}

extern int channels_enabled[4];

void CPageEightDialog::OnSetActive(void) {
	TStackedPage::OnSetActive();

	bool one_is_enabled = false;

	if (channels_enabled[3]) {
  	  one_is_enabled = true;
	  GetDlgItem(IDC_CS3)->EnableWindow(TRUE);
	  CheckRadioButton(IDC_CS0,IDC_CS3,IDC_CS3);	
      m_OScopeCtrl.SetGraphUnits(VOLTAGE);
	}
	else
	  GetDlgItem(IDC_CS3)->EnableWindow(FALSE);

	if (channels_enabled[2]) {
  	  one_is_enabled = true;
	  GetDlgItem(IDC_CS2)->EnableWindow(TRUE);
	  CheckRadioButton(IDC_CS0,IDC_CS3,IDC_CS2);	
      m_OScopeCtrl.SetGraphUnits(VOLTAGE);
	}
	else
	  GetDlgItem(IDC_CS2)->EnableWindow(FALSE);

	if (channels_enabled[1]) {
  	  one_is_enabled = true;
	  GetDlgItem(IDC_CS1)->EnableWindow(TRUE);
	  CheckRadioButton(IDC_CS0,IDC_CS3,IDC_CS1);	
      m_OScopeCtrl.SetGraphUnits(VOLTAGE);
	}
	else
	  GetDlgItem(IDC_CS1)->EnableWindow(FALSE);

	if (channels_enabled[0]) {
  	  one_is_enabled = true;
	  GetDlgItem(IDC_CS0)->EnableWindow(TRUE);
	  CheckRadioButton(IDC_CS0,IDC_CS3,IDC_CS0);
      m_OScopeCtrl.SetGraphUnits(TEMPERATURE);
	}
	else
	  GetDlgItem(IDC_CS0)->EnableWindow(FALSE);

	if (one_is_enabled) {
	  read_datalog = true;
	  m_OScopeCtrl.Zoomall();
	}

	GetDlgItem(IDC_BUTTON1)->SetFocus();
}

void CPageEightDialog::OnSelchangeComboAverage() 
{
	// TODO: Add your control notification handler code here
//	char str[256];
//	sprintf(str,"%d",m_Combo_Average.GetCurSel());
//	AfxMessageBox(str);
	switch (m_Combo_Average.GetCurSel()) {
		case 0: m_OScopeCtrl.SetFilter(0);  break;
		case 1: m_OScopeCtrl.SetFilter(2);  break;
		case 2: m_OScopeCtrl.SetFilter(4);  break;
		case 3: m_OScopeCtrl.SetFilter(8);  break;
		case 4: m_OScopeCtrl.SetFilter(16); break;
	}
}


static bool mouse_down = false;
static CPoint point1;

void CPageEightDialog::OnLButtonDown(UINT nFlags, CPoint point) 
{
	TStackedPage::OnLButtonDown(nFlags, point);
}

void CPageEightDialog::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
mouse_down = false;

	TStackedPage::OnLButtonUp(nFlags, point);
}

void CPageEightDialog::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if (mouse_down) {
		m_OScopeCtrl.DrawRect1(point1,point);
	}

	TStackedPage::OnMouseMove(nFlags, point);
}





#define SEC  0
#define MIN  1
#define HOUR 2

static COleDateTimeSpan TicksToSpan(int mode,long ticks) {


//SetDateTimeSpan( long lDays, int nHours, int nMins, int nSecs );

  double dday = 0;
  COleDateTimeSpan day(dday);
				
//				char str[245];
//				sprintf(str,"ticks %lu",ticks);
//				AfxMessageBox(str);
  switch (mode) {
    case SEC: dday = (double)ticks / ((double)60.0 * (double)60.0 * (double)24.0);
			  day = dday;
			  return day;
			break;
    case MIN: dday = (double)ticks / ((double)60.0 * (double)24.0);
			  day = dday;
			  return day;
			break;
    case HOUR: dday = (double)ticks / (double)24.0;
			   day = dday;
			   return day;
			break;
  }

  return day;
}







static unsigned char lastseconds = 0;
static bool read_datahist_queued = false;
static int read_timeout = 0;
static DWORD tick;
static int read_page_status = STATUS_IDLE;
static int page_processed = -1;
static unsigned char buffer[3000];
static unsigned char page_start = 128;
static unsigned char page_end   = 191;
static unsigned char page0_buffer[64];
static unsigned char page0_start = 0;
static unsigned char page0_end   = 0;

/*unsigned char ro_modify;
int Flag_RollOver = 0;
int Start_Pin_Enable = 0;
int Start_Software = 0;
unsigned char sample_rate = 1;*/
static int mission_stopped_event = STATUS_IDLE;
static char temp_scale = 'F';
static char filename[128];
static bool bsave_file = false;
static struct PrintInfoStruct {
	long totalsamples;
	long missionsamples;
	long cursor_sample;
	SYSTEMTIME timestamp;
	SYSTEMTIME currenttime;
	char serialnumber[64];
	char usermemory_string[36];

	unsigned int sample_rate;
	char cursor_datetime[64];
	char start_datetime[64];
	char end_datetime[64];
	char cursor_temperature[16];
	char range_lowest[32],range_highest[32];
	char threshold_lo[32],threshold_hi[32];
	bool alarm_lo,alarm_hi;
	bool rollover;
	// temperature alarm...
} PrintInfo;
static unsigned char user_page_start = 2;
static unsigned char user_page_end   = 2;
// define static vars for serial number
static unsigned char sn_page_start = 16;
static unsigned char sn_page_end = 16;
static unsigned char sn_buffer[34];

static unsigned char page_start1 = 1;
static unsigned char page_end1 = 1;
static unsigned char buffer1[34];

void CPageEightDialog::UpdatePlotMinMax()  {
	char str[256];
	double ymax;
	double ymin;
	ymax = m_OScopeCtrl.FindMaxY();
	ymin = m_OScopeCtrl.FindMinY();
	sprintf(str,"Highest: %3.1f %c",ymax,temp_scale);
	strcpy(PrintInfo.range_highest,str);
	GetDlgItem(IDC_TEXT_HI)->SetWindowText(str);
	sprintf(str,"Lowest: %3.1f %c",ymin,temp_scale);
	strcpy(PrintInfo.range_lowest,str);
	GetDlgItem(IDC_TEXT_LO)->SetWindowText(str);
}

static long rollover_offset = 0;
extern bool force_plot_refresh;

void CPageEightDialog::Refresh()  {
	// TODO: Add your control notification handler code here

	char str[256];
	char str2[256];
	int returnval;
	double degrees;

//		if (!auto_poll && datasource == READFROM_KEY)
//			return;

		//if (!read_datahist_queued) {
		returnval = Cmd_Process();
		if (returnval == CMD_SUSPEND) {
			return;
		}
		if (returnval == CMD_SHUTDOWN) {
			return;
		}
		//}
		if ((read_datalog == true) || (force_plot_refresh == true)) {
			if (read_page_status == STATUS_IDLE) {
				page_processed = -1;  // init this var for our progress control
				// first read page 0 so that we can get the number of samples recorded
				Cmd_Insert(CMD_READ_PAGE,page0_buffer,&page0_start,&page0_end,NULL,NULL);
				// read page 1 for DS1616 functions
				Cmd_Insert(CMD_READ_PAGE,buffer1,&page_start1,&page_end1,NULL,NULL);
				// get the user memory
				Cmd_Insert(CMD_READ_PAGE,PrintInfo.usermemory_string,&user_page_start,&user_page_end,NULL,NULL);
				// read the page with the serial number
				Cmd_Insert(CMD_READ_PAGE,sn_buffer,&sn_page_start,&sn_page_end,NULL,NULL);
				// next queue a datalog read
				Cmd_Insert(CMD_READ_PAGE,buffer,&page_start,&page_end,&page_processed,&read_page_status);
				read_datalog = false;
				force_plot_refresh = false;
			}
		}
		// if a read is queued then show progress
		if (read_page_status == STATUS_QUEUED) {
			if (page_processed != -1) {
				m_DataLog_Progress.SetPos((page_processed - 128) + 1);
			} else {
				m_DataLog_Progress.SetPos(0);
			}
		}
		if (read_page_status == STATUS_DONE) {
			    read_page_status = STATUS_IDLE;
				m_DataLog_Progress.SetPos(0);

			// PRINT STUFF BEGIN	
		

			// setup print info in-case the user wants to print the plot
				unsigned long current;
				current = DS1615BufferToCurrentSample(page0_buffer);
				PrintInfo.missionsamples = current;
				DS1615BufferToTimeStamp(page0_buffer,&PrintInfo.timestamp);
				PrintInfo.totalsamples = DS1615BufferToTotalSamples(page0_buffer);
				DS1615BufferToCurrentTime(page0_buffer,&PrintInfo.currenttime);	
			// get alarm info for printout
				if (page0_buffer[0x14] & 0x04)
					PrintInfo.alarm_lo = true;
				else
					PrintInfo.alarm_lo = false;
				if (page0_buffer[0x14] & 0x02)
					PrintInfo.alarm_hi = true;
				else
					PrintInfo.alarm_hi = false;

			// get threshold hi / lo info for printout
				float temp1,temp2,f1;
				f1 = (float)page0_buffer[0x0B];
				temp1 = ((float)0.5 * (float)f1) - (float)40.0;
				temp2 = ((float)1.8 * (float)temp1) + (float)32.0;
				sprintf(PrintInfo.threshold_lo,"%.1fC / %.1fF",temp1,temp2);
				f1 = (float)page0_buffer[0x0C];
				temp1 = ((float)0.5 * (float)f1) - (float)40.0;
				temp2 = ((float)1.8 * (float)temp1) + (float)32.0;
				sprintf(PrintInfo.threshold_hi,"%.1fC / %.1fF",temp1,temp2);

		    // get sample rate info
				PrintInfo.sample_rate = DS1615BufferToSampleRate(page0_buffer);
				sprintf(str,"Samples (Sample Rate = %-3d min)",PrintInfo.sample_rate);
				m_OScopeCtrl.SetXUnits(str) ;
			// make sure the user string data is zero-terminated
				PrintInfo.usermemory_string[32] = 0;
			// clear out info incase it doesn't get filled in later
				strcpy(PrintInfo.cursor_temperature,"");
				strcpy(PrintInfo.cursor_datetime,"");
				strcpy(PrintInfo.start_datetime,"");
				strcpy(PrintInfo.end_datetime,"");

			// get the serial number
				char temp[8];
				PrintInfo.serialnumber[0] = 0;
				for (int s = 0; s < 8; s++) {
					sprintf(temp,"%02X ",sn_buffer[24 + s]);
					strcat(PrintInfo.serialnumber,temp);
				}
				sprintf(str,"Serial Number: %s",PrintInfo.serialnumber);
				GetDlgItem(IDC_STATIC_SERIAL_NUMBER)->SetWindowText(str);

//				if (PrintInfo.missionsamples < 2) 
//					goto abort_graphing;


			// set axis label to F or C
				if (temp_scale == 'F')
					m_OScopeCtrl.SetYUnits("Temperature (F)") ;
				else
					m_OScopeCtrl.SetYUnits("Temperature (C)") ;
				if (m_OScopeCtrl.GetGraphUnits() == VOLTAGE)
					m_OScopeCtrl.SetYUnits("Voltage (V)") ;
			// display datalog
				unsigned long i;
				m_OScopeCtrl.DeletePoints();
			// DS1615_Read_Datalog(DataLog_Data);
				current = DS1615BufferToCurrentSample(page0_buffer);


				m_OScopeCtrl.SetXAxisOffset(0);

				// the indice into the channel_size array is the number of channels
				//   active
				int channel_size[5] = {
					0,
					2048,
					1024,
					512,
					512
				};
				// the indice into the channel_offset array is the number of channels
				//   active
				int channel_offset[5] = {
					0,
					1,
					2,
					4,
					4
				};
				int number_of_channels_active = 0;
				int CS0_enable = 0;
				int CS1_enable = 0;
				int CS2_enable = 0;
				int CS3_enable = 0;
				if ((buffer1[0x09] & 0x40) == 0x40) { 
					CS0_enable = 1; 
					number_of_channels_active++; 
					GetDlgItem(IDC_CS0)->EnableWindow(TRUE);
				} else GetDlgItem(IDC_CS0)->EnableWindow(FALSE);
				if ((buffer1[0x09] & 0x20) == 0x20) { 
					CS1_enable = 1; 
					number_of_channels_active++; 
					GetDlgItem(IDC_CS1)->EnableWindow(TRUE);
				} else GetDlgItem(IDC_CS1)->EnableWindow(FALSE);			
				if ((buffer1[0x09] & 0x10) == 0x10) { 
					CS2_enable = 1; 
					number_of_channels_active++; 
					GetDlgItem(IDC_CS2)->EnableWindow(TRUE);
				} else GetDlgItem(IDC_CS2)->EnableWindow(FALSE);			
				if ((buffer1[0x09] & 0x08) == 0x08) { 
					CS3_enable = 1; 
					number_of_channels_active++; 
					GetDlgItem(IDC_CS3)->EnableWindow(TRUE);
				} else GetDlgItem(IDC_CS3)->EnableWindow(FALSE);			
				int slot = 0;
	
//				if (number_of_channels_active == 1) channel = 0;
//				if (number_of_channels_active == 2) channel = 0;
				switch (CS0_enable + CS1_enable + CS2_enable + CS3_enable) {
					case 0: return; // should not get here
					case 1: slot = 0; break;
					case 2: if (IsDlgButtonChecked(IDC_CS0)) {
								slot = 0;
							}
							if (IsDlgButtonChecked(IDC_CS1)) {
								slot = 0;
								if (CS0_enable == 1) slot = 1;
							}
							if (IsDlgButtonChecked(IDC_CS2)) {
								slot = 0;
								if (CS0_enable == 1) slot = 1;
								if (CS1_enable == 1) slot = 1;
							}
							if (IsDlgButtonChecked(IDC_CS3)) {
								slot = 1;
							}
							break;
					case 3: if (IsDlgButtonChecked(IDC_CS0)) {
								slot = 0;
							}
							if (IsDlgButtonChecked(IDC_CS1)) {
								slot = 0;
								if (CS0_enable == 1) slot = 1;
							}
							if (IsDlgButtonChecked(IDC_CS2)) {
								slot = 1;
								if ((CS0_enable == 1) && (CS1_enable == 1)) slot = 2;
							}
							if (IsDlgButtonChecked(IDC_CS3)) {
								slot = 2;
							}
							break;
					case 4: if (IsDlgButtonChecked(IDC_CS0)) slot = 0;
						if (IsDlgButtonChecked(IDC_CS1)) slot = 1;
						if (IsDlgButtonChecked(IDC_CS2)) slot = 2;
						if (IsDlgButtonChecked(IDC_CS3)) slot = 3;
						break;
				}
				
				
				//
				// account for roll-over it needed
				//
				
				PrintInfo.rollover = AccountForRollOver(page0_buffer,buffer,number_of_channels_active,channel_size[number_of_channels_active]);
				// check if time needs to be offset because of rollover;
				int csample = DS1615BufferToCurrentSample(page0_buffer);
				rollover_offset = 0;
				if ((csample > channel_size[number_of_channels_active]) && ((page0_buffer[0x0E] & 0x08) == 0x08)) {
					// if we got to this point then samples is greater than 2048 and the roll-over bit is set
					//ldiv_t div_result;					
					//div_result = ldiv(samples, (long)channel_size);
					//rollover_offset = (int)(div_result.quot * (long)channel_size);
					rollover_offset = csample - channel_size[number_of_channels_active];
				}				
				m_OScopeCtrl.SetXAxisOffset(rollover_offset);
//				sprintf(str,"%lu",rollover_offset);
//				AfxMessageBox(str);








				for (i = 0; i < channel_size[number_of_channels_active]; i++) {
					DataLog_Data[i] = (unsigned int)buffer[i * channel_offset[number_of_channels_active]+slot];
					degrees = ((double)0.5 * (double)DataLog_Data[i]) - (double)40.0;
					if (temp_scale == 'F')
						degrees = ((double)1.8 * (double)degrees) + (double)32.0;
				    if (m_OScopeCtrl.GetGraphUnits() == VOLTAGE)
					  degrees = DataLog_Data[i] * 0.008;
					if (i < current)
					  m_OScopeCtrl.AddPoint(degrees);
				}

				// get the hi/lo thresholds and send them to the grapher
				float hi,lo;
				lo = (float)page0_buffer[0x0B];
				lo = ((float)0.5 * (float)lo) - (float)40.0;
				hi = (float)page0_buffer[0x0C];
				hi = ((float)0.5 * (float)hi) - (float)40.0;
				if (temp_scale == 'F') {
					hi = ((double)1.8 * (double)hi) + (double)32.0;
					lo = ((double)1.8 * (double)lo) + (double)32.0;
				}
				m_OScopeCtrl.SetHiThreshold(hi);
				m_OScopeCtrl.SetLoThreshold(lo);

				m_OScopeCtrl.AppendPoint(i);

				double ymax;
				double ymin;
				if (current) {
					ymax = m_OScopeCtrl.FindMaxY();
					ymin = m_OScopeCtrl.FindMinY();
				} else {
					ymax = 0.0;
					ymin = 0.0;
				}
				//if (m_OScopeCtrl.GetGraphUnits() == VOLTAGE) temp_scale = 'V';
				//  else
				if (PrintInfo.missionsamples > 2) { 
					if (m_OScopeCtrl.GetGraphUnits() == TEMPERATURE)
					  sprintf(str,"Highest: %3.1f %c",ymax,temp_scale);
					else
					  sprintf(str,"Highest: %3.1f %c",ymax,'V');
					GetDlgItem(IDC_TEXT_HI)->SetWindowText(str);
					strcpy(PrintInfo.range_highest,str);
					if (m_OScopeCtrl.GetGraphUnits() == TEMPERATURE)
					  sprintf(str,"Lowest: %3.1f %c",ymin,temp_scale);
					else
					  sprintf(str,"Lowest: %3.1f %c",ymin,'V');
					GetDlgItem(IDC_TEXT_LO)->SetWindowText(str);
					strcpy(PrintInfo.range_lowest,str);
				}
				else{
					sprintf(str,"Highest: --.- %c",' ');
					GetDlgItem(IDC_TEXT_HI)->SetWindowText(str);
					sprintf(str,"Lowest: --.- %c",' ');
					GetDlgItem(IDC_TEXT_LO)->SetWindowText(str);
				}
	
				// now that data is downloaded check to see if we should save the file
				if (bsave_file) {
					FILE *outfile;
					SYSTEMTIME stamp;
					CString field1,field2,field3,field4,
							field5,field6,field7,field8,field9,fields;

					int samples = 2048;
					if (DS1615BufferToCurrentSample(page0_buffer) < 2048) 
						samples = DS1615BufferToCurrentSample(page0_buffer);

					if (samples == 0){
						bsave_file = false;
						read_datalog = false;
						MessageBox("No Data to Save.","Save Datalog");
						goto abort_graphing;
					}					
					
					field1.Format(_T("%d,"),samples);
					field2.Format(_T("%d,"),DS1615BufferToSampleRate(page0_buffer));
					DS1615BufferToTimeStamp(page0_buffer,&stamp);
					field3.Format(_T("%02d/%02d/%02d %02d:%02d,"),	stamp.wMonth, stamp.wDay,  stamp.wYear, 
												stamp.wHour, stamp.wMinute);
					field4.Format(_T("%2.1f,"),lo);
					field5.Format(_T("%2.1f,"),hi);
					field6.Format(_T("%s,"),(page0_buffer[0x14] & 0x04)?"1":"0");
					field7.Format(_T("%s,"),(page0_buffer[0x14] & 0x02)?"1":"0");
					if (IsDlgButtonChecked(IDC_CS0))   // check if temperature is checked
						field8.Format(_T("%c,"),temp_scale);
					else {
						if (g_bSaveAsVoltage)
							field8.Format(_T("%s,"),"Volts (2.04V ref. typ)");
						else
							field8.Format(_T("%s,"),"Raw A->D Value");
					}
					field9 = PrintInfo.usermemory_string;
					fields =	field1 + field2 + field3 + field4 + field5 + 
								field6 + field7 + field8 + field9 + "\n";
					outfile = fopen(filename,"wt");
					if (outfile == NULL) {
						MessageBox("Error: Can't open outfile","Save Datalog");
						goto abort_graphing;				
					}
					fputs((LPCTSTR)fields,outfile);
					// write datalog fields
					int hour24to12[24] = { 12,1,2,3,4,5,6,7,8,9,10,11,12,1,2,3,4,5,6,7,8,9,10,11 };
					float temperature;
					COleDateTimeSpan date;
					int log_count = samples;
					if (log_count > channel_size[number_of_channels_active]) 
						log_count = channel_size[number_of_channels_active];
					for (i = 0; i < log_count; i++) {
						DS1615BufferToTimeStamp(page0_buffer,&stamp);
						COleDateTime start(stamp.wYear, stamp.wMonth,  stamp.wDay, 
						stamp.wHour, stamp.wMinute, stamp.wSecond );
						date = TicksToSpan(MIN,(long)i * (long)DS1615BufferToSampleRate(page0_buffer) + (long)rollover_offset * (long)DS1615BufferToSampleRate(page0_buffer));
						start = start + date;
						sprintf( str, "%02lu/%02lu/%lu %02lu:%02lu, ", start.GetMonth(),start.GetDay(),start.GetYear(),start.GetHour(),start.GetMinute());
						fputs(str,outfile);
						// now write temperature value
						if (IsDlgButtonChecked(IDC_CS0)) {  // check if temperature is checked
							temperature = (float)DataLog_Data[i];
							temperature = ((float)0.5 * (float)temperature) - (float)40.0;
							if (temp_scale == 'F')
								temperature = ((float)1.8 * (float)temperature) + (float)32.0;
							fprintf(outfile,"%2.1f\n",temperature);
						} else {
							if (g_bSaveAsVoltage)
								fprintf(outfile,"%1.3f\n",(int)DataLog_Data[i] * 0.008);
							else
								fprintf(outfile,"%d\n",(int)DataLog_Data[i]);
						}
					}

					fclose(outfile);
					bsave_file = false;
					read_datalog = false;
					strcat(filename," Saved.");
					MessageBox(filename,"Save Datalog");
//					, stamp.wMonth,  stamp.wDay, 
//				   stamp.wHour, stamp.wMinute, stamp.wSecond
//					SaveDatalog(filename,page0_buffer,buffer,(long)current,temp_scale);
				}
abort_graphing:
			read_datalog = false;
		}

		if (PrintInfo.missionsamples > 1){ 
			if (m_OScopeCtrl.IsPointInfo) {
				//m_OScopeCtrl.IsPointInfo = false;
				if (m_OScopeCtrl.GetGraphUnits() == TEMPERATURE) 
				  sprintf(str,"Temp: %3.1f %c",m_OScopeCtrl.value,temp_scale);
				else
				  sprintf(str,"Voltage: %3.3f %c",m_OScopeCtrl.value,'V');
				GetDlgItem(IDC_TEXT_TEMPERATURE)->SetWindowText(str);
				strcpy(PrintInfo.cursor_temperature,str);

				// figure out relative date and time for this data index
				COleDateTimeSpan date;
				SYSTEMTIME stamp;
				DS1615BufferToTimeStamp(page0_buffer,&stamp);
				COleDateTime start(stamp.wYear, stamp.wMonth,  stamp.wDay, 
				   stamp.wHour, stamp.wMinute, stamp.wSecond );
//				sprintf(str,"cursor %lu",rollover_offset);
//				AfxMessageBox(str);
				date = TicksToSpan(MIN,(long)m_OScopeCtrl.index * (long)DS1615BufferToSampleRate(page0_buffer) + (long)rollover_offset * (long)DS1615BufferToSampleRate(page0_buffer));
				start = start + date;
				int hour24to12[24] = { 12,1,2,3,4,5,6,7,8,9,10,11,12,1,2,3,4,5,6,7,8,9,10,11 };
				sprintf( str, "Date Time: %02lu/%02lu/%lu %02lu:%02lu:%02lu%s", start.GetMonth(),start.GetDay(),start.GetYear(),hour24to12[start.GetHour()],start.GetMinute(),start.GetSecond(),(start.GetHour()<12)?"am":"pm");
				// sprintf(str,"%d",m_OScopeCtrl.index);
                PrintInfo.cursor_sample = (long)m_OScopeCtrl.index + 1 + (long)rollover_offset;
				GetDlgItem(IDC_TEXT_TIME)->SetWindowText(str);
				strcpy(PrintInfo.cursor_datetime,str);
				sprintf(str,"Sample: %-6lu",PrintInfo.cursor_sample);
				GetDlgItem(IDC_STATIC_SAMPLE)->SetWindowText(str);
//new stuff
					// figure out relative date and time for this data index

					DS1615BufferToTimeStamp(page0_buffer,&stamp);
					COleDateTime start1(stamp.wYear, stamp.wMonth,  stamp.wDay, 
					   stamp.wHour, stamp.wMinute, stamp.wSecond );
					date = TicksToSpan(MIN,(long)m_OScopeCtrl.line_info_datalog[0].index * (long)DS1615BufferToSampleRate(page0_buffer) + (long)rollover_offset * (long)DS1615BufferToSampleRate(page0_buffer));
					start1 = start1 + date;
					sprintf( str, "Start: %02lu/%02lu/%lu %02lu:%02lu:%02lu%s  ", start1.GetMonth(),start1.GetDay(),start1.GetYear(),hour24to12[start1.GetHour()],start1.GetMinute(),start1.GetSecond(),(start1.GetHour()<12)?"am":"pm");
					strcpy(PrintInfo.start_datetime,&str[7]);

					// figure out relative date and time for this data index

					DS1615BufferToTimeStamp(page0_buffer,&stamp);
					COleDateTime start2(stamp.wYear, stamp.wMonth,  stamp.wDay, 
					   stamp.wHour, stamp.wMinute, stamp.wSecond );
					date = TicksToSpan(MIN,(long)m_OScopeCtrl.line_info_datalog[m_OScopeCtrl.line_info_points_datalog - 1].index * (long)DS1615BufferToSampleRate(page0_buffer) + (long)rollover_offset * (long)DS1615BufferToSampleRate(page0_buffer));
					start2 = start2 + date;
					sprintf( str2, "End: %02lu/%02lu/%lu %02lu:%02lu:%02lu%s", start2.GetMonth(),start2.GetDay(),start2.GetYear(),hour24to12[start2.GetHour()],start2.GetMinute(),start2.GetSecond(),(start2.GetHour()<12)?"am":"pm");
					strcpy(PrintInfo.end_datetime,&str2[5]);
                    strcat(str,str2);
					GetDlgItem(IDC_STATIC_START_END)->SetWindowText(str);
// end new stuff
			}
		}
		else{
			sprintf(str,"Start: --/--/-- --:----  End: --/--/-- --:----");
			GetDlgItem(IDC_STATIC_START_END)->SetWindowText(str);
			sprintf(str,"Sample: ----");
			GetDlgItem(IDC_STATIC_SAMPLE)->SetWindowText(str);
			sprintf(str,"Temp: --.- %c",temp_scale);
			GetDlgItem(IDC_TEXT_TEMPERATURE)->SetWindowText(str);
			sprintf( str, "Date Time: --/--/---- --:--:----");
			// sprintf(str,"%d",m_OScopeCtrl.index);
			GetDlgItem(IDC_TEXT_TIME)->SetWindowText(str);
		}
}



void CPageEightDialog::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if (nIDEvent == CLOCK_UPDATE_TIMER_ID) {
		if (TStackedPage::IsPageActive()) {
			Debug.Printf1("Page5 tick");
			#ifdef _DEBUG
			   _CrtDbgReport(_CRT_WARN,"rPageOneDialog.cpp",__LINE__,"Demo",":  %s\n","timer page five");
			#endif

				   if ((!suspend_timers) && (!suspend_due_to_error))
						Refresh();
//			}
		}
	}
	
	TStackedPage::OnTimer(nIDEvent);
}

void CPageEightDialog::SaveDatalog(char *filename,unsigned char *buffer,unsigned char *log_buffer,long samples,char temp_scale) {
	int samprate,temp,roll,offset=0;
	int TLF,THF;
	FILE *outfile;
	float degrees,tlow,thigh;
	char str[33];
	long i,fsample = 0;;
	ldiv_t div_result;
////	if (1) {
////		save_opened = 1;
//		length = number_of_points;
////		length = GetDataNum();
////		get_filename(filename);
////		if (!savedatalog)
////		{
////			save_opened = 0;
////			goto graph;
//			return;
////		}
		outfile = fopen(filename,"wt");
//		fprintf(outfile,"%d\n",length);

////	samples = DS1615_Get_Current_Sample();
	
////    Read_RTC_Page(buffer);

	roll = buffer[0x0E] & 0x08;

	sprintf(str,"%02X/%02X/%02X %02X:%02X",
			  (int)buffer[0x18],
			  (int)buffer[0x17],
			  (int)buffer[0x19],
			  (int)buffer[0x16],
			  (int)buffer[0x15]);

	samprate = int(buffer[0x0d]);
	temp = int(buffer[0x0b]);
	degrees = ((float)0.5 * (float)temp) - (float)40.0;
	if (temp_scale == 'F')
		degrees = ((float)1.8 * (float)degrees) + (float)32.0;
	tlow = degrees;
	temp = int(buffer[0x0c]);
	degrees = ((float)0.5 * (float)temp) - (float)40.0;
	if (temp_scale == 'F')
		degrees = ((float)1.8 * (float)degrees) + (float)32.0;
	thigh = degrees;
	TLF = (buffer[0x14] & 0x04) >> 2;
	THF = (buffer[0x14] & 0x02) >> 1;

	for (i=0; i<33; i++)
		buffer[i] = NULL;

//	Read_Page(2,buffer);

	// check if the ro bit is set and the number of samples is greater than 2048
	if (samples > 2048 && roll == 0x08)
	{
		fsample = samples - long(2048);
		div_result = ldiv(samples, (long)2048);
		offset = (int)(samples - (div_result.quot * (long)2048));
	}
	unsigned int data;
		if (samples <= 2048 || roll != 0x08)
		{
			if (samples > 2048 && roll != 0x08)
				samples = 2048;

			fprintf(outfile,"%ld, %d, %s, %.1f, %.1f, %d, %d, %c\n",samples,samprate,str,tlow,thigh,TLF,THF,temp_scale);
			for(i = fsample; i < samples; i++)
			{
					data = (unsigned int)log_buffer[i];
					degrees = ((double)0.5 * (double)data) - (double)40.0;
					if (temp_scale == 'F')
						degrees = ((double)1.8 * (double)degrees) + (double)32.0;

			  //dat = GetDataAt(i);
			  //degrees = ((float)0.5 * (float)dat) - (float)40.0;
			  //if (temp_scale == 'F')
			  //  degrees = ((float)1.8 * (float)degrees) + (float)32.0;
			  fprintf(outfile,"%ld, %.1f\n",i+1,degrees);
			}
		}
		else
		{
			samples = 2048;
			fprintf(outfile,"%ld, %d, %s, %.1f, %.1f, %d, %d, %c, %s\n",samples,samprate,str,tlow,thigh,TLF,THF,temp_scale,buffer);

			for(i = offset; i < samples; i++)
			{
					data = (unsigned int)log_buffer[i];
					degrees = ((double)0.5 * (double)data) - (double)40.0;
					if (temp_scale == 'F')
						degrees = ((double)1.8 * (double)degrees) + (double)32.0;
			  fprintf(outfile,"%ld, %.1f\n",fsample++,degrees);
			}
			for(i = 0; i <= offset; i++)
			{
					data = (unsigned int)log_buffer[i];
					degrees = ((double)0.5 * (double)data) - (double)40.0;
					if (temp_scale == 'F')
						degrees = ((double)1.8 * (double)degrees) + (double)32.0;
			  fprintf(outfile,"%ld, %.1f\n",fsample++,degrees);
			}
		}
	fclose(outfile);
}



bool CPageEightDialog::AccountForRollOver(unsigned char *buffer,unsigned char *log_buffer,int num_of_channels,int channel_size) {
	int roll,offset=0,offset2;
	long i,fsample = 0;;
	ldiv_t div_result;
	static unsigned char sorted_buffer[3000];
	int sorted_buffer_index = 0;

	roll = buffer[0x0E] & 0x08;

	// check if the ro bit is set and the number of samples is greater than 2048
	long samples;
	samples = DS1615BufferToCurrentSample(buffer);
	// if the number of samples is less than or equal to 2048 then return (no sorting needed)
	if (samples <= channel_size) return false;
	// if the roll-over bit is not set then return (no sorting needed)
	if (roll != 0x08) return false;

	// if we got to this point then samples is greater than channel_size and the roll-over bit is set
//	fsample = samples - long(2048);
	div_result = ldiv(samples, (long)channel_size);
	offset = (int)(samples - (div_result.quot * (long)channel_size));

	if (num_of_channels == 3) num_of_channels = 4;
	offset2 = offset * num_of_channels;

	sorted_buffer_index = 0;

	for(i = offset2; i < 2048; i++) {
		sorted_buffer[sorted_buffer_index++] = log_buffer[i];
	}
	for(i = 0; i <= offset2; i++) {
		sorted_buffer[sorted_buffer_index++] = log_buffer[i];
	}

	// now copy the new sorted array to the original array
	for(i = 0; i < 2048; i++) {
		log_buffer[i] = sorted_buffer[i];
	}
	return true;  // return true, rollover present and accounted for
}


void CPageEightDialog::OnButtonDegreeC() 
{
	// TODO: Add your control notification handler code here
	temp_scale = 'C';
	m_OScopeCtrl.SetC();	
	read_datalog = true;
//	m_OScopeCtrl.RePaint();	
}

void CPageEightDialog::OnButtonDegreeF() 
{
	// TODO: Add your control notification handler code here
	temp_scale = 'F';
	m_OScopeCtrl.SetF();	
	read_datalog = true;
//	m_OScopeCtrl.RePaint();	
}

void CPageEightDialog::OnButtonFilesave() 
{
	// TODO: Add your control notification handler code here

	if (GetFilename(filename,"Save The Device Data File","Datalog.txt","Text files *.txt\0*.dat\0All Files *.*\0*.*\0\0","txt")
		== -1) return;
	if (!IsDlgButtonChecked(IDC_CS0)) {  // check if temperature is checked
		int result = AfxMessageBox("Save A->D as Voltage (Y) or Save as Raw Value (No)",MB_YESNO);
		if (result == IDYES) g_bSaveAsVoltage = true;
			else g_bSaveAsVoltage = false;
	}

	read_datalog = true;
	bsave_file = true;

}

void CPageEightDialog::OnPrint() 
{
	// TODO: Add your control notification handler code here
  CString PrintString[128];
  int     PrintStringNum;
	
	bool b_print_information = true;

	CPrintInformation dlg2;
	int nResponse = dlg2.DoModal();
	if (nResponse == IDCANCEL)
	{
		b_print_information = false;
	}

	CPrintDlg dlg;
	nResponse = dlg.DoModal();
	if (nResponse == IDCANCEL)
	{
		return;
	}

	bool tabulated_output = dlg.b_printtabulated;
	m_OScopeCtrl.print_graph = dlg.b_printgraph;

	char str[256];
	char str2[256];
	SYSTEMTIME time;
	int hour24to12[24] = { 12,1,2,3,4,5,6,7,8,9,10,11,12,1,2,3,4,5,6,7,8,9,10,11 };

/*			// setup print info in-case the user wants to print the plot
				PrintInfo.missionsamples = current;
				DS1615BufferToTimeStamp(page0_buffer,&PrintInfo.timestamp);
				PrintInfo.totalsamples = DS1615BufferToTotalSamples(page0_buffer);
				DS1615BufferToCurrentTime(page0_buffer,&PrintInfo.currenttime);	
				strcpy(PrintInfo.serialnumber,"00 00 00 00 00 00 00");*/

	// first string is the title of the plot
	PrintStringNum = 0;
	m_OScopeCtrl.TitleStr = dlg.title;

	PrintString[PrintStringNum++] = "";
	PrintString[PrintStringNum++] = "*** Device Temperature DataLog ***";
//	PrintString[PrintStringNum++] = "";


    if (dlg.b_samplenum || dlg.b_sn || dlg.b_stamp || dlg.b_time || dlg.b_usermemory || dlg.b_samplerate
		|| dlg.b_cursorinfo || dlg.b_alarminfo || dlg.b_highestlowest || dlg.b_rollover) {
//		PrintString[PrintStringNum++] = " ";
		PrintString[PrintStringNum++] = "===================================================================================================";
		PrintString[PrintStringNum++] = "Device Status Information:";
		PrintString[PrintStringNum++] = " ";
	}

	if (dlg.b_samplenum) {
		sprintf(str,"Number of Mission Samples: %lu",PrintInfo.missionsamples);
		PrintString[PrintStringNum++] = str;
	}

	if (dlg.b_sn) {
		sprintf(str,"Serial Number: [%s]",PrintInfo.serialnumber);
		PrintString[PrintStringNum++] = str;
	}

	if (dlg.b_stamp) {
		time = PrintInfo.timestamp;
		sprintf( str, "Date Time of First Sample: %02lu/%02lu/%lu %02lu:%02lu:%02lu%s", time.wMonth,time.wDay,time.wYear,
			hour24to12[time.wHour],time.wMinute,time.wSecond,(time.wHour<12)?"am":"pm");
		PrintString[PrintStringNum++] = str;
	}

	if (dlg.b_time) {
		time = PrintInfo.currenttime;
		sprintf( str, "Current Date Time of Device: %02lu/%02lu/%lu %02lu:%02lu:%02lu%s", time.wMonth,time.wDay,time.wYear,
			hour24to12[time.wHour],time.wMinute,time.wSecond,(time.wHour<12)?"am":"pm");
		PrintString[PrintStringNum++] = str;
	}

	if (dlg.b_usermemory) {
		sprintf( str, "User Memory: \"%s\"", PrintInfo.usermemory_string);
		PrintString[PrintStringNum++] = str;
	}

	if (dlg.b_samplerate) {
		sprintf( str, "Sample Rate (mins): %lu", PrintInfo.sample_rate);
		PrintString[PrintStringNum++] = str;
	}

	if (dlg.b_cursorinfo) {
		sprintf( str, "Cursor Sample: %-6lu", PrintInfo.cursor_sample);
		PrintString[PrintStringNum++] = str;
		sprintf( str, "Start Date Time: %s  End Date Time: %s", PrintInfo.start_datetime, PrintInfo.end_datetime);
		PrintString[PrintStringNum++] = str;
		sprintf( str, "Cursor Date Time: %s", &PrintInfo.cursor_datetime[10]);
		PrintString[PrintStringNum++] = str;
		sprintf( str, "Cursor Temperature: %s", &PrintInfo.cursor_temperature[6]);
		PrintString[PrintStringNum++] = str;
	}

	if (dlg.b_alarminfo) {
		sprintf( str, "Alarm Threshold Low: %s", PrintInfo.threshold_lo);
		sprintf( str2, "   Alarm Threshold Hi : %s", PrintInfo.threshold_hi);
		strcat(str,str2);
		PrintString[PrintStringNum++] = str;
		sprintf( str, "Alarm Hi / Lo: %s / %s", PrintInfo.alarm_hi ? "Set" : "Clear", PrintInfo.alarm_lo ? "Set" : "Clear");
		PrintString[PrintStringNum++] = str;
	}

	if (dlg.b_highestlowest) {		
		sprintf( str, "Value in plot, %s %s", PrintInfo.range_highest, PrintInfo.range_lowest);
		PrintString[PrintStringNum++] = str;
	}

	if (dlg.b_rollover) {
		sprintf( str, "Rollover Occured: %s", PrintInfo.rollover ? "Yes" : "No");
		PrintString[PrintStringNum++] = str;
	}

	if (b_print_information) {
//		PrintString[PrintStringNum++] = " ";
		PrintString[PrintStringNum++] = "===================================================================================================";
		PrintString[PrintStringNum++] = "HACCP Reporting Information:";
		PrintString[PrintStringNum++] = " ";
		PrintString[PrintStringNum++] = "Name of processor or importer: " + dlg2.field1;
		PrintString[PrintStringNum++] = "Location of processor or importer: " + dlg2.field2;
		PrintString[PrintStringNum++] = "Description of product: " + dlg2.field3;
		PrintString[PrintStringNum++] = "Production code: " + dlg2.field4;
		PrintString[PrintStringNum++] = "Corrective action or notes: " + dlg2.field5;
		PrintString[PrintStringNum++] = " ";
		PrintString[PrintStringNum++] = " ";
		PrintString[PrintStringNum++] = "Signature:    __________________________________  Date: ______________";
	}
	else {
		PrintString[PrintStringNum++] = "===================================================================================================";
	}

	if (tabulated_output) {
		PrintString[PrintStringNum++] = " ";
		PrintString[PrintStringNum++] = "===================================================================================================";
		PrintString[PrintStringNum++] = "Tabulated Temperature Data:";
		PrintString[PrintStringNum++] = " ";
		PrintString[PrintStringNum++] = "Sample              Date - Time             Temperature";
		PrintString[PrintStringNum++] = " ";
	}


	// if tabulated output then assemble the info
	int i;
	int index_min = 0; //m_OScopeCtrl.GetMinRange();
	int index_max = 5; //m_OScopeCtrl.GetMaxRange();
	m_OScopeCtrl.lhead = NULL;
	s_printstrings slink,*newlink;
	newlink = &slink;
	// create a link list of the tabulated output

	for (i = 0; i < PrintStringNum;i++) {
		newlink->next = (s_printstrings *) new s_printstrings;
		if (m_OScopeCtrl.lhead == NULL) {
			m_OScopeCtrl.lhead = newlink->next;
		}
		newlink = newlink->next;
		newlink->cstr = (CString *) new CString;

		*newlink->cstr = PrintString[i];
		newlink->next = NULL;
	}

	if (tabulated_output) {
		for (i = 0; i < m_OScopeCtrl.line_info_points_datalog;i++) {
			newlink->next = (s_printstrings *) new s_printstrings;
			if (m_OScopeCtrl.lhead == NULL) {
				m_OScopeCtrl.lhead = newlink->next;
			}
			newlink = newlink->next;
			newlink->cstr = (CString *) new CString;

					// figure out relative date and time for this data index
					COleDateTimeSpan date;
					SYSTEMTIME stamp;
					DS1615BufferToTimeStamp(page0_buffer,&stamp);
					COleDateTime start(stamp.wYear, stamp.wMonth,  stamp.wDay, 
					   stamp.wHour, stamp.wMinute, stamp.wSecond );
	//				sprintf(str,"cursor %lu",rollover_offset);
	//				AfxMessageBox(str);
					date = TicksToSpan(MIN,(long)m_OScopeCtrl.line_info_datalog[i].index * (long)DS1615BufferToSampleRate(page0_buffer) + (long)rollover_offset * (long)DS1615BufferToSampleRate(page0_buffer));
					start = start + date;
					int hour24to12[24] = { 12,1,2,3,4,5,6,7,8,9,10,11,12,1,2,3,4,5,6,7,8,9,10,11 };
                    char marker;
					long cursamp = (long)m_OScopeCtrl.line_info_datalog[i].index + 1 + (long)rollover_offset;
                    if (cursamp == PrintInfo.cursor_sample && dlg.b_cursorinfo)
						marker = '*';
					else
						marker = 0x00;
					sprintf( str, "%06lu    %02lu/%02lu/%lu - %02lu:%02lu:%02lu%s",cursamp,start.GetMonth(),start.GetDay(),start.GetYear(),hour24to12[start.GetHour()],start.GetMinute(),start.GetSecond(),(start.GetHour()<12)?"am":"pm");


			sprintf(str2,"    %3.1f %c  %c",m_OScopeCtrl.line_info_datalog[i].value,temp_scale,marker);
			strcat(str,str2);

			*newlink->cstr = str;
			newlink->next = NULL;
		}
	}


	m_OScopeCtrl.PrintGraph();
}



void CPageEightDialog::OnButtonPrint() 
{
	// TODO: Add your control notification handler code here
	OnPrint();
}

static b_displayticks = false;

void CPageEightDialog::OnButtonTicks() 
{
	// TODO: Add your control notification handler code here
	if (b_displayticks) b_displayticks = false;
		else b_displayticks = true;
	m_OScopeCtrl.DisplayTicks(b_displayticks);
}




void CPageEightDialog::OnButtonZoomin() 
{
	// TODO: Add your control notification handler code here
	m_OScopeCtrl.Zoomin();
	UpdatePlotMinMax();
}

void CPageEightDialog::OnButtonZoomout() 
{
	// TODO: Add your control notification handler code here
	m_OScopeCtrl.Zoomout();
	UpdatePlotMinMax();
}

void CPageEightDialog::OnButtonZoomall() 
{
	// TODO: Add your control notification handler code here
	m_OScopeCtrl.Zoomall();
	UpdatePlotMinMax();
}

void CPageEightDialog::OnButtonZoomallthresholds() 
{
	// TODO: Add your control notification handler code here
	m_OScopeCtrl.Zoomall_Thresholds();
	UpdatePlotMinMax();
}

void CPageEightDialog::OnCs0() 
{
	read_datalog = true;
	m_OScopeCtrl.SetGraphUnits(TEMPERATURE);
}

void CPageEightDialog::OnCs1() 
{
	read_datalog = true;
	m_OScopeCtrl.SetGraphUnits(VOLTAGE);
}

void CPageEightDialog::OnCs2() 
{
	read_datalog = true;
	m_OScopeCtrl.SetGraphUnits(VOLTAGE);
}

void CPageEightDialog::OnCs3() 
{
	read_datalog = true;
	m_OScopeCtrl.SetGraphUnits(VOLTAGE);
}
