/*
  This Evaluation kit software is available free of charge and can be used,
  edited, or reproduced as you see fit. Dallas Semiconductor does not
  assume any liability for the accuracy or correctness of this code.

  It is free to use at your own risk.
  */
#if !defined(AFX_PageEightDialog_H__473BDB06_B52B_11D3_9C20_00E09803BB79__INCLUDED_)
#define AFX_PageEightDialog_H__473BDB06_B52B_11D3_9C20_00E09803BB79__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PageEightDialog.h : header file
//
#include "GraphCtrl.h"
#include "Sxbutton - updated.h"

/////////////////////////////////////////////////////////////////////////////
// CPageEightDialog dialog

class CPageEightDialog : public TStackedPage
{
// Construction
public:
	CPageEightDialog(CWnd* pParent = NULL);   // standard constructor
	void Refresh();
	CIconButton	m_button_degree_c; 
	CIconButton	m_button_degree_f; 
	CIconButton	m_button_savefile; 
	CIconButton	m_button_print; 
	CIconButton	m_button_ticks; 
	CIconButton	m_button_zoomin; 
	CIconButton	m_button_zoomout; 
	CIconButton	m_button_zoomall; 
	CIconButton	m_button_zoomallthreshold; 
	void OnSetActive(void);

	void SaveDatalog(char *filename,unsigned char *buffer,unsigned char *log_buffer,long samples,char temp_scale);

	void UpdatePlotMinMax();

	bool AccountForRollOver(unsigned char *buffer,unsigned char *log_buffer,int num_of_channels,int channel_size);

// Dialog Data
	//{{AFX_DATA(CPageEightDialog)
	enum { IDD = IDD_PAGE8 };
	CComboBox	m_Combo_Average;
	CProgressCtrl	m_DataLog_Progress;
	CTreeCtrl	m_Tree;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPageEightDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
  CGraphCtrl  m_OScopeCtrl;
  BOOL        m_bStartStop;

	// Generated message map functions
	//{{AFX_MSG(CPageEightDialog)
	virtual BOOL OnInitDialog();
	afx_msg void OnButton1();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnButtonDegreeC();
	afx_msg void OnButtonDegreeF();
	afx_msg void OnButtonFilesave();
	afx_msg void OnPrint();
	afx_msg void OnSelchangeComboAverage();
	afx_msg void OnButtonPrint();
	afx_msg void OnButtonTicks();
	afx_msg void OnButtonZoomin();
	afx_msg void OnButtonZoomout();
	afx_msg void OnButtonZoomall();
	afx_msg void OnButtonZoomallthresholds();
	afx_msg void OnCs0();
	afx_msg void OnCs1();
	afx_msg void OnCs2();
	afx_msg void OnCs3();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PageEightDialog_H__473BDB06_B52B_11D3_9C20_00E09803BB79__INCLUDED_)
