// PageFiveDialog.cpp : implementation file
//
/*
  This Evaluation kit software is available free of charge and can be used,
  edited, or reproduced as you see fit. Dallas Semiconductor does not
  assume any liability for the accuracy or correctness of this code.

  It is free to use at your own risk.
  */

#include "stdafx.h"
#include "sample.h"
#include "PageFiveDialog.h"
#include "DS1678.h"
#include "DS1615io.h"
#include "Serial.h"
#include "CrcErrorDlg.h"
#include "Cmd_Pipe.h"
#include "ThresholdDlg.h"
#include "SampleDelay.h"

#include "Cdebug.h"
extern CDebug Debug;

#include "OutputWindow.h"
extern COutputWindow g_OutputWindow;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/* So that all transactions are syncronized with the timer,
   schedule each user command (Mission Buttons, etc.) in a
   command queue
*/


extern bool suspend_timers;
extern bool suspend_due_to_error;
static int CLOCK_UPDATE_TIMER_ID = 25;
static int InitControls = 1;
static int TIMER_ID = 0;

bool D_Edit = FALSE;
bool D_DoUpdate = FALSE;

extern bool auto_poll;
#define READFROM_KEY  1
#define READFROM_FILE 2
extern int datasource;
/////////////////////////////////////////////////////////////////////////////
// CPageFiveDialog dialog


CPageFiveDialog::CPageFiveDialog(CWnd* pParent /*=NULL*/)
	: TStackedPage(CPageFiveDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPageFiveDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CPageFiveDialog::DoDataExchange(CDataExchange* pDX)
{
//	DDX_Control(pDX, IDC_MCLOCK, m_MClock);
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageFiveDialog)
	DDX_Control(pDX, IDC_CHECK_EDIT, m_CHECK_Edit);
	DDX_Control(pDX, IDC_CHECK_CAL, m_CHECK_Cal);
	DDX_Control(pDX, IDC_LED_HI_ALARM, m_Led_Hi_Alarm);
	DDX_Control(pDX, IDC_LED_LO_ALARM, m_Led_Lo_Alarm);
	DDX_Control(pDX, IDC_EDIT_HI, m_Edit_Hi);
	DDX_Control(pDX, IDC_EDIT_LO, m_Edit_Lo);
	DDX_Control(pDX, IDC_EDIT_TIMEDATESTAMP, m_Edit_TimeDateStamp);
	DDX_Control(pDX, IDC_EDIT_SERIALNUMBER, m_Edit_Serial_Number);
	DDX_Control(pDX, IDC_EDIT_SAMPLE_RATE, m_Edit_Sample_Rate);
	DDX_Control(pDX, IDC_EDIT_SAMPLE_DELAY, m_Edit_Sample_Delay);
	DDX_Control(pDX, IDC_CHECK_RO, m_Check_Ro);
	DDX_Control(pDX, IDC_COMBO_DURATION, m_Combo_Duration);
	DDX_Control(pDX, IDC_COMBO_TRIGGER, m_Combo_Trigger);
	DDX_Control(pDX, IDC_EDITADDRESS, m_Edit_Address);
	DDX_Control(pDX, IDC_EDITCOUNTER, m_Edit_Counter);
	DDX_Control(pDX, IDC_EDITSTATUS, m_Edit_Status);
	DDX_Control(pDX, IDC_LED_RO, m_Led_Ro);
	DDX_Control(pDX, IDC_LED_MIP, m_Led_Mip);
	DDX_Control(pDX, IDC_LED_CLEARED, m_Led_Cleared);
	DDX_Control(pDX, IDC_LED_BATT, m_Led_Batt);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageFiveDialog, TStackedPage)
	//{{AFX_MSG_MAP(CPageFiveDialog)
	ON_BN_CLICKED(IDC_INIT, OnInit)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_STARTSOFT, OnStartsoft)
	ON_BN_CLICKED(IDC_STARTEVENT, OnStartevent)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_CLEARMEM, OnClearmem)
	ON_CBN_DROPDOWN(IDC_COMBO_TRIGGER, OnDropdownComboTrigger)
	ON_CBN_SELCHANGE(IDC_COMBO_TRIGGER, OnSelchangeComboTrigger)
	ON_CBN_DROPDOWN(IDC_COMBO_DURATION, OnDropdownComboDuration)
	ON_CBN_SELCHANGE(IDC_COMBO_DURATION, OnSelchangeComboDuration)
	ON_BN_CLICKED(IDC_CHECK_RO, OnCheckRo)
	ON_BN_CLICKED(IDC_SET_RATE_DELAY, OnSetRateDelay)
	ON_EN_KILLFOCUS(IDC_EDIT_SAMPLE_RATE, OnKillfocusEditSampleRate)
	ON_EN_KILLFOCUS(IDC_EDIT_SAMPLE_DELAY, OnKillfocusEditSampleDelay)
	ON_BN_CLICKED(IDC_SETLO, OnSetlo)
	ON_BN_CLICKED(IDC_SETHI, OnSethi)
	ON_BN_CLICKED(IDC_CLRLO, OnClrlo)
	ON_BN_CLICKED(IDC_CLRHI, OnClrhi)
	ON_BN_CLICKED(IDC_BUTTON_DELAY_OFFSET, OnButtonDelayOffset)
	ON_BN_CLICKED(IDC_CHECK_EDIT, OnCheckEdit)
	ON_BN_CLICKED(IDC_CHECK_DS1616_TEMP, OnCheckDs1616Temp)
	ON_BN_CLICKED(IDC_CHECK_DS1616_ADC1, OnCheckDs1616Adc1)
	ON_BN_CLICKED(IDC_CHECK_DS1616_ADC2, OnCheckDs1616Adc2)
	ON_BN_CLICKED(IDC_CHECK_DS1616_ADC3, OnCheckDs1616Adc3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPageFiveDialog message handlers
extern int silicon;

BOOL CPageFiveDialog::OnInitDialog() 
{

	TStackedPage::OnInitDialog();


	TIMER_ID = this->SetTimer(CLOCK_UPDATE_TIMER_ID,100,NULL);


	// TODO: Add extra initialization here
	b_EditingTrigger = false;
	b_EditingDuration = false;

	m_Led_Lo_Alarm.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);
	m_Led_Hi_Alarm.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);

	m_Edit_Lo.SetWindowText("0");
	m_Edit_Hi.SetWindowText("0");

	m_button_delayoffset.SubclassDlgItem( IDC_BUTTON_DELAY_OFFSET, this );
	m_button_delayoffset.SetIcon( IDI_ICON4, 16, 16 );
	m_button_delayoffset.SetMaskedBitmap( IDI_ICON4, 40, 150, RGB( 255, 0, 0 ) );

			// show or hide DS1616 channel information
				if (silicon == 1616) {
					GetDlgItem(IDC_CHECK_DS1616_TEMP)->ShowWindow(SW_SHOW);
					GetDlgItem(IDC_CHECK_DS1616_ADC1)->ShowWindow(SW_SHOW);
					GetDlgItem(IDC_CHECK_DS1616_ADC2)->ShowWindow(SW_SHOW);
					GetDlgItem(IDC_CHECK_DS1616_ADC3)->ShowWindow(SW_SHOW);
					GetDlgItem(IDC_DS1616CHANNELTEXT)->ShowWindow(SW_SHOW);
				} else {
					GetDlgItem(IDC_CHECK_DS1616_TEMP)->ShowWindow(SW_HIDE);
					GetDlgItem(IDC_CHECK_DS1616_ADC1)->ShowWindow(SW_HIDE);
					GetDlgItem(IDC_CHECK_DS1616_ADC2)->ShowWindow(SW_HIDE);
					GetDlgItem(IDC_CHECK_DS1616_ADC3)->ShowWindow(SW_HIDE);
					GetDlgItem(IDC_DS1616CHANNELTEXT)->ShowWindow(SW_HIDE);
				}


	return TRUE;  // return TRUE unless you set the focus to a control
				  // EXCEPTION: OCX Property Pages should return FALSE
}

void CPageFiveDialog::OnInit() 
{

  CRect rect;

  m_Led_Ro.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);
  m_Led_Mip.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);
  m_Led_Cleared.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);
  m_Led_Batt.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);
	
  m_Edit_Status.SetWindowText("Idle");
  m_Edit_Counter.SetWindowText("000000");
  m_Edit_Address.SetWindowText("0000");

  m_Combo_Duration.AddString("Sec Interval (Max 18.2 hours)");
  m_Combo_Duration.AddString("Min Interval (Max 45.5 days)");
  m_Combo_Duration.AddString("Hour Interval (Max 7.5 years)");
//  m_Combo_Duration.SetCurSel(0);

  m_Combo_Trigger.AddString("Falling Edge");
  m_Combo_Trigger.AddString("Rising Edge");
  m_Combo_Trigger.AddString("Both Edges1");
//  m_Combo_Trigger.SetCurSel(0);

}

static unsigned char lastseconds = 0;
bool read_datahist_queued = false;
int read_timeout = 0;
DWORD tick;
int read_page_status = STATUS_IDLE;
unsigned char buffer[34];
unsigned char page_start = 0;
unsigned char page_end = 0;
// define static vars for serial number
unsigned char sn_page_start = 16;
unsigned char sn_page_end = 16;
unsigned char sn_buffer[34];
unsigned char ro_modify;

unsigned char lothresh;
unsigned char hithresh;

bool Flag_RollOver = false;
int  Set_RollOver;

int Start_Pin_Enable = 0;
int Start_Software = 0;
unsigned int sample_delay;
unsigned char sample_rate = 9;
int mission_stopped_event = STATUS_IDLE;
static bool bMission_In_Progress;
bool sample_rate_edited = false;
bool init_sample_rate_varible = true;
static bool bClearLo = false;
static bool bClearHi = false;
static unsigned char status_reg;
bool clear_memory_now = false;

static SYSTEMTIME  current_time;


// Varibles required for the DS1616
unsigned char page_start1 = 1;
unsigned char page_end1 = 1;
unsigned char buffer1[34];

bool flag_DS1616_channel_change0 = false;
bool flag_DS1616_channel_change1 = false;
bool flag_DS1616_channel_change2 = false;
bool flag_DS1616_channel_change3 = false;
int  flag_DS1616_cs0;
int  flag_DS1616_cs1;
int  flag_DS1616_cs2;
int  flag_DS1616_cs3;
unsigned char csaddr0,csdata0;
unsigned char csaddr1,csdata1;
unsigned char csaddr2,csdata2;
unsigned char csaddr3,csdata3;
int channels_enabled[4] = {
	0,0,0,0
};

void CPageFiveDialog::Refresh()  {
	// TODO: Add your control notification handler code here

	char str[128];
	int returnval;

//	if (!auto_poll && datasource == READFROM_KEY)
//		return;

		//if (!read_datahist_queued) {
		returnval = Cmd_Process();
		if (returnval == CMD_SUSPEND) {
			return;
		}
		if (returnval == CMD_SHUTDOWN) {
			return;
		}
		//}
		if (read_page_status == STATUS_IDLE) {
			// read the page with the serial number
			Cmd_Insert(CMD_READ_PAGE,sn_buffer,&sn_page_start,&sn_page_end,NULL,NULL);
			// read page 1 for DS1616 functions
			Cmd_Insert(CMD_READ_PAGE,buffer1,&page_start1,&page_end1,NULL,NULL);
			// read control
			Cmd_Insert(CMD_READ_PAGE,buffer,&page_start,&page_end,NULL,&read_page_status);
		}
		if (read_page_status == STATUS_DONE) {
			    read_page_status = STATUS_IDLE;




			// display stamp date/time
				SYSTEMTIME m_CurrentDateTime;
				unsigned int tstat;
				tstat = DS1615BufferToTimeStamp(buffer,&m_CurrentDateTime);

				DS1615BufferToCurrentTime(buffer,&current_time);

//				sprintf(str,"%d:%02d:%02d %d/%d/%d",m_CurrentDateTime.wHour,m_CurrentDateTime.wMinute,m_CurrentDateTime.wSecond,
//					m_CurrentDateTime.wMonth,m_CurrentDateTime.wDay,m_CurrentDateTime.wYear);		
				if (!tstat){
					int hour24to12[24] = { 12,1,2,3,4,5,6,7,8,9,10,11,12,1,2,3,4,5,6,7,8,9,10,11 };
					sprintf( str, "%02lu/%02lu/%lu %02lu:%02lu:%02lu%s", m_CurrentDateTime.wMonth,m_CurrentDateTime.wDay,m_CurrentDateTime.wYear,
						hour24to12[m_CurrentDateTime.wHour],m_CurrentDateTime.wMinute,m_CurrentDateTime.wSecond,(m_CurrentDateTime.wHour<12)?"am":"pm");
				}
				else{
					sprintf( str, "--/--/-- --:--:----");
				}
				m_Edit_TimeDateStamp.SetWindowText(str);			
				/*m_CalenderCtrl.SetCurrentDate(m_CurrentDateTime);
				m_CalenderCtrl.Reset();
				m_MClock.SetCurrentTime(m_CurrentDateTime);
				m_MClock.Refresh();*/

				if (buffer[0x0E] & 0x10){
					Start_Pin_Enable = 1;
					Start_Software = 0;
				}


/*				if (D_DoUpdate == TRUE){
					if (buffer[0x0E] & 0x10) Start_Pin_Enable = 1;
					Start_Software = 0;
					sample_rate_edited = false;
					init_sample_rate_varible = true;
					clear_memory_now = false;
					D_DoUpdate = FALSE;
				}
*/

				CWnd *pWnd;
			// display MIP led and update bMission_In_Progress flag
				if (buffer[0x14] & 0x20) {
					m_Led_Mip.SetLed(CLed::LED_COLOR_RED,CLed::LED_ON,CLed::LED_ROUND);
					bMission_In_Progress = true;
					Start_Pin_Enable = 0;
					m_Edit_Status.SetWindowText("Mission in Progress");
					
					// disable all edit, start, blah blah, so that the user can not end a mission by accident
					//m_Edit_Sample_Rate.SetReadOnly();
					//m_Edit_Sample_Delay.SetReadOnly();
					pWnd = GetDlgItem(IDC_EDIT_SAMPLE_RATE);  pWnd->EnableWindow(FALSE);
					pWnd = GetDlgItem(IDC_EDIT_SAMPLE_DELAY);  pWnd->EnableWindow(FALSE);
					pWnd = GetDlgItem(IDC_SET_RATE_DELAY);  pWnd->EnableWindow(FALSE);
					pWnd = GetDlgItem(IDC_CHECK_RO);  pWnd->EnableWindow(FALSE);
					pWnd = GetDlgItem(IDC_STARTSOFT);  pWnd->EnableWindow(FALSE);
					pWnd = GetDlgItem(IDC_STARTEVENT);  pWnd->EnableWindow(FALSE);
					pWnd = GetDlgItem(IDC_STOP);  pWnd->EnableWindow(TRUE);
					pWnd = GetDlgItem(IDC_CLEARMEM);  pWnd->EnableWindow(FALSE);
					GetDlgItem(IDC_CHECK_DS1616_TEMP)->EnableWindow(FALSE);
					GetDlgItem(IDC_CHECK_DS1616_ADC1)->EnableWindow(FALSE);
					GetDlgItem(IDC_CHECK_DS1616_ADC2)->EnableWindow(FALSE);
					GetDlgItem(IDC_CHECK_DS1616_ADC3)->EnableWindow(FALSE);
					GetDlgItem(IDC_DS1616CHANNELTEXT)->EnableWindow(FALSE);
				}
				else {
					bMission_In_Progress = false;
					m_Led_Mip.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);
					//m_Edit_Sample_Rate.SetReadOnly(FALSE);
					//m_Edit_Sample_Delay.SetReadOnly(FALSE);
					// enable buttons and edits when not on mission
					pWnd = GetDlgItem(IDC_EDIT_SAMPLE_RATE);  pWnd->EnableWindow(TRUE);
					pWnd = GetDlgItem(IDC_EDIT_SAMPLE_DELAY);  pWnd->EnableWindow(TRUE);
					pWnd = GetDlgItem(IDC_SET_RATE_DELAY);  pWnd->EnableWindow(TRUE);
					pWnd = GetDlgItem(IDC_CHECK_RO);  pWnd->EnableWindow(TRUE);
					pWnd = GetDlgItem(IDC_STARTSOFT);  pWnd->EnableWindow(TRUE);
					pWnd = GetDlgItem(IDC_STARTEVENT);  pWnd->EnableWindow(TRUE);
					pWnd = GetDlgItem(IDC_STOP);  pWnd->EnableWindow(FALSE);
					pWnd = GetDlgItem(IDC_CLEARMEM);  pWnd->EnableWindow(TRUE);
					GetDlgItem(IDC_CHECK_DS1616_TEMP)->EnableWindow(TRUE);
					GetDlgItem(IDC_CHECK_DS1616_ADC1)->EnableWindow(TRUE);
					GetDlgItem(IDC_CHECK_DS1616_ADC2)->EnableWindow(TRUE);
					GetDlgItem(IDC_CHECK_DS1616_ADC3)->EnableWindow(TRUE);
					GetDlgItem(IDC_DS1616CHANNELTEXT)->EnableWindow(TRUE);
					if (!(buffer[0x0E] & 0x10)) m_Edit_Status.SetWindowText("Idle");
				}

		    // display serial number
				char temp[8];
				str[0] = 0;
				for (int s = 0; s < 8; s++) {
					sprintf(temp,"%02X ",sn_buffer[24 + s]);
					strcat(str,temp);
				}
				m_Edit_Serial_Number.SetWindowText(str);

			// display Memory Cleared led
				if (buffer[0x14] & 0x40) 
			      m_Led_Cleared.SetLed(CLed::LED_COLOR_RED,CLed::LED_ON,CLed::LED_ROUND);
				else
			      m_Led_Cleared.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);

			// display Battery Low led
				if (buffer[0x14] & 0x08) 
			      m_Led_Batt.SetLed(CLed::LED_COLOR_RED,CLed::LED_ON,CLed::LED_ROUND);
				else
			      m_Led_Batt.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);

			// display current samples
				sprintf(str,"%lu",DS1615BufferToCurrentSample(buffer));
				m_Edit_Address.SetWindowText(str);

			// display total samples recorded
				sprintf(str,"%lu",DS1615BufferToTotalSamples(buffer));
				m_Edit_Counter.SetWindowText(str);

				if (init_sample_rate_varible) {
					init_sample_rate_varible = false;
					sample_rate = DS1615BufferToSampleRate(buffer);
				}

			// display sample rate
				if (sample_rate_edited) {  // display sample rate as user entered it
					int rate = (int)sample_rate;
					if (GetFocus() != &m_Edit_Sample_Rate) {
						sprintf(str,"%d",rate);
						m_Edit_Sample_Rate.SetWindowText(str);
					}
				} else	// display sample rate from part
					if (GetFocus() != &m_Edit_Sample_Rate) {
						sprintf(str,"%d",DS1615BufferToSampleRate(buffer));
						m_Edit_Sample_Rate.SetWindowText(str);
					}

			// display sample delay
				if (GetFocus() != &m_Edit_Sample_Delay) {
					sprintf(str,"%d",DS1615BufferToSampleDelay(buffer));
					m_Edit_Sample_Delay.SetWindowText(str);
				}

			// if RO bit enabled and current sample > 2048 then light led
				if (silicon == 1615) {		
					if ((DS1615BufferToCurrentSample(buffer) > 2048) && 
						((buffer[0x0E] & 0x08) == 0x08)) 
					  m_Led_Ro.SetLed(CLed::LED_COLOR_RED,CLed::LED_ON, CLed::LED_ROUND);
					else
					  m_Led_Ro.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);
				} else {  // else this is a DS1616
					int channel_size[5] = {
						0,
						2048,
						1024,
						512,
						512
					};
					int number_of_channels_active = 0;
					if ((buffer1[0x09] & 0x40) == 0x40) number_of_channels_active++; 
					if ((buffer1[0x09] & 0x20) == 0x20) number_of_channels_active++; 
					if ((buffer1[0x09] & 0x10) == 0x10) number_of_channels_active++; 
					if ((buffer1[0x09] & 0x08) == 0x08) number_of_channels_active++; 
					int max_size = channel_size[number_of_channels_active];
					if ((DS1615BufferToCurrentSample(buffer) > max_size) && 
						((buffer[0x0E] & 0x08) == 0x08)) 
						m_Led_Ro.SetLed(CLed::LED_COLOR_RED,CLed::LED_ON, CLed::LED_ROUND);
					else
						m_Led_Ro.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);
					
				}

			// Display Ro and check if there is a request to change the flag
				if (!Flag_RollOver) {
					if ((buffer[0x0E] & 0x08) == 0x08) {			
						m_Check_Ro.SetCheck(1);
					} else {
						m_Check_Ro.SetCheck(0);
					}
				}
				if (Flag_RollOver) {
					Debug.Printf1("Flag_RollOver == 1");
					if (Set_RollOver)
						ro_modify = buffer[0x0E] | 0x08;
					else
						ro_modify = buffer[0x0E] & 0xF7;
					Cmd_Insert(CMD_CONTROL_REGISTER,&ro_modify,NULL,NULL,NULL,NULL);
					Flag_RollOver = false;
				}

			// deal with DS1616 channel channel changes
				if (!flag_DS1616_channel_change0) {
					if ((buffer1[0x09] & 0x40) == 0x40) {			
						CheckDlgButton(IDC_CHECK_DS1616_TEMP, BST_CHECKED);
						channels_enabled[0] = 1;
					} else {
						CheckDlgButton(IDC_CHECK_DS1616_TEMP, BST_UNCHECKED);
						channels_enabled[0] = 0;
					}
				}
				if (!flag_DS1616_channel_change1) {
					if ((buffer1[0x09] & 0x20) == 0x20) {			
						CheckDlgButton(IDC_CHECK_DS1616_ADC1, BST_CHECKED);
						channels_enabled[1] = 1;
					} else {
						CheckDlgButton(IDC_CHECK_DS1616_ADC1, BST_UNCHECKED);
						channels_enabled[1] = 0;
					}
				}
				if (!flag_DS1616_channel_change2) {
					if ((buffer1[0x09] & 0x10) == 0x10) {			
						CheckDlgButton(IDC_CHECK_DS1616_ADC2, BST_CHECKED);
						channels_enabled[2] = 1;
					} else {
						CheckDlgButton(IDC_CHECK_DS1616_ADC2, BST_UNCHECKED);
						channels_enabled[2] = 0;
					}
				}
				if (!flag_DS1616_channel_change3) {
					if ((buffer1[0x09] & 0x08) == 0x08) {			
						CheckDlgButton(IDC_CHECK_DS1616_ADC3, BST_CHECKED);
						channels_enabled[3] = 1;
					} else {
						CheckDlgButton(IDC_CHECK_DS1616_ADC3, BST_UNCHECKED);
						channels_enabled[3] = 0;
					}
				}
				if (flag_DS1616_channel_change0) {
					flag_DS1616_channel_change0 = false;
					//AfxMessageBox("flag_DS1616_channel_change");
					//Debug.Printf1("Flag_RollOver == 1");
					if (flag_DS1616_cs0)
						csdata0 = buffer1[0x09] |  0x40;
					else
						csdata0 = buffer1[0x09] & ~0x40;
					csaddr0 = 0x29;
					Cmd_Insert(CMD_WRITE_REGISTER,&csaddr0,&csdata0,NULL,NULL,NULL);
				}
				if (flag_DS1616_channel_change1) {
					flag_DS1616_channel_change1 = false;
					if (flag_DS1616_cs1)
						csdata1 = buffer1[0x09] |  0x20;
					else
						csdata1 = buffer1[0x09] & ~0x20;
					csaddr1 = 0x29;
					Cmd_Insert(CMD_WRITE_REGISTER,&csaddr1,&csdata1,NULL,NULL,NULL);
				}
				if (flag_DS1616_channel_change2) {
					flag_DS1616_channel_change2 = false;
					if (flag_DS1616_cs2)
						csdata2 = buffer1[0x09] |  0x10;
					else
						csdata2 = buffer1[0x09] & ~0x10;
					csaddr2 = 0x29;
					Cmd_Insert(CMD_WRITE_REGISTER,&csaddr2,&csdata2,NULL,NULL,NULL);
				}
				if (flag_DS1616_channel_change3) {
					flag_DS1616_channel_change3 = false;
					if (flag_DS1616_cs3)
						csdata3 = buffer1[0x09] |  0x08;
					else
						csdata3 = buffer1[0x09] & ~0x08;
					csaddr3 = 0x29;
					Cmd_Insert(CMD_WRITE_REGISTER,&csaddr3,&csdata3,NULL,NULL,NULL);
				}

/*					if (Flag_RollOver == 1) {
						Debug.Printf1("Flag_RollOver == 0");
						ro_modify = buffer[0x0E] | 0x08;
						Cmd_Insert(CMD_CONTROL_REGISTER,&ro_modify,NULL,NULL,NULL,NULL);
					} else*/

/*				if (Start_Pin_Enable) {
					ro_modify = buffer[0x0E] | 0x10;
					Cmd_Insert(CMD_CONTROL_REGISTER,&ro_modify,NULL,NULL,NULL,NULL);
					Start_Pin_Enable = 0;
					Cmd_Insert(CMD_BEGIN_MISSION_SOFTWARE,&sample_rate,NULL,NULL,NULL,NULL);
					m_Edit_Status.SetWindowText("Waiting for External Start");
				}
*/
				if (clear_memory_now) {
					static unsigned char old_control_register0 = buffer[0x0E];
					Cmd_Insert(CMD_CLEAR_MEMORY,&old_control_register0,NULL,NULL,NULL,NULL);
					clear_memory_now = false;
					Start_Pin_Enable = 0;
					pWnd = GetDlgItem(IDC_EDIT_SAMPLE_RATE);  pWnd->EnableWindow(TRUE);
					pWnd = GetDlgItem(IDC_EDIT_SAMPLE_DELAY);  pWnd->EnableWindow(TRUE);
					pWnd = GetDlgItem(IDC_SET_RATE_DELAY);  pWnd->EnableWindow(TRUE);
					pWnd = GetDlgItem(IDC_CHECK_RO);  pWnd->EnableWindow(TRUE);
					pWnd = GetDlgItem(IDC_STARTSOFT);  pWnd->EnableWindow(TRUE);
					pWnd = GetDlgItem(IDC_STARTEVENT);  pWnd->EnableWindow(TRUE);
					pWnd = GetDlgItem(IDC_STOP);  pWnd->EnableWindow(FALSE);
					pWnd = GetDlgItem(IDC_CLEARMEM);  pWnd->EnableWindow(TRUE);
				}
				if (Start_Pin_Enable) {
					Start_Pin_Enable = 0;
					// set external start bit
					sample_delay = DS1615BufferToSampleDelay(buffer);  // save sample delay
					static unsigned char old_control_register = buffer[0x0E];
					if (!(buffer[0x0E] & 0x10)){
						Cmd_Insert(CMD_CLEAR_MEMORY,&old_control_register,NULL,NULL,NULL,NULL);
//						m_Edit_Status.SetWindowText("Memory Cleared");
						// write sample delay
						Cmd_Insert(CMD_SAMPLE_DELAY,&sample_delay,NULL,NULL,NULL,NULL);
						ro_modify = buffer[0x0E] | 0x10;
						Cmd_Insert(CMD_CONTROL_REGISTER,&ro_modify,NULL,NULL,NULL,NULL);
						sample_rate_edited = false;
						Cmd_Insert(CMD_BEGIN_MISSION_SOFTWARE,&sample_rate,NULL,NULL,NULL,NULL);
						Cmd_Insert(CMD_END_MISSION,NULL,NULL,NULL,NULL,&mission_stopped_event);
					}
					m_Edit_Status.SetWindowText("Waiting for External Start");
					pWnd = GetDlgItem(IDC_EDIT_SAMPLE_RATE);  pWnd->EnableWindow(FALSE);
					pWnd = GetDlgItem(IDC_EDIT_SAMPLE_DELAY);  pWnd->EnableWindow(FALSE);
					pWnd = GetDlgItem(IDC_SET_RATE_DELAY);  pWnd->EnableWindow(FALSE);
					pWnd = GetDlgItem(IDC_CHECK_RO);  pWnd->EnableWindow(FALSE);
					pWnd = GetDlgItem(IDC_STARTSOFT);  pWnd->EnableWindow(FALSE);
					pWnd = GetDlgItem(IDC_STARTEVENT);  pWnd->EnableWindow(FALSE);
					pWnd = GetDlgItem(IDC_STOP);  pWnd->EnableWindow(FALSE);
					pWnd = GetDlgItem(IDC_CLEARMEM);  pWnd->EnableWindow(TRUE);
				}

				if (Start_Software) {
					// clear external start bit
					sample_delay = DS1615BufferToSampleDelay(buffer);  // save sample delay
					static unsigned char old_control_register2 = buffer[0x0E];
					Cmd_Insert(CMD_CLEAR_MEMORY,&old_control_register2,NULL,NULL,NULL,NULL);
					m_Edit_Status.SetWindowText("Memory Cleared");
					// write sample delay
					Cmd_Insert(CMD_SAMPLE_DELAY,&sample_delay,NULL,NULL,NULL,NULL);
					ro_modify = buffer[0x0E] & 0xEF;
					Cmd_Insert(CMD_CONTROL_REGISTER,&ro_modify,NULL,NULL,NULL,NULL);
					Start_Software = 0;
					sample_rate_edited = false;
					//sprintf(str,"start %d",sample_rate);
					//AfxMessageBox(str);
					Cmd_Insert(CMD_BEGIN_MISSION_SOFTWARE,&sample_rate,NULL,NULL,NULL,NULL);
					m_Edit_Status.SetWindowText("Starting Mission");
				}

				if (mission_stopped_event == STATUS_DONE) {
					if (!(buffer[0x0E] & 0x10))					
						m_Edit_Status.SetWindowText("Mission Stopped");
					mission_stopped_event = STATUS_IDLE;
					static unsigned char old_control_register2 = buffer[0x0E];
					if (!(buffer[0x14] & 0x40))
						Cmd_Insert(CMD_CLEAR_STENABLE,&old_control_register2,NULL,NULL,NULL,NULL);
				}
			


			// display Temperature info
			// draw F and C temperature
				float temp1,temp2;
				float f1;
				CDC* ptrDC;

				f1 = (float)buffer[0x11];
				temp1 = ((float)0.5 * (float)f1) - (float)40.0;
				temp2 = ((float)1.8 * (float)temp1) + (float)32.0;
				CRect rc;
				rc.left  = 275+70;
				rc.top   = 145-110;
				ptrDC = GetDC();
				DrawTemp(ptrDC, rc,temp2,temp1);		
				ReleaseDC(ptrDC);

                lothresh = buffer[0x0B];
				f1 = (float)buffer[0x0B];
				temp1 = ((float)0.5 * (float)f1) - (float)40.0;
				temp2 = ((float)1.8 * (float)temp1) + (float)32.0;
				sprintf(str,"%.1fC / %.1fF",temp1,temp2);
				m_Edit_Lo.SetWindowText(str);
				hithresh = buffer[0x0C];
				f1 = (float)buffer[0x0C];
				temp1 = ((float)0.5 * (float)f1) - (float)40.0;
				temp2 = ((float)1.8 * (float)temp1) + (float)32.0;
				sprintf(str,"%.1fC / %.1fF",temp1,temp2);
				m_Edit_Hi.SetWindowText(str);

			// display lo threshold led
				if (buffer[0x14] & 0x04)
			      m_Led_Lo_Alarm.SetLed(CLed::LED_COLOR_RED,CLed::LED_ON,CLed::LED_ROUND);
				else
			      m_Led_Lo_Alarm.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);

			// display hi threshold led
				if (buffer[0x14] & 0x02)
			      m_Led_Hi_Alarm.SetLed(CLed::LED_COLOR_RED,CLed::LED_ON,CLed::LED_ROUND);
				else
			      m_Led_Hi_Alarm.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);

				if (bClearLo) {
					bClearLo = false;
					status_reg = buffer[0x14] & ~0x04;
					Cmd_Insert(CMD_STATUS_REGISTER,&status_reg,NULL,NULL,NULL,NULL);
				}
				if (bClearHi) {
					bClearHi = false;
					status_reg = buffer[0x14] & ~0x02;
					Cmd_Insert(CMD_STATUS_REGISTER,&status_reg,NULL,NULL,NULL,NULL);
				}


      }
	
		g_OutputWindow.PrintLine("PAGE 5 REFRESH");
		if ((!bMission_In_Progress) && (read_page_status == STATUS_IDLE)) {
			Cmd_Insert(CMD_READ_TEMPERATURE,NULL,NULL,NULL,NULL,NULL);
		}

}



void CPageFiveDialog::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if (nIDEvent == CLOCK_UPDATE_TIMER_ID) {
		if (TStackedPage::IsPageActive()) {
			Debug.Printf1("Page5 tick");
			#ifdef _DEBUG
			   _CrtDbgReport(_CRT_WARN,"rPageOneDialog.cpp",__LINE__,"Demo",":  %s\n","timer page five");
			#endif

			if (InitControls) {
				OnInit();
				InitControls = 0;
			} else {
				   if ((!suspend_timers) && (!suspend_due_to_error))
					Refresh();
			}
		}
	}
	
	TStackedPage::OnTimer(nIDEvent);
}

void CPageFiveDialog::OnStartsoft() 
{
	int response;

	if ((signed int)(hithresh - lothresh) <= 0){
        MessageBox("High Temperature Threshold must be greater than Low Temperature Threshold","Begin Mission",MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	if (sample_rate == 0) {
		MessageBox("Sample Rate must be a Non-Zero Value!","Begin Mission",MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	response = MessageBox("Begining a New Mission Clears the Datalog, Histogram, Current Sample, Temperature Alarm and Start Time Stamp!","Begin Mission",MB_OKCANCEL | MB_ICONEXCLAMATION);
	if (response != IDOK)
		return;
	Start_Software = 1;
}

void CPageFiveDialog::OnStartevent() 
{
	int response;

	if ((signed int)(hithresh - lothresh) <= 0){
        MessageBox("High Temperature Threshold must be greater than Low Temperature Threshold","Begin Mission",MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	if (sample_rate == 0) {
		MessageBox("Sample Rate must be a Non-Zero Value!","Begin Mission",MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	response = MessageBox("Begining a New Mission Clears the Datalog, Histogram, Current Sample, Temperature Alarm and Start Time Stamp!","Begin Mission",MB_OKCANCEL | MB_ICONEXCLAMATION);
	if (response != IDOK)
		return;
	Start_Pin_Enable = 1;
}

void CPageFiveDialog::OnStop() 
{
	int response;
	if (bMission_In_Progress) {
		response = MessageBox("Are You Sure?","End Mission",MB_YESNO | MB_ICONQUESTION);
		if (response == IDNO) return;
	}
	
	m_Edit_Status.SetWindowText("Stopping Mission");
	Cmd_Insert(CMD_END_MISSION,NULL,NULL,NULL,NULL,&mission_stopped_event);

}

void CPageFiveDialog::OnClearmem() 
{
	int response;
	response = MessageBox("Are You Sure?","Clear Memory",MB_YESNO | MB_ICONQUESTION);
	if (response == IDNO)
		return;
	sample_rate = 0;
	clear_memory_now = true;
//	Cmd_Insert(CMD_CLEAR_MEMORY,NULL,NULL,NULL,NULL,NULL);
	m_Edit_Status.SetWindowText("Memory Cleared");
}

void CPageFiveDialog::OnDropdownComboTrigger() 
{
	// TODO: Add your control notification handler code here
	
	b_EditingTrigger = true;
}

void CPageFiveDialog::OnSelchangeComboTrigger() 
{
}

void CPageFiveDialog::OnDropdownComboDuration() 
{
	b_EditingDuration = true;
}

void CPageFiveDialog::OnSelchangeComboDuration() 
{
}


void CPageFiveDialog::OnKillActive(void) {
	TStackedPage::OnKillActive();
}

void CPageFiveDialog::OnSetActive(void) {
	TStackedPage::OnSetActive();
}

void CPageFiveDialog::OnCheckRo() 
{
	if (bMission_In_Progress) {
		MessageBox("Mission In Progress!  Action Cannot be Completed.","Set RollOver",MB_ICONSTOP);
		return;
	}
	if (IsDlgButtonChecked(IDC_CHECK_RO)) {
		Set_RollOver = 1;
		Flag_RollOver = true;
//		AfxMessageBox("set");
	} else {
		Set_RollOver = 0;
		Flag_RollOver = true;
//		AfxMessageBox("clear");
	}
//	if (IsDlgButtonChecked()) 
//	Flag_RollOver ^= 1;
//	}
}

void CPageFiveDialog::OnSetRateDelay() 
{
	// TODO: Add your control notification handler code here
	
}

void CPageFiveDialog::OnKillfocusEditSampleRate() 
{
	char str[16];
	int rate;
	// TODO: Add your control notification handler code here
	m_Edit_Sample_Rate.GetWindowText(str,7);
	sscanf(str,"%d",&rate);
	if (rate < 0 || rate > 255) {
		MessageBox("Sample Rate must be in the range from 0 to 255","Sample Rate Out of Range",MB_ICONSTOP);
		sample_rate = (unsigned char)0;
		sample_rate_edited = true;
		return;
	}
	sample_rate = (unsigned char)rate;
	//AfxMessageBox(str);
	sample_rate_edited = true;
}


void CPageFiveDialog::OnKillfocusEditSampleDelay() 
{
	// TODO: Add your control notification handler code here
	static unsigned int sample_delay;
	char str[16];
	int rate;
	m_Edit_Sample_Delay.GetWindowText(str,7);
	sscanf(str,"%d",&rate);
	if (rate < 0 || rate > 65535) {
		MessageBox("Sample Delay must be in the range from 0 to 65535","Sample Delay Out of Range",MB_ICONSTOP);
		sample_delay = (unsigned char)0;
		return;
	}
	sample_delay = rate;
	Cmd_Insert(CMD_SAMPLE_DELAY,&sample_delay,NULL,NULL,NULL,NULL);
}









static CFont*  m_pFont;				// text font on the tabs
static CFont*  m_pFont2;				// text font on the tabs


void CPageFiveDialog::DrawTemp(CDC* pDC, CRect& rBoundingRect,float temp_f,float temp_c)
{
	char str[80];
	//save the DC so we can restore it
	int nSaveDC = pDC->SaveDC();

	// create font
	LOGFONT logfont;
    CFont*   pfontOld;   // pointer to old font
    CFont*   pfontOld2;   // pointer to old font
    if( m_pFont == NULL ) {                    // if no tab font, create one
		memset( &logfont, 0, sizeof( LOGFONT ) );
		logfont.lfHeight = 12;
		strcpy(logfont.lfFaceName,"MS Sans Serif"); 
		m_pFont = new CFont();
		m_pFont->CreateFontIndirect(&logfont); 
	}
    if( m_pFont2 == NULL ) {                    // if no tab font, create one
		memset( &logfont, 0, sizeof( LOGFONT ) );
		logfont.lfHeight = 38;
		strcpy(logfont.lfFaceName,"Times New Roman"); 
		m_pFont2 = new CFont();
		m_pFont2->CreateFontIndirect(&logfont); 
	}
    pfontOld = pDC->SelectObject( m_pFont );                   // select tab font

	CPen blackpen;
	blackpen.CreatePen (PS_INSIDEFRAME, 1, RGB(0,0,0));
	CPen whitepen;
	whitepen.CreatePen (PS_INSIDEFRAME, 1, RGB(255,255,255));
	CPen pen;
	CPen* pPrevPen = pDC->SelectObject(&pen);

	// draw border	

	CBrush brush;
	brush.CreateSolidBrush(RGB(192,192,192));

	//save the current brush
	CBrush* oldBrush;
	oldBrush = pDC->SelectObject(&brush);

	CRect column;
	//draw the rectangle for the column

    pfontOld2 = pDC->SelectObject( m_pFont2 );                  // select tab font
	pDC->SetTextColor(RGB(0,0,0));
	pDC->SetBkColor(RGB(192,192,192));

	// display temperature
	sprintf(str," %3.1f F  ",temp_f);
	pDC->TextOut(rBoundingRect.left+4,
				rBoundingRect.top+4,
				str);

	sprintf(str," %3.1f C  ",temp_c);
	pDC->TextOut(rBoundingRect.left+4,
				rBoundingRect.top+4+30,
				str);

    pDC->SelectObject( m_pFont );                   // select tab font


	// figure out the starting date to begin cal
	if(oldBrush)
	{
		pDC->SelectObject(oldBrush);
	}

	if(pPrevPen)
	{
		pDC->SelectObject(pPrevPen);
	}

    pDC->SelectObject( pfontOld );         // select old font


	return;


	if (nSaveDC > 0)
	{
		pDC->RestoreDC(nSaveDC);
	}
	return;
}	



void CPageFiveDialog::OnSetlo() 
{
	static unsigned char addr = 0x0B;
	static unsigned char lo;

	if (bMission_In_Progress) {
		MessageBox("Mission In Progress!  Action Cannot be Completed.","Set Threshold",MB_ICONSTOP);
		return;
	}
	CThresholdDlg ThresholdDlg;
	ThresholdDlg.DoModal();
	lo = (unsigned char)((ThresholdDlg.temperature + 40) * 2);
    lothresh = lo;
	Cmd_Insert(CMD_WRITE_REGISTER,&addr,&lo,NULL,NULL,NULL);
}

void CPageFiveDialog::OnSethi() 
{
	static unsigned char addr = 0x0C;
	static unsigned char hi;

	if (bMission_In_Progress) {
		MessageBox("Mission In Progress!  Action Cannot be Completed.","Set Threshold",MB_ICONSTOP);
		return;
	}
	CThresholdDlg ThresholdDlg;
	ThresholdDlg.DoModal();
	hi = (unsigned char)((ThresholdDlg.temperature + 40) * 2);
    hithresh = hi;
	Cmd_Insert(CMD_WRITE_REGISTER,&addr,&hi,NULL,NULL,NULL);
}

void CPageFiveDialog::OnClrlo() 
{
	bClearLo = true;
}

void CPageFiveDialog::OnClrhi() 
{
	bClearHi = true;
}

void CPageFiveDialog::OnButtonDelayOffset() 
{
	// TODO: Add your control notification handler code here
	CSampleDelay dlg;
	char str[256];
	int rate;
	m_Edit_Sample_Delay.GetWindowText(str,7);
	sscanf(str,"%d",&rate);

	dlg.m_lminutes = (long)rate;
	dlg.SetCurrentTime(current_time);
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK) {
		// sprintf(str,"%lu",dlg.m_lminutes);
		// AfxMessageBox(str);
		//file:m_Edit_Sample_Delay.SetWindowText(str);
		if (bMission_In_Progress) {
			MessageBox("Mission In Progress!  Action Cannot be Completed.","Set Sample Delay",MB_ICONSTOP);
			return;
		}
		sample_delay = (unsigned int)dlg.m_lminutes;
		Cmd_Insert(CMD_SAMPLE_DELAY,&sample_delay,NULL,NULL,NULL,NULL);
	}
	else if (nResponse == IDCANCEL) {
	}

}

 
void CPageFiveDialog::OnCheckEdit() 
{
	// TODO: Add your control notification handler code here
	if (m_CHECK_Edit.GetCheck() == 1)
		D_Edit = TRUE;
	else
		D_Edit = FALSE;
}

/*bool flag_DS1616_channel_change = false;
int  flag_DS1616_cs0;
int  flag_DS1616_cs1;
int  flag_DS1616_cs2;
int  flag_DS1616_cs3;
*/

void CPageFiveDialog::CheckChannelChange() {
}

void CPageFiveDialog::OnCheckDs1616Temp() 
{
	if (IsDlgButtonChecked(IDC_CHECK_DS1616_TEMP)) {
		flag_DS1616_cs0 = 1;
		flag_DS1616_channel_change0 = true;
//		AfxMessageBox("set0");
	} else {
		flag_DS1616_cs0 = 0;
		flag_DS1616_channel_change0 = true;
//		AfxMessageBox("clear0");
	}	
}

void CPageFiveDialog::OnCheckDs1616Adc1() 
{
	if (IsDlgButtonChecked(IDC_CHECK_DS1616_ADC1)) {
		flag_DS1616_cs1 = 1;
		flag_DS1616_channel_change1 = true;
//		AfxMessageBox("set1");
	} else {
		flag_DS1616_cs1 = 0;
		flag_DS1616_channel_change1 = true;
//		AfxMessageBox("clear1");
	}	
}

void CPageFiveDialog::OnCheckDs1616Adc2() 
{
	if (IsDlgButtonChecked(IDC_CHECK_DS1616_ADC2)) {
		flag_DS1616_cs2 = 1;
		flag_DS1616_channel_change2 = true;
//		AfxMessageBox("set2");
	} else {
		flag_DS1616_cs2 = 0;
		flag_DS1616_channel_change2 = true;
//		AfxMessageBox("clear2");
	}	
}

void CPageFiveDialog::OnCheckDs1616Adc3() 
{
	if (IsDlgButtonChecked(IDC_CHECK_DS1616_ADC3)) {
		flag_DS1616_cs3 = 1;
		flag_DS1616_channel_change3 = true;
//		AfxMessageBox("set3");
	} else {
		flag_DS1616_cs3 = 0;
		flag_DS1616_channel_change3 = true;
//		AfxMessageBox("clear3");
	}	
}
