/*
  This Evaluation kit software is available free of charge and can be used,
  edited, or reproduced as you see fit. Dallas Semiconductor does not
  assume any liability for the accuracy or correctness of this code.

  It is free to use at your own risk.
  */
#if !defined(AFX_PAGEFIVEDIALOG_H__B9EF8E20_FC3F_11D3_8B6B_00609772CE13__INCLUDED_)
#define AFX_PAGEFIVEDIALOG_H__B9EF8E20_FC3F_11D3_8B6B_00609772CE13__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PageFiveDialog.h : header file
//
#include "GCClock.h"
#include "CalenderCtrl.h"
#include "Led.h"
#include "Sxbutton - updated.h"

/////////////////////////////////////////////////////////////////////////////
// CPageFiveDialog dialog

class CPageFiveDialog : public TStackedPage
{
// Construction
public:
	CPageFiveDialog(CWnd* pParent = NULL);   // standard constructor
	void DrawTemp(CDC* pDC, CRect& rBoundingRect,float temp_f,float temp_c);
	CIconButton	m_button_delayoffset; 

	void CheckChannelChange();

// Dialog Data
	//{{AFX_DATA(CPageFiveDialog)
	enum { IDD = IDD_PAGE5 };
	CButton	m_CHECK_Edit;
	CButton	m_CHECK_Cal;
	CLed	m_Led_Hi_Alarm;
	CLed	m_Led_Lo_Alarm;
	CEdit	m_Edit_Hi;
	CEdit	m_Edit_Lo;
	CEdit	m_Edit_TimeDateStamp;
	CEdit	m_Edit_Serial_Number;
	CEdit	m_Edit_Sample_Rate;
	CEdit	m_Edit_Sample_Delay;
	CButton	m_Check_Ro;
	CGCClock	m_MClock;
	CComboBox	m_Combo_Duration;
	CComboBox	m_Combo_Trigger;
	CEdit	m_Edit_Address;
	CEdit	m_Edit_Counter;
	CEdit	m_Edit_Status;
	CLed	m_Led_Ro;
	CLed	m_Led_Mip;
	CLed	m_Led_Cleared;
	CLed	m_Led_Batt;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPageFiveDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
  CCalenderCtrl m_CalenderCtrl;
  BOOL b_EditingTrigger;
  BOOL b_EditingDuration;
  void Refresh();

void OnKillActive(void);
void OnSetActive(void);
	// Generated message map functions
	//{{AFX_MSG(CPageFiveDialog)
	virtual BOOL OnInitDialog();
	afx_msg void OnInit();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnStartsoft();
	afx_msg void OnStartevent();
	afx_msg void OnStop();
	afx_msg void OnClearmem();
	afx_msg void OnDropdownComboTrigger();
	afx_msg void OnSelchangeComboTrigger();
	afx_msg void OnDropdownComboDuration();
	afx_msg void OnSelchangeComboDuration();
	afx_msg void OnCheckRo();
	afx_msg void OnSetRateDelay();
	afx_msg void OnKillfocusEditSampleRate();
	afx_msg void OnKillfocusEditSampleDelay();
	afx_msg void OnSetlo();
	afx_msg void OnSethi();
	afx_msg void OnClrlo();
	afx_msg void OnClrhi();
	afx_msg void OnButtonDelayOffset();
	afx_msg void OnCheckEdit();
	afx_msg void OnCheckDs1616Temp();
	afx_msg void OnCheckDs1616Adc1();
	afx_msg void OnCheckDs1616Adc2();
	afx_msg void OnCheckDs1616Adc3();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PAGEFIVEDIALOG_H__B9EF8E20_FC3F_11D3_8B6B_00609772CE13__INCLUDED_)
