// PageThreeDialog.cpp : implementation file
//
/*
  This Evaluation kit software is available free of charge and can be used,
  edited, or reproduced as you see fit. Dallas Semiconductor does not
  assume any liability for the accuracy or correctness of this code.

  It is free to use at your own risk.
  */

#include "stdafx.h"
#include "sample.h"
#include "PageNineDialog.h"
#include "Cmd_Pipe.h"
#include "Common.h"
#include "DS1615io.h"
#include "PrintInformation.h"
#include "PrintDlg.h"

#include "Cdebug.h"
extern CDebug Debug;
//#include "TestOScope.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern bool suspend_timers;
extern bool suspend_due_to_error;
static int CLOCK_UPDATE_TIMER_ID = 26;
static int InitControls = 1;
static int TIMER_ID = 0;

static bool histo;
extern bool auto_poll;
#define READFROM_KEY  1
#define READFROM_FILE 2
extern int datasource;
static unsigned int cursorbin;

/////////////////////////////////////////////////////////////////////////////
// CPageNineDialog dialog


CPageNineDialog::CPageNineDialog(CWnd* pParent /*=NULL*/)
	: TStackedPage(CPageNineDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPageNineDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CPageNineDialog::DoDataExchange(CDataExchange* pDX)
{
	TStackedPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageNineDialog)
	DDX_Control(pDX, IDC_DATALOGPROGRESS, m_DataLog_Progress);
	DDX_Control(pDX, IDC_TREE, m_Tree);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageNineDialog, TStackedPage)
	//{{AFX_MSG_MAP(CPageNineDialog)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_DEGREE_C, OnButtonDegreeC)
	ON_BN_CLICKED(IDC_BUTTON_DEGREE_F, OnButtonDegreeF)
	ON_BN_CLICKED(IDC_BUTTON_FILESAVE, OnButtonFilesave)
	ON_BN_CLICKED(IDC_PRINT, OnPrint)
	ON_BN_CLICKED(IDC_BUTTON_PRINT, OnButtonPrint)
	ON_BN_CLICKED(IDC_RADIO_TEMPERATURE, OnRadioTemperature)
	ON_BN_CLICKED(IDC_ADC_CHANNEL1, OnAdcChannel1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPageNineDialog message handlers

BOOL CPageNineDialog::OnInitDialog() 
{
	TStackedPage::OnInitDialog();

	// TODO: Add extra initialization here
	HTREEITEM htroot = m_Tree.InsertItem("Test root");
	m_Tree.InsertItem("Child A", htroot);
	m_Tree.InsertItem("Child B", htroot);

	CheckRadioButton(IDC_RADIO_TEMPERATURE,IDC_ADC_CHANNEL1,IDC_RADIO_TEMPERATURE);	
	m_OScopeCtrl.SetGraphUnits(TEMPERATURE);

	// TODO: Add extra initialization here
	// determine the rectangle for the control
	CRect rect;
	GetDlgItem(IDC_OSCOPE)->GetWindowRect(rect) ;
	ScreenToClient(rect) ;
	// create the control
	m_OScopeCtrl.Create(WS_VISIBLE | WS_CHILD, rect, this) ; 
	// customize the control
	m_OScopeCtrl.SetF();	
	m_OScopeCtrl.SetHistogram() ;
	m_OScopeCtrl.SetRange(-10.0, 10.0, 1) ;
	m_OScopeCtrl.SetYUnits("Samples") ;
	m_OScopeCtrl.SetXUnits("Temperature") ;
	m_OScopeCtrl.SetBackgroundColor(RGB(0, 0, 0)) ;
	m_OScopeCtrl.SetGridColor(RGB(192, 192, 255)) ;
	m_OScopeCtrl.SetPlotColor(RGB(255, 255, 255)) ;
//	m_OScopeCtrl.SetBackgroundColor(RGB(255, 255, 255)) ;
//	m_OScopeCtrl.SetGridColor(RGB(0, 0, 0)) ;
//	m_OScopeCtrl.SetPlotColor(RGB(0, 0, 0)) ;

	m_DataLog_Progress.SetRange(0,3);

	TIMER_ID = this->SetTimer(CLOCK_UPDATE_TIMER_ID,10,NULL);

  // initialize graphical buttons
	m_button_degree_c.SubclassDlgItem( IDC_BUTTON_DEGREE_C, this );
	m_button_degree_c.SetIcon( IDI_ICON_DEGREE_C, 16, 16 );
	m_button_degree_c.SetMaskedBitmap( IDI_ICON_DEGREE_C, 40, 150, RGB( 255, 0, 0 ) );

	m_button_degree_f.SubclassDlgItem( IDC_BUTTON_DEGREE_F, this );
	m_button_degree_f.SetIcon( IDI_ICON_DEGREE_F, 16, 16 );
	m_button_degree_f.SetMaskedBitmap( IDI_ICON_DEGREE_F, 40, 150, RGB( 255, 0, 0 ) );

	m_button_savefile.SubclassDlgItem( IDC_BUTTON_FILESAVE, this );
	m_button_savefile.SetIcon( IDC_BUTTON_FILESAVE, 16, 16 );
	m_button_savefile.SetMaskedBitmap( IDI_ICON_FILESAVE, 40, 150, RGB( 255, 0, 0 ) );

	m_button_print.SubclassDlgItem( IDC_BUTTON_PRINT, this );
	m_button_print.SetIcon( IDI_ICON_PRINT, 16, 16 );
	m_button_print.SetMaskedBitmap( IDI_ICON_PRINT, 40, 150, RGB( 255, 0, 0 ) );

	return TRUE;	// return TRUE unless you set the focus to a control
					// EXCEPTION: OCX Property Pages should return FALSE
}

static unsigned int DataLog_Data[3000];
static bool read_datalog = false;

void CPageNineDialog::OnSetActive(void) {
	TStackedPage::OnSetActive();
	GetDlgItem(IDC_BUTTON1)->SetFocus();
	read_datalog = true;
	m_OScopeCtrl.Zoomall();
}

void CPageNineDialog::OnButton1() 
{
	// TODO: Add your control notification handler code here
	read_datalog = true;
/*	int i;

	m_OScopeCtrl.DeletePoints();
//	DS1615_Read_Datalog(DataLog_Data);
	for (i = 0; i < 200; i++) {
	  DataLog_Data[i] = i;
	  m_OScopeCtrl.AddPoint(DataLog_Data[i]);
	}

	m_OScopeCtrl.AppendPoint(i);
*/
/*	double nRandom;

  // generate a random number between -5 and 5
  nRandom = -5.0 + 10.0*rand()/(double)RAND_MAX;

  // append the new value to the plot
  m_OScopeCtrl.AppendPoint(nRandom);
	AfxMessageBox("Test");

*/

}

static bool mouse_down = false;
static CPoint point1;

void CPageNineDialog::OnLButtonDown(UINT nFlags, CPoint point) 
{
	TStackedPage::OnLButtonDown(nFlags, point);
}

void CPageNineDialog::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
mouse_down = false;

	TStackedPage::OnLButtonUp(nFlags, point);
}

void CPageNineDialog::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if (mouse_down) {
		m_OScopeCtrl.DrawRect1(point1,point);
	}

	TStackedPage::OnMouseMove(nFlags, point);
}

static bool CheckForRollover(unsigned char *buffer) {
	int roll,offset=0;
	long fsample = 0;;
//	ldiv_t div_result;
	int sorted_buffer_index = 0;

	roll = buffer[0x0E] & 0x08;
	// check if the ro bit is set and the number of samples is greater than 2048
	long samples;
	samples = DS1615BufferToCurrentSample(buffer);
	// if the number of samples is less than or equal to 2048 then return (no sorting needed)
	if (samples <= 2048) return false;
	// if the roll-over bit is not set then return (no sorting needed)
	if (roll != 0x08) return false;

	return true;  // return true, rollover occured
}



static unsigned char lastseconds = 0;
static bool read_datahist_queued = false;
static int read_timeout = 0;
static DWORD tick;
static int read_page_status = STATUS_IDLE;
static int page_processed = -1;
static unsigned char buffer[3000];
static unsigned char page_start = 64;
static unsigned char page_end   = 67;
/*unsigned char ro_modify;
int Flag_RollOver = 0;
int Start_Pin_Enable = 0;
int Start_Software = 0;
unsigned char sample_rate = 1;*/
static int mission_stopped_event = STATUS_IDLE;
static char temp_scale = 'F';
static bsave_file = false;
static char filename[128];
static unsigned char page0_buffer[64];
static unsigned char page0_start = 0;
static unsigned char page0_end   = 0;

static struct PrintInfoStruct {
	long totalsamples;
	long missionsamples;
	long cursor_sample;
	SYSTEMTIME timestamp;
	SYSTEMTIME currenttime;
	char serialnumber[64];
	char usermemory_string[36];

	unsigned int sample_rate;
	char cursor_datetime[64];
	char start_datetime[64];
	char end_datetime[64];
	char cursor_temperature[16];
	char range_lowest[32],range_highest[32];
	char threshold_lo[32],threshold_hi[32];
	bool alarm_lo,alarm_hi;
	bool rollover;
	// temperature alarm...
} PrintInfo;
static unsigned char user_page_start = 2;
static unsigned char user_page_end   = 2;
// define static vars for serial number
static unsigned char sn_page_start = 16;
static unsigned char sn_page_end = 16;
static unsigned char sn_buffer[34];

extern bool force_plot_refresh;

void CPageNineDialog::Refresh()  {
	// TODO: Add your control notification handler code here

	char str[128];
	int returnval;
	double value;

//		if (!auto_poll && datasource == READFROM_KEY)
//			return;

		//if (!read_datahist_queued) {
		returnval = Cmd_Process();
		if (returnval == CMD_SUSPEND) {
			return;
		}
		if (returnval == CMD_SHUTDOWN) {
			return;
		}
		//}
		if ((read_datalog == true) || (force_plot_refresh == true)) {
			if (read_page_status == STATUS_IDLE) {
				if (IsDlgButtonChecked(IDC_RADIO_TEMPERATURE)) {
					page_start = 64;
					page_end   = 67;
					m_OScopeCtrl.SetXUnits("Temperature") ;
				} else {
					page_start = 68;
					page_end   = 71;
					m_OScopeCtrl.SetXUnits("Voltage") ;
				}

				
				page_processed = -1;  // init this var for our progress control
				// firat read page 0 so that we can get the number of samples recorded
				Cmd_Insert(CMD_READ_PAGE,page0_buffer,&page0_start,&page0_end,NULL,NULL);
				// get the user memory
				Cmd_Insert(CMD_READ_PAGE,PrintInfo.usermemory_string,&user_page_start,&user_page_end,NULL,NULL);
				// read the page with the serial number
				Cmd_Insert(CMD_READ_PAGE,sn_buffer,&sn_page_start,&sn_page_end,NULL,NULL);
				// next queue a histogram read
				Cmd_Insert(CMD_READ_PAGE,buffer,&page_start,&page_end,&page_processed,&read_page_status);
				force_plot_refresh = false;
			}
		}
		// if a read is queued then show progress
		if (read_page_status == STATUS_QUEUED) {
			if (page_processed != -1) {
				m_DataLog_Progress.SetPos((page_processed - page_start) + 1);
			} else {
				m_DataLog_Progress.SetPos(0);
			}
		}
		if (read_page_status == STATUS_DONE) {
			    read_page_status = STATUS_IDLE;
				m_DataLog_Progress.SetPos(0);
			// set axis label to F or C
				if (IsDlgButtonChecked(IDC_RADIO_TEMPERATURE)) {
					if (temp_scale == 'F')
						m_OScopeCtrl.SetXUnits("Temperature (F)") ;
					else
						m_OScopeCtrl.SetXUnits("Temperature (C)") ;
				}
			// display datalog
				unsigned long i,j,current,sample = 0;
				j = 0;
				unsigned int val;
				unsigned int valhi;
				unsigned int vallo;
				current = DS1615BufferToCurrentSample(page0_buffer);

			// setup print info in-case the user wants to print the plot
				PrintInfo.missionsamples = current;
				DS1615BufferToTimeStamp(page0_buffer,&PrintInfo.timestamp);
				PrintInfo.totalsamples = DS1615BufferToTotalSamples(page0_buffer);
				DS1615BufferToCurrentTime(page0_buffer,&PrintInfo.currenttime);	

			// for printout sake check to see if rollover occured
				PrintInfo.rollover = CheckForRollover(page0_buffer);

			// get alarm info for printout
				if (page0_buffer[0x14] & 0x04)
					PrintInfo.alarm_lo = true;
				else
					PrintInfo.alarm_lo = false;
				if (page0_buffer[0x14] & 0x02)
					PrintInfo.alarm_hi = true;
				else
					PrintInfo.alarm_hi = false;

			// get threshold hi / lo info for printout
				float temp1,temp2,f1;
				f1 = (float)page0_buffer[0x0B];
				temp1 = ((float)0.5 * (float)f1) - (float)40.0;
				temp2 = ((float)1.8 * (float)temp1) + (float)32.0;
				sprintf(PrintInfo.threshold_lo,"%.1fC / %.1fF",temp1,temp2);
				f1 = (float)page0_buffer[0x0C];
				temp1 = ((float)0.5 * (float)f1) - (float)40.0;
				temp2 = ((float)1.8 * (float)temp1) + (float)32.0;
				sprintf(PrintInfo.threshold_hi,"%.1fC / %.1fF",temp1,temp2);

		    // get sample rate info
				PrintInfo.sample_rate = DS1615BufferToSampleRate(page0_buffer);
			// make sure the user string data is zero-terminated
				PrintInfo.usermemory_string[32] = 0;

			// get the serial number
				char temp[8];
				PrintInfo.serialnumber[0] = 0;
				for (int s = 0; s < 8; s++) {
					sprintf(temp,"%02X ",sn_buffer[24 + s]);
					strcat(PrintInfo.serialnumber,temp);
				}
				sprintf(str,"Serial Number: %s",PrintInfo.serialnumber);
				GetDlgItem(IDC_STATIC_SERIAL_NUMBER)->SetWindowText(str);

//				if (PrintInfo.missionsamples < 2) 
//					goto abort_graphing;
				m_OScopeCtrl.DeletePoints();
			//	DS1615_Read_Datalog(DataLog_Data);
				for (i = 0; i < 64; i++) {
					vallo = (unsigned int)buffer[j++];
					valhi = (unsigned int)buffer[j++];
					val =   (valhi * 0x100) + vallo;
					value = (double)val;
					sample++;
					m_OScopeCtrl.AddPoint(value);
				}
				m_OScopeCtrl.AppendPoint(i);

				// now that data is downloaded check to see if we should save the file
				if (bsave_file) {
					if (current == 0){
						bsave_file = false;
						read_datalog = false;
						MessageBox("No Data to Save.","Save Histogram");
						goto abort_graphing;
					}
					SaveDatahist(filename,page0_buffer,buffer,(long)current,temp_scale);
					bsave_file = false;
					read_datalog = false;
					strcat(filename, " Saved.");
					MessageBox(filename,"Save Histogram");
				}
				
abort_graphing:
				read_datalog = false;
		}
		if (PrintInfo.missionsamples >= 1){ 
			if (m_OScopeCtrl.IsPointInfo) {
//				m_OScopeCtrl.IsPointInfo = false;
				float degreesl;
				float degreesu;
				degreesl = ((float)m_OScopeCtrl.index * 2.0) + -40;
				cursorbin = m_OScopeCtrl.index;
				if (m_OScopeCtrl.index < 62)
					degreesu = degreesl + 1.5;
				else
					degreesu = degreesl + 1.0;
				if (temp_scale == 'F'){
					degreesl = ((float)1.8 * (float)degreesl) + (float)32.0;
					degreesu = ((float)1.8 * (float)degreesu) + (float)32.0;
				}
				if (m_OScopeCtrl.GetGraphUnits() == TEMPERATURE)
				  sprintf(str,"Temperature Bin: %3.1f to %3.1f %c",(float)degreesl,(float)degreesu,temp_scale);
				else
				  sprintf(str,"Voltage Bin: %3.3f to %3.3f %c",(float)m_OScopeCtrl.index * 0.032,(float)(m_OScopeCtrl.index * 0.032) + (0.008 * 3.0),'V');
				GetDlgItem(IDC_TEXT_TEMPERATURE)->SetWindowText(str);
				strcpy(PrintInfo.cursor_temperature,str);

				sprintf( str, "Samples: %1.f", m_OScopeCtrl.value);
				// sprintf(str,"%d",m_OScopeCtrl.index);
				GetDlgItem(IDC_TEXT_SAMPLES)->SetWindowText(str);
				strcpy(PrintInfo.cursor_datetime,str);
			}
		}
		else{
				sprintf(str,"Temperature Bin: --.- to --.- %c",temp_scale);
				GetDlgItem(IDC_TEXT_TEMPERATURE)->SetWindowText(str);

				sprintf( str, "Samples: ----");
				// sprintf(str,"%d",m_OScopeCtrl.index);
				GetDlgItem(IDC_TEXT_SAMPLES)->SetWindowText(str);
		}
}



void CPageNineDialog::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if (nIDEvent == CLOCK_UPDATE_TIMER_ID) {
		if (TStackedPage::IsPageActive()) {
			Debug.Printf1("Page7 tick");
//			if (InitControls) {
//				OnInit();
//				InitControls = 0;
//			} else {
				   if ((!suspend_timers) && (!suspend_due_to_error))
					Refresh();
//			}
		}
	}
	
	TStackedPage::OnTimer(nIDEvent);
}


void CPageNineDialog::SaveDatahist(char *filename,unsigned char *buffer,unsigned char *log_buffer,long samples,char temp_scale) {
	int dat,samprate,temp,roll,offset=0;
	int TLF,THF;
	FILE *outfile;
	float degreesl,degreesu,tlow,thigh;
	char str[33];
	long i,fsample = 0;;
	ldiv_t div_result;
		outfile = fopen(filename,"wt");

	roll = buffer[0x0E] & 0x08;

	sprintf(str,"%02X/%02X/%02X %02X:%02X",
			  (int)buffer[0x18],
			  (int)buffer[0x17],
			  (int)buffer[0x19],
			  (int)buffer[0x16],
			  (int)buffer[0x15]);

	samprate = int(buffer[0x0d]);
	temp = int(buffer[0x0b]);
	degreesl = ((float)0.5 * (float)temp) - (float)40.0;
	if (temp_scale == 'F')
		degreesl = ((float)1.8 * (float)degreesl) + (float)32.0;
	tlow = degreesl;
	temp = int(buffer[0x0c]);
	degreesl = ((float)0.5 * (float)temp) - (float)40.0;
	if (temp_scale == 'F')
		degreesl = ((float)1.8 * (float)degreesl) + (float)32.0;
	thigh = degreesl;
	TLF = (buffer[0x14] & 0x04) >> 2;
	THF = (buffer[0x14] & 0x02) >> 1;

	for (i=0; i<33; i++)
		buffer[i] = NULL;

//	Read_Page(2,buffer);

	if (samples > 2048 && roll == 0x08)
	{
		fsample = samples - long(2048);
		div_result = ldiv(samples, (long)2048);
		offset = (int)(samples - (div_result.quot * (long)2048));
	}

				unsigned long j;
				j = 0;
				unsigned int val;
				unsigned int valhi;
				unsigned int vallo;

		fprintf(outfile,"%d,%d,%s,%.1f,%.1f,%d,%d,%c,%s\n",63,samprate,str,tlow,thigh,TLF,THF,temp_scale,PrintInfo.usermemory_string);
		for(i = 0; i < 63; i++)
		{
					vallo = (unsigned int)buffer[j++];
					valhi = (unsigned int)buffer[j++];
					val =   (valhi * 0x100) + vallo;
					dat = (int)val;

			degreesl = ((float)i * 2.0) + -40;
			if (i < 62)
				degreesu = degreesl + 1.5;
			else
				degreesu = degreesl + 1.0;
			if (temp_scale == 'F'){
				degreesl = ((float)1.8 * (float)degreesl) + (float)32.0;
				degreesu = ((float)1.8 * (float)degreesu) + (float)32.0;
			}
		  fprintf(outfile,"%.1f, / %.1f %d\n",degreesl,degreesu,dat);
		}
/*

		if (samples <= 2048 || roll != 0x08)
		{
			if (samples > 2048 && roll != 0x08)
				samples = 2048;

			fprintf(outfile,"%ld, %d, %s, %.1f, %.1f, %d, %d, %c\n",samples,samprate,str,tlow,thigh,TLF,THF,temp_scale);
			for(i = fsample; i < samples; i++)
			{
					data = (unsigned int)log_buffer[i];
					degrees = ((double)0.5 * (double)data) - (double)40.0;
					if (temp_scale == 'F')
						degrees = ((double)1.8 * (double)degrees) + (double)32.0;

			  //dat = GetDataAt(i);
			  //degrees = ((float)0.5 * (float)dat) - (float)40.0;
			  //if (temp_scale == 'F')
			  //  degrees = ((float)1.8 * (float)degrees) + (float)32.0;
			  fprintf(outfile,"%ld, %.1f\n",i+1,degrees);
			}
		}
		else
		{
			samples = 2048;
			fprintf(outfile,"%ld, %d, %s, %.1f, %.1f, %d, %d, %c, %s\n",samples,samprate,str,tlow,thigh,TLF,THF,temp_scale,buffer);

			for(i = offset; i < samples; i++)
			{
					data = (unsigned int)log_buffer[i];
					degrees = ((double)0.5 * (double)data) - (double)40.0;
					if (temp_scale == 'F')
						degrees = ((double)1.8 * (double)degrees) + (double)32.0;
			  fprintf(outfile,"%ld, %.1f\n",fsample++,degrees);
			}
			for(i = 0; i <= offset; i++)
			{
					data = (unsigned int)log_buffer[i];
					degrees = ((double)0.5 * (double)data) - (double)40.0;
					if (temp_scale == 'F')
						degrees = ((double)1.8 * (double)degrees) + (double)32.0;
			  fprintf(outfile,"%ld, %.1f\n",fsample++,degrees);
			}
		}*/
	fclose(outfile);
}
void CPageNineDialog::OnButtonDegreeC() 
{
	// TODO: Add your control notification handler code here
	temp_scale = 'C';
	m_OScopeCtrl.SetC();	
	read_datalog = true;
}

void CPageNineDialog::OnButtonDegreeF() 
{
	// TODO: Add your control notification handler code here
	temp_scale = 'F';
	m_OScopeCtrl.SetF();	
	read_datalog = true;
}

void CPageNineDialog::OnButtonFilesave() 
{
	// TODO: Add your control notification handler code here

	GetFilename(filename,"Save The Device Data File","Datahist.txt","Text files *.txt\0*.dat\0All Files *.*\0*.*\0\0","txt");
//	AfxMessageBox(filename);	

	read_datalog = true;
	bsave_file = true;

}

void CPageNineDialog::OnPrint() 
{
			Debug.Printf0("CPageNineDialog::OnPrint()");
			Sleep(500);
	// TODO: Add your control notification handler code here
  CString PrintString[128];
  int     PrintStringNum;

	bool b_print_information = true;

			Debug.Printf0("CPrintInformation.DoModal()");
			Sleep(500);
	CPrintInformation dlg2;
	int nResponse = dlg2.DoModal();
	if (nResponse == IDCANCEL)
	{
		b_print_information = false;
	}

	histo = true;

			Debug.Printf0("CPrintDlg.DoModal()");
			Sleep(500);
	CPrintDlg dlg;
	nResponse = dlg.DoModal();
	if (nResponse == IDCANCEL)
	{
		histo = false;
		return;
	}
	histo = false;

	bool tabulated_output = dlg.b_printtabulated;
	m_OScopeCtrl.print_graph = dlg.b_printgraph;

	char str[256];
	char str2[256];
	SYSTEMTIME time;
	int hour24to12[24] = { 12,1,2,3,4,5,6,7,8,9,10,11,12,1,2,3,4,5,6,7,8,9,10,11 };

/*			// setup print info in-case the user wants to print the plot
				PrintInfo.missionsamples = current;
				DS1615BufferToTimeStamp(page0_buffer,&PrintInfo.timestamp);
				PrintInfo.totalsamples = DS1615BufferToTotalSamples(page0_buffer);
				DS1615BufferToCurrentTime(page0_buffer,&PrintInfo.currenttime);	
				strcpy(PrintInfo.serialnumber,"00 00 00 00 00 00 00");*/

			Debug.Printf0("compile print options");
			Sleep(500);
	// first string is the title of the plot
	PrintStringNum = 0;
	m_OScopeCtrl.TitleStr = dlg.title;

	PrintString[PrintStringNum++] = "";
	PrintString[PrintStringNum++] = "*** Device Temperature Histogram ***";
	PrintString[PrintStringNum++] = "";


    if (dlg.b_samplenum || dlg.b_sn || dlg.b_stamp || dlg.b_time || dlg.b_usermemory || dlg.b_samplerate
		|| dlg.b_cursorinfo || dlg.b_alarminfo || dlg.b_rollover) {
		PrintString[PrintStringNum++] = " ";
		PrintString[PrintStringNum++] = "===================================================================================================";
		PrintString[PrintStringNum++] = "Device Status Information:";
		PrintString[PrintStringNum++] = " ";
	}

	if (dlg.b_samplenum) {
		sprintf(str,"Number of Mission Samples: %lu",PrintInfo.missionsamples);
		PrintString[PrintStringNum++] = str;
	}

	if (dlg.b_sn) {
		sprintf(str,"Serial Number: [%s]",PrintInfo.serialnumber);
		PrintString[PrintStringNum++] = str;
	}

	if (dlg.b_stamp) {
		time = PrintInfo.timestamp;
		sprintf( str, "Date/Time of First Sample: %02lu/%02lu/%lu %02lu:%02lu:%02lu%s", time.wMonth,time.wDay,time.wYear,
			hour24to12[time.wHour],time.wMinute,time.wSecond,(time.wHour<12)?"am":"pm");
		PrintString[PrintStringNum++] = str;
	}

	if (dlg.b_time) {
		time = PrintInfo.currenttime;
		sprintf( str, "Current Date/Time of Device: %02lu/%02lu/%lu %02lu:%02lu:%02lu%s", time.wMonth,time.wDay,time.wYear,
			hour24to12[time.wHour],time.wMinute,time.wSecond,(time.wHour<12)?"am":"pm");
		PrintString[PrintStringNum++] = str;
	}

	if (dlg.b_usermemory) {
		time = PrintInfo.currenttime;
		sprintf( str, "User Memory: \"%s\"", PrintInfo.usermemory_string);
		PrintString[PrintStringNum++] = str;
	}


	if (dlg.b_samplerate) {
		sprintf( str, "Sample Rate (mins): %lu", PrintInfo.sample_rate);
		PrintString[PrintStringNum++] = str;
	}

	if (dlg.b_cursorinfo) {
		sprintf( str, "Cursor %s", PrintInfo.cursor_datetime);
		PrintString[PrintStringNum++] = str;
		sprintf( str, "Cursor Temperature: %s", PrintInfo.cursor_temperature);
		PrintString[PrintStringNum++] = str;
	}

	if (dlg.b_alarminfo) {
		sprintf( str, "Alarm Threshold Low: %s", PrintInfo.threshold_lo);
		sprintf( str2, "   Alarm Threshold Hi : %s", PrintInfo.threshold_hi);
		strcat(str,str2);
		PrintString[PrintStringNum++] = str;
		sprintf( str, "Alarm Hi / Lo: %s / %s", PrintInfo.alarm_hi ? "Set" : "Clear", PrintInfo.alarm_lo ? "Set" : "Clear");
		PrintString[PrintStringNum++] = str;
	}

	if (dlg.b_rollover) {
		sprintf( str, "Rollover Occured: %s", PrintInfo.rollover ? "Yes" : "No");
		PrintString[PrintStringNum++] = str;
	}


	if (b_print_information) {
//		PrintString[PrintStringNum++] = " ";
		PrintString[PrintStringNum++] = "===================================================================================================";
		PrintString[PrintStringNum++] = "HACCP Reporting Information:";
		PrintString[PrintStringNum++] = " ";
		PrintString[PrintStringNum++] = "Name of processor or importer: " + dlg2.field1;
		PrintString[PrintStringNum++] = "Location of processor or importer: " + dlg2.field2;
		PrintString[PrintStringNum++] = "Description of product: " + dlg2.field3;
		PrintString[PrintStringNum++] = "Production code: " + dlg2.field4;
		PrintString[PrintStringNum++] = "Corrective action or notes: " + dlg2.field5;
		PrintString[PrintStringNum++] = " ";
		PrintString[PrintStringNum++] = " ";
		PrintString[PrintStringNum++] = "Signature:    __________________________________  Date: ______________";
	}
	else {
		PrintString[PrintStringNum++] = "===================================================================================================";
	}

	if (tabulated_output) {
		PrintString[PrintStringNum++] = " ";
		PrintString[PrintStringNum++] = "===================================================================================================";
		PrintString[PrintStringNum++] = "Tabulated Temperature Histogram Data:";
		PrintString[PrintStringNum++] = " ";
		PrintString[PrintStringNum++] = "Temperature              Samples";
		PrintString[PrintStringNum++] = " ";
	}

			Debug.Printf0("assemble the print text into a link list");
			Sleep(500);
	// if tabulated output then assemble the info
	int i;
	int index_min = 0; //m_OScopeCtrl.GetMinRange();
	int index_max = 5; //m_OScopeCtrl.GetMaxRange();
	m_OScopeCtrl.lhead = NULL;
	s_printstrings slink,*newlink;
	newlink = &slink;

// append to the link list the user info
	for (i = 0; i < PrintStringNum;i++) {
		newlink->next = (s_printstrings *) new s_printstrings;
		if (m_OScopeCtrl.lhead == NULL) {
			m_OScopeCtrl.lhead = newlink->next;
		}
		newlink = newlink->next;
		newlink->cstr = (CString *) new CString;

		*newlink->cstr = PrintString[i];
		newlink->next = NULL;
	}

	// append a link list of the tabulated output
			Debug.Printf0("assemble tabulated output (if any)");
			Sleep(500);
	if (tabulated_output) {
		for (i = 0; i < m_OScopeCtrl.line_info_points_datahist;i++) {
			newlink->next = (s_printstrings *) new s_printstrings;
			if (m_OScopeCtrl.lhead == NULL) {
				m_OScopeCtrl.lhead = newlink->next;
			}
			newlink = newlink->next;
			newlink->cstr = (CString *) new CString;


				float degreesl,degreesu;
				degreesl = ((float)m_OScopeCtrl.line_info_datahist[i].index * 2.0) + -40;
				if (m_OScopeCtrl.line_info_datahist[i].index < 62)
					degreesu = degreesl + 1.5;
				else
					degreesu = degreesl + 1.0;
				if (temp_scale == 'F'){
					degreesl = ((float)1.8 * (float)degreesl) + (float)32.0;
					degreesu = ((float)1.8 * (float)degreesu) + (float)32.0;
				}
                char marker;
                if (cursorbin == m_OScopeCtrl.line_info_datahist[i].index && dlg.b_cursorinfo)
					marker = '*';
				else
					marker = 0x00;
				sprintf(str,"% 3.1f / % 3.1f %c",degreesl,degreesu,temp_scale);


			sprintf(str2,"                  % 1.f     %c",m_OScopeCtrl.line_info_datahist[i].value,marker);
			strcat(str,str2);

			*newlink->cstr = str;
			newlink->next = NULL;
		}
	}

			Debug.Printf0("m_OScopeCtrl.PrintGraph()");
			Sleep(500);
	m_OScopeCtrl.PrintGraph();	
}






void CPageNineDialog::OnButtonPrint() 
{
	// TODO: Add your control notification handler code here
    suspend_timers = true;
	OnPrint();
    suspend_timers = false;
}

void CPageNineDialog::OnRadioTemperature() 
{
	CheckRadioButton(IDC_RADIO_TEMPERATURE,IDC_ADC_CHANNEL1,IDC_RADIO_TEMPERATURE);	
	read_datalog = true;
	m_OScopeCtrl.SetGraphUnits(TEMPERATURE);
}

void CPageNineDialog::OnAdcChannel1() 
{
	CheckRadioButton(IDC_RADIO_TEMPERATURE,IDC_ADC_CHANNEL1,IDC_ADC_CHANNEL1);	
	read_datalog = true;
	m_OScopeCtrl.SetGraphUnits(VOLTAGE);
}
