// PageOneDialog.cpp : implementation file
//
/*
  This Evaluation kit software is available free of charge and can be used,
  edited, or reproduced as you see fit. Dallas Semiconductor does not
  assume any liability for the accuracy or correctness of this code.

  It is free to use at your own risk.
  */

#include "stdafx.h"
#include "Sample.h"
#include "PageOneDialog.h"
#include "DS1678.h"
#include "DS1615io.h"
#include "Serial.h"
#include "Cmd_Pipe.h"
#include "datetimecls.h"
#include "SetAlarmDlg.h"


#include "Cdebug.h"
extern CDebug Debug;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern bool suspend_timers;
extern bool suspend_due_to_error;
static int CLOCK_UPDATE_TIMER_ID = 27;
static int TIMER_ID = 0;
static int InitControls = 1;

extern bool auto_poll;
#define READFROM_KEY  1
#define READFROM_FILE 2
extern int datasource;
/////////////////////////////////////////////////////////////////////////////
// CPageOneDialog dialog


CPageOneDialog::CPageOneDialog(CWnd* pParent /*=NULL*/)
	: TStackedPage(CPageOneDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPageOneDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CPageOneDialog::DoDataExchange(CDataExchange* pDX)
{
	TStackedPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageOneDialog)
	DDX_Control(pDX, IDC_ALARM_TIME, m_Alarm_Time);
	DDX_Control(pDX, IDC_CHECKOSC, m_CheckOsc);
	DDX_Control(pDX, IDC_CHECKALARMSOUND, m_CheckAlarmSound);
	DDX_Control(pDX, IDC_CHECKALARMCLEAR, m_CheckAlarmClear);
	DDX_Control(pDX, IDC_CHECK12_24, m_Check12_24);
	DDX_Control(pDX, IDC_COMBODAYS, m_ComboDays);
	DDX_Control(pDX, IDC_ACLOCK, m_AlarmClock);
	DDX_Control(pDX, IDC_COMBOALARM, m_ComboAlarm);
	DDX_Control(pDX, IDC_LED, m_LedAlarm);
	DDX_Control(pDX, IDC_CLOCK, m_Clock);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageOneDialog, TStackedPage)
	//{{AFX_MSG_MAP(CPageOneDialog)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_SETCURRENT, OnSetcurrent)
	ON_WM_CANCELMODE()
	ON_CBN_SELCHANGE(IDC_COMBOALARM, OnSelchangeComboalarm)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECKOSC, OnCheckosc)
	ON_BN_CLICKED(IDC_CHECKALARMCLEAR, OnCheckalarmclear)
	ON_BN_CLICKED(IDC_CHECKALARMSOUND, OnCheckalarmsound)
	ON_CBN_SELCHANGE(IDC_COMBODAYS, OnSelchangeCombodays)
	ON_CBN_DROPDOWN(IDC_COMBODAYS, OnDropdownCombodays)
	ON_CBN_CLOSEUP(IDC_COMBODAYS, OnCloseupCombodays)
	ON_CBN_DROPDOWN(IDC_COMBOALARM, OnDropdownComboalarm)
	ON_WM_KILLFOCUS()
	ON_BN_CLICKED(IDC_SETDATETIME, OnSetdatetime)
	ON_BN_CLICKED(IDC_SET_ALARM_TIME, OnSetAlarmTime)
	ON_BN_CLICKED(IDC_SET_ALARM, OnSetAlarm)
	ON_BN_CLICKED(IDC_CHECK_INT, OnCheckInt)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


static unsigned char lastseconds = 0;
static bool read_datahist_queued = false;
static int read_timeout = 0;
static DWORD tick;
static int read_page_status = STATUS_IDLE;
static unsigned char buffer[34];
static unsigned char page_start = 0;
static unsigned char page_end   = 0;
/*unsigned char ro_modify;
int Flag_RollOver = 0;
int Start_Pin_Enable = 0;
int Start_Software = 0;
unsigned char sample_rate = 1;*/
static int mission_stopped_event = STATUS_IDLE;
static bool bMission_In_Progress;
static SYSTEMTIME SystemTime;
static unsigned char status_reg;
static int g_alarmint = 2;


void CPageOneDialog::Refresh()  {
	// TODO: Add your control notification handler code here

	int returnval;

//		if (!auto_poll && datasource == READFROM_KEY)
//			return;

		//if (!read_datahist_queued) {
		returnval = Cmd_Process();
		if (returnval == CMD_SUSPEND) {
			return;
		}
		if (returnval == CMD_SHUTDOWN) {
			return;
		}
		//}
		if (read_page_status == STATUS_IDLE) {
			Cmd_Insert(CMD_READ_PAGE,buffer,&page_start,&page_end,NULL,&read_page_status);
		}
		if (read_page_status == STATUS_DONE) {
			read_page_status = STATUS_IDLE;
			
			if (buffer[0x14] & 0x20) {
				bMission_In_Progress = true;
			} else bMission_In_Progress = false;
			
			// "Ping" led if alarm
			if (buffer[0x14] & 0x01) {
				m_LedAlarm.Ping(700);
				status_reg = buffer[0x14] & ~0x01;
				Cmd_Insert(CMD_STATUS_REGISTER,&status_reg,NULL,NULL,NULL,NULL);
			}
			
			if (g_alarmint == 2) {
				g_alarmint = (int)(buffer[0x0E] & 1);
			}
			static unsigned char addr1[1] = {0x0E};
			static unsigned char data1[1];
			if ((buffer[0x0E] & 1) != g_alarmint) {
				if (g_alarmint) {
					data1[0] = buffer[0x0E] | 1;
				} else {
					data1[0] = buffer[0x0E] & 0xFE;
				}
				Cmd_Insert(CMD_WRITE_REGISTER,&addr1[0],&data1[0],NULL,NULL,NULL);
			}
			



			//GetDS1678Time(&m_CurrentDateTime);
			DS1615BufferToCurrentTime(buffer,&SystemTime);

			if (IsDlgButtonChecked(IDC_RADIO_24)) 
				m_Clock.Set24Mode();			
			else
				m_Clock.Set12Mode();
			m_CalenderCtrl.SetCurrentDate(SystemTime);
			m_CalenderCtrl.Reset();
			m_Clock.SetCurrentTime(SystemTime);
			m_Clock.Refresh();

			unsigned char ms,mm,mh,md,d;
			SYSTEMTIME m_AlarmDateTime;	
			memset(&m_AlarmDateTime, 0, sizeof(m_AlarmDateTime));
   			DS1615BufferToAlarmTime(buffer,&m_AlarmDateTime,&ms,&mm,&mh,&md);
/*			m_AlarmDateTime.wHour = 1;
			m_AlarmDateTime.wMinute = 1;
			m_AlarmDateTime.wSecond = 1;
			m_AlarmDateTime.wMilliseconds = 1;*/
			m_AlarmClock.SetCurrentTime(m_AlarmDateTime);
			m_AlarmClock.Refresh();
			//m_Alarm_Time.SetTime(&m_AlarmDateTime);

   CDateTimeCtrl* pCtrl = (CDateTimeCtrl*) GetDlgItem(IDC_ALARM_TIME);
   ASSERT(pCtrl != NULL);

   // set with a CTime
   CTime timeTime(1998, 4, 3, m_AlarmDateTime.wHour, m_AlarmDateTime.wMinute, m_AlarmDateTime.wSecond);
   VERIFY(pCtrl->SetTime(&timeTime));

   // set with a COleDateTime object
/*   COleDateTime oletimeTime(1998, 4, 3, 0, 0, 0);
   VERIFY(pCtrl->SetTime(oletimeTime));

   // set using the SYSTEMTIME
   SYSTEMTIME sysTime;
   memset(&sysTime, 0, sizeof(sysTime));
   sysTime.wYear = 1998;
   sysTime.wMonth = 4;
   sysTime.wDay = 3;
   VERIFY(pCtrl->SetTime(&sysTime));*/

		// check current alarm mask settings
			d = (ms >> 7) * 0x08 + (mm >> 7) * 0x04 + (mh >> 7) * 0x02 + (md >> 7) * 0x01;

			switch (d) {
				case 0x0F: GetDlgItem(IDC_EDIT_MASK)->SetWindowText("Alarm Once Per Second");	 break;
				case 0x07: GetDlgItem(IDC_EDIT_MASK)->SetWindowText("Alarm When Minutes Match");	 break;
				case 0x03: GetDlgItem(IDC_EDIT_MASK)->SetWindowText("Alarm When Min,Sec Match");	 break;
				case 0x01: GetDlgItem(IDC_EDIT_MASK)->SetWindowText("Alarm When Hrs,Min,Sec Match");	 break;
				case 0x00: GetDlgItem(IDC_EDIT_MASK)->SetWindowText("Alarm When Days,Hrs,Min,Sec Match");	 break;
				default:GetDlgItem(IDC_EDIT_MASK)->SetWindowText("-------"); break;
			}
			switch (buffer[0x0A] & 0x0F) {
				case 0x00:	GetDlgItem(IDC_EDIT_DAYS)->SetWindowText("Sunday"); break;
				case 0x01:	GetDlgItem(IDC_EDIT_DAYS)->SetWindowText("Monday"); break;
				case 0x02:	GetDlgItem(IDC_EDIT_DAYS)->SetWindowText("Tuesday"); break;
				case 0x03:	GetDlgItem(IDC_EDIT_DAYS)->SetWindowText("Wednesday"); break;
				case 0x04:	GetDlgItem(IDC_EDIT_DAYS)->SetWindowText("Thursday"); break;
				case 0x05:	GetDlgItem(IDC_EDIT_DAYS)->SetWindowText("Friday"); break;
				case 0x06:	GetDlgItem(IDC_EDIT_DAYS)->SetWindowText("Saturday"); break;
				default:GetDlgItem(IDC_EDIT_DAYS)->SetWindowText("---"); break;
			}

		}
/*
	unsigned char d;
	unsigned char currentseconds;

  // the following three lines synchronize the updating of the clock
  //   with the part
    currentseconds = DS1678ReadByte(0x00);
	if (currentseconds == lastseconds) return; 
	lastseconds = currentseconds;
	
    d = DS1678ReadByte(0x0F);
	if (d != 0xFF)
	  if ((d & 0x01) == 0x01) {
		m_LedAlarm.Ping(500);
	  }

//    d = DS1678ReadByte(0x09);

//	if (b_CheckAlarmClear == true) {
//	}

	SYSTEMTIME m_CurrentDateTime;	// Current LOCAL time.

	GetDS1678Time(&m_CurrentDateTime);
		
	m_CalenderCtrl.SetCurrentDate(m_CurrentDateTime);
	m_CalenderCtrl.Reset();
	m_Clock.SetCurrentTime(m_CurrentDateTime);
	m_Clock.Refresh();

	unsigned char ms,mm,mh,md;
	SYSTEMTIME m_AlarmDateTime;	
	GetDS1678AlarmTime(&m_AlarmDateTime,&ms,&mm,&mh,&md);

  // check current alarm mask settings
	d = (ms >> 7) * 0x08 + (mm >> 7) * 0x04 + (mh >> 7) * 0x02 + (md >> 7) * 0x01;

	if (b_EditingMask == false) { // don't update control if user is changing it
		switch (d) {
			case 0x0F:	m_ComboAlarm.SetCurSel(0); break;
			case 0x07:	m_ComboAlarm.SetCurSel(1); break;
			case 0x03:	m_ComboAlarm.SetCurSel(2); break;
			case 0x01:	m_ComboAlarm.SetCurSel(3); break;
			case 0x00:	m_ComboAlarm.SetCurSel(4); break;
				// if invalid value then default will be forced
			default: SetDS1678AlarmTime(m_AlarmDateTime,ALARM_OFF,ALARM_OFF,ALARM_OFF,ALARM_OFF); m_ComboAlarm.SetCurSel(4); break;
		};
	}

	
	if (b_EditingDays == false) { // don't update control if user is changing it

	    #ifdef _DEBUG
		   _CrtDbgReport(_CRT_WARN,"rPageOneDialog.cpp",__LINE__,"Demo",":  %s %d\n","m_AlarmDateTime.wDay",m_AlarmDateTime.wDay);
	    #endif
		
		switch (m_AlarmDateTime.wDay) {
			case 0x00:	m_ComboDays.SetCurSel(0); break;
			case 0x01:	m_ComboDays.SetCurSel(1); break;
			case 0x02:	m_ComboDays.SetCurSel(2); break;
			case 0x03:	m_ComboDays.SetCurSel(3); break;
			case 0x04:	m_ComboDays.SetCurSel(4); break;
			case 0x05:	m_ComboDays.SetCurSel(5); break;
			case 0x06:	m_ComboDays.SetCurSel(6); break;
		}
	}
	m_AlarmClock.SetCurrentTime(m_AlarmDateTime);
	m_AlarmClock.Refresh();
*/
}



/////////////////////////////////////////////////////////////////////////////
// CPageOneDialog message handlers

void CPageOneDialog::OnButton1() 
{
	// TODO: Add your control notification handler code here
	m_Clock.SetOn(FALSE);
	m_Clock.SetTextOffColor(RGB(0,180,255));
	m_Clock.SetBackgroundOffColor(RGB(0,0,50));
	m_Clock.SetBold();
	m_Clock.SetSunken();
	m_Clock.SetPointFont(25,"Comic Sans MS");
//	m_Clock.Start();

	m_AlarmClock.SetOn(FALSE);
	m_AlarmClock.SetTextOffColor(RGB(180,180,255));
	m_AlarmClock.SetBackgroundOffColor(RGB(0,0,50));
	//m_AlarmClock.SetBold();
	m_AlarmClock.SetSunken();
	m_AlarmClock.SetPointFont(10,"Comic Sans MS");
//	m_Clock.Start();

  CRect rect;
  GetDlgItem(IDC_CALENDER)->GetWindowRect(rect) ;
  ScreenToClient(rect) ;
  // create the control
  m_CalenderCtrl.Create(WS_VISIBLE | WS_CHILD, rect, this) ; 
  // customize the control
  m_CalenderCtrl.SetRange(-10.0, 10.0, 1) ;
  m_CalenderCtrl.SetYUnits("Volts") ;
  m_CalenderCtrl.SetXUnits("Samples (Windows Timer: 100 msec)") ;
  m_CalenderCtrl.SetBackgroundColor(RGB(0, 0, 64)) ;
  m_CalenderCtrl.SetGridColor(RGB(192, 192, 255)) ;
  m_CalenderCtrl.SetPlotColor(RGB(255, 255, 255)) ;

  m_LedAlarm.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);

}

void CPageOneDialog::OnButton2() 
{
	// TODO: Add your control notification handler code here
	Refresh();
}

void CPageOneDialog::OnButton3() 
{
	// TODO: Add your control notification handler code here
/*  char str[128];
  sprintf(str,"%02X",DS1678ReadByte(0x0E));
  AfxMessageBox(str);
  sprintf(str,"%02X",DS1678ReadByte(0x0F));
  AfxMessageBox(str);

  DS1678WriteByte(0x0E,0x00);
*/	
}


void CPageOneDialog::OnSetcurrent() 
{
	if (bMission_In_Progress) {
		MessageBox("Mission In Progress!  Action Cannot be Completed.","Set Time",MB_ICONSTOP);
		return;
	}
    GetLocalTime(&SystemTime);
	Cmd_Insert(CMD_WRITE_RTC,&SystemTime,NULL,NULL,NULL,NULL);
}

BOOL CPageOneDialog::OnInitDialog() 
{
	TStackedPage::OnInitDialog();
	
	// TODO: Add extra initialization here
  // TODO: Add extra initialization here
  // determine the rectangle for the control
  m_ComboAlarm.AddString("Alarm Once Per Second");
  m_ComboAlarm.AddString("Alarm When Minutes Match");
  m_ComboAlarm.AddString("Alarm When Min,Sec Match");
  m_ComboAlarm.AddString("Alarm When Hrs,Min,Sec Match");
  m_ComboAlarm.AddString("Alarm When Days,Hrs,Min,Sec Match");

  m_AlarmDateTime.wDay = 1;
  m_AlarmDateTime.wHour = 12;
  m_AlarmDateTime.wMinute = 0;
  m_AlarmDateTime.wSecond = 0;

  m_ComboDays.AddString("Sun");
  m_ComboDays.AddString("Mon");
  m_ComboDays.AddString("Tue");
  m_ComboDays.AddString("Wed");
  m_ComboDays.AddString("Thr");
  m_ComboDays.AddString("Fri");
  m_ComboDays.AddString("Sat");

  b_CheckAlarmClear = true;
  b_CheckAlarmSound = false;

	b_EditingDays = false;	
	b_EditingMask = false;	

  TIMER_ID = this->SetTimer(CLOCK_UPDATE_TIMER_ID,70,NULL);
//	if (id == 0) return FALSE;



	CheckRadioButton(IDC_RADIO_12,IDC_RADIO_24,IDC_RADIO_12);	

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPageOneDialog::OnCancelMode() 
{
	TStackedPage::OnCancelMode();
	
	// TODO: Add your message handler code here
	
}

void CPageOneDialog::OnSelchangeComboalarm() 
{
	// TODO: Add your control notification handler code here
/*  char str[128];

  int nIndex = m_ComboAlarm.GetCurSel();
  sprintf(str,"%d",nIndex);
  AfxMessageBox(str);
  switch (nIndex) {
  case 0: SetDS1678AlarmTime(m_AlarmDateTime,ALARM_ON ,ALARM_ON ,ALARM_ON ,ALARM_ON ); break;
  case 1: SetDS1678AlarmTime(m_AlarmDateTime,ALARM_OFF,ALARM_ON ,ALARM_ON ,ALARM_ON ); break;
  case 2: SetDS1678AlarmTime(m_AlarmDateTime,ALARM_OFF,ALARM_OFF,ALARM_ON ,ALARM_ON ); break;
  case 3: SetDS1678AlarmTime(m_AlarmDateTime,ALARM_OFF,ALARM_OFF,ALARM_OFF,ALARM_ON ); break;
  case 4: SetDS1678AlarmTime(m_AlarmDateTime,ALARM_OFF,ALARM_OFF,ALARM_OFF,ALARM_OFF); break;
  }
  b_EditingMask = false;*/
//  AfxMessageBox("change");
}

void CPageOneDialog::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if (nIDEvent == CLOCK_UPDATE_TIMER_ID) {
		if (TStackedPage::IsPageActive()) {
			Debug.Printf1("Page1 tick");
			#ifdef _DEBUG
			   _CrtDbgReport(_CRT_WARN,"rPageOneDialog.cpp",__LINE__,"Demo",":  %s\n","timer page one");
			#endif

			if (InitControls) {
				OnButton1();
				InitControls = 0;
			} else {
				   if ((!suspend_timers) && (!suspend_due_to_error))
					  Refresh();
			}
		}
	}
		// CGCColorStatic::OnTimer(nIDEvent);

	// If we are here then the current timer event is the clock's update event.	
	TStackedPage::OnTimer(nIDEvent);
}

void CPageOneDialog::OnCheckosc() 
{
	// TODO: Add your control notification handler code here
/*  unsigned char d;
	
  d = DS1678ReadByte(0x0E);
	if ((m_CheckOsc.GetState() & 0x0003) == 1) {
		DS1678WriteByte(0x0E,d | 0x01);
	} else {
		DS1678WriteByte(0x0E,d & 0xFE);
	}*/
}


void CPageOneDialog::OnCheckalarmclear() 
{
	// TODO: Add your control notification handler code here
/*	if ((m_CheckAlarmClear.GetState() & 0x0003) == 1) {
		b_CheckAlarmClear = true;
	} else {
		b_CheckAlarmClear = false;
	}
	*/
}

void CPageOneDialog::OnCheckalarmsound() 
{
	// TODO: Add your control notification handler code here
/*	if ((m_CheckAlarmSound.GetState() & 0x0003) == 1) {
		b_CheckAlarmSound = true;
	} else {
		b_CheckAlarmSound = false;
	}
*/	
}

void CPageOneDialog::OnSelchangeCombodays() 
{
	// TODO: Add your control notification handler code here
/*  unsigned char ms,mm,mh,md;
  unsigned char d;
  char str[128];
	
  d = DS1678ReadByte(0x0B);

  int nIndex = m_ComboDays.GetCurSel();
  switch (nIndex) {
    case 0: d = (d & 0x80) + 0; break;
    case 1: d = (d & 0x80) + 1; break;
    case 2: d = (d & 0x80) + 2; break;
    case 3: d = (d & 0x80) + 3; break;
    case 4: d = (d & 0x80) + 4; break;
    case 5: d = (d & 0x80) + 5; break;
    case 6: d = (d & 0x80) + 6; break;
  }
  
  DS1678WriteByte(0x0B,d);
  b_EditingDays = false;*/	
}

void CPageOneDialog::OnDropdownCombodays() 
{
	b_EditingDays = true;
}

void CPageOneDialog::OnCloseupCombodays() 
{
}

void CPageOneDialog::OnDropdownComboalarm() 
{
	b_EditingMask = true;
}

void CPageOneDialog::OnKillFocus(CWnd* pNewWnd) 
{
	TStackedPage::OnKillFocus(pNewWnd);
}

void CPageOneDialog::OnKillActive(void) {
	TStackedPage::OnKillActive();
	Debug.Printf1("Page1 OnKillActive");
}

void CPageOneDialog::OnSetActive(void) {
	TStackedPage::OnSetActive();
}

static SYSTEMTIME SystemTimeUpdate;

void CPageOneDialog::OnSetdatetime() 
{
	// TODO: Add your control notification handler code here
	if (bMission_In_Progress) {
		MessageBox("Mission In Progress!  Action Cannot be Completed.","Set Time",MB_ICONSTOP);
		return;
	}

	char str[256];
	CDateTimeCls dlg;
	dlg.timestruct = SystemTime;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		SystemTimeUpdate = dlg.timestruct;
//		AfxMessageBox("Cmd_Insert");
		Cmd_Insert(CMD_WRITE_RTC,&SystemTimeUpdate,NULL,NULL,NULL,NULL);
	}
	else if (nResponse == IDCANCEL)
	{
	}

	sprintf(str,"Time %d:%02d:%02d   Date %d/%d/%d" ,SystemTimeUpdate.wHour
													,SystemTimeUpdate.wMinute
													,SystemTimeUpdate.wSecond
													,SystemTimeUpdate.wMonth
													,SystemTimeUpdate.wDay
													,SystemTimeUpdate.wYear);
//	AfxMessageBox(str);
}

void CPageOneDialog::OnSetAlarmTime() 
{
	// TODO: Add your control notification handler code here
	
}

static unsigned char bin_to_bcd(int d) {
  int i;
  unsigned char c;

  i = d / 10;
  c = (unsigned char)(i * 16);
  i = d % 10;
  c += (unsigned char)i;
  return c;
}

void CPageOneDialog::OnSetAlarm() 
{
	int i;
	static unsigned char addr[4] = {0x07,0x08,0x09,0x0A};
	static unsigned char data[4];
	// TODO: Add your control notification handler code here
	if (bMission_In_Progress) {
		MessageBox("Mission In Progress!  Action Cannot be Completed.","Set Alarm Time",MB_ICONSTOP);
		return;
	}

	char str[256];
	CSetAlarmDlg dlg;
	dlg.timestruct = SystemTime;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
	sprintf(str,"%d %d %d %d %d " ,	dlg.timestruct.wSecond,
									dlg.timestruct.wMinute,
									dlg.timestruct.wHour,
									dlg.days_selection,
									dlg.mask_selection);
//	AfxMessageBox(str);
		data[0] = bin_to_bcd(dlg.timestruct.wSecond);
		data[1] = bin_to_bcd(dlg.timestruct.wMinute);
		data[2] = bin_to_bcd(dlg.timestruct.wHour);
		data[3] = bin_to_bcd(dlg.days_selection);
		switch (dlg.mask_selection) {
			case 0: data[0]+=0x80; data[1]+=0x80; data[2]+=0x80; data[3]+=0x80; break;
			case 1: data[0]+=0x00; data[1]+=0x80; data[2]+=0x80; data[3]+=0x80; break;
			case 2: data[0]+=0x00; data[1]+=0x00; data[2]+=0x80; data[3]+=0x80; break;
			case 3: data[0]+=0x00; data[1]+=0x00; data[2]+=0x00; data[3]+=0x80; break;
			case 4: data[0]+=0x00; data[1]+=0x00; data[2]+=0x00; data[3]+=0x00; break;
		}
		for (i = 0; i < 4; i++)
			Cmd_Insert(CMD_WRITE_REGISTER,&addr[i],&data[i],NULL,NULL,NULL);
//		Cmd_Insert(CMD_WRITE_RTC,&SystemTime,NULL,NULL,NULL,NULL);
	}
	else if (nResponse == IDCANCEL)
	{
		return;
	}
	sprintf(str,"%02X %02X %02X %02X " ,data[0],
										data[1],
										data[2],
										data[3]);

//	AfxMessageBox(str);


}



void CPageOneDialog::OnCheckInt() 
{
	if (IsDlgButtonChecked(IDC_CHECK_INT)) 
		g_alarmint = 1;			
	else
		g_alarmint = 0;
}
