// PageSix1Dialog.cpp : implementation file
//
/*
  This Evaluation kit software is available free of charge and can be used,
  edited, or reproduced as you see fit. Dallas Semiconductor does not
  assume any liability for the accuracy or correctness of this code.

  It is free to use at your own risk.
  */

#include "stdafx.h"
#include "sample.h"
#include "PageSix1Dialog.h"
#include "DS1615io.h"
#include "Serial.h"
#include "CrcErrorDlg.h"
#include "Cmd_Pipe.h"
#include "ThresholdDlg.h"

#include "Cdebug.h"
extern CDebug Debug;

#include "OutputWindow.h"
extern COutputWindow g_OutputWindow;
//g_OutputWindow.PrintLine("PAGE 5 REFRESH");


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern bool suspend_timers;
extern bool suspend_due_to_error;
static int CLOCK_UPDATE_TIMER_ID = 29;
static int InitControls = 1;
static int TIMER_ID = 0;



/////////////////////////////////////////////////////////////////////////////
// CPageSix1Dialog dialog


CPageSix1Dialog::CPageSix1Dialog(CWnd* pParent /*=NULL*/)
	: TStackedPage(CPageSix1Dialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPageSix1Dialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CPageSix1Dialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageSix1Dialog)
	DDX_Control(pDX, IDC_EDIT_HI, m_Edit_Hi);
	DDX_Control(pDX, IDC_EDIT_LO, m_Edit_Lo);
	DDX_Control(pDX, IDC_LED_LO_ALARM, m_Led_Lo_Alarm);
	DDX_Control(pDX, IDC_LED_HI_ALARM, m_Led_Hi_Alarm);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageSix1Dialog, CDialog)
	//{{AFX_MSG_MAP(CPageSix1Dialog)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_SETLO, OnSetlo)
	ON_BN_CLICKED(IDC_SETHI, OnSethi)
	ON_BN_CLICKED(IDC_CLRLO, OnClrlo)
	ON_BN_CLICKED(IDC_CLRHI, OnClrhi)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPageSix1Dialog message handlers

BOOL CPageSix1Dialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	g_OutputWindow.PrintLine("******** OnInitDialog Six1");
//	TIMER_ID = this->SetTimer(CLOCK_UPDATE_TIMER_ID,400,NULL);
	
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}



void CPageSix1Dialog::OnInit() 
{

	g_OutputWindow.PrintLine("******** OnInitDialog Six1");
	m_Led_Lo_Alarm.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);
	m_Led_Hi_Alarm.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);

	m_Edit_Lo.SetWindowText("0");
	m_Edit_Hi.SetWindowText("0");

}


static unsigned char lastseconds = 0;
static bool read_datahist_queued = false;
static int read_timeout = 0;
static DWORD tick;
static int read_page_status = STATUS_IDLE;
static unsigned char buffer[34];
static unsigned char page_start = 0;
static unsigned char page_end   = 0;
/*unsigned char ro_modify;
int Flag_RollOver = 0;
int Start_Pin_Enable = 0;
int Start_Software = 0;
unsigned char sample_rate = 1;*/
static int mission_stopped_event = STATUS_IDLE;
static bool bMission_In_Progress;
static bool bClearLo = false;
static bool bClearHi = false;
static unsigned char status_reg;

void CPageSix1Dialog::Refresh()  {
	// TODO: Add your control notification handler code here

	char str[128];
	int returnval;


	g_OutputWindow.PrintLine("******** Refresh Six1");
		//if (!read_datahist_queued) {
		returnval = Cmd_Process();
		if (returnval == CMD_SUSPEND) {
			return;
		}
		if (returnval == CMD_SHUTDOWN) {
			return;
		}
		//}
		if (read_page_status == STATUS_IDLE) {
			Cmd_Insert(CMD_READ_PAGE,buffer,&page_start,&page_end,NULL,&read_page_status);
		}
		if (read_page_status == STATUS_DONE) {
			    read_page_status = STATUS_IDLE;

				if (buffer[0x14] & 0x20) {
					bMission_In_Progress = true;
				} else bMission_In_Progress = false;

			// draw F and C temperature
				float temp1,temp2;
				float f1;
				CDC* ptrDC;

				f1 = (float)buffer[0x11];
				temp1 = ((float)0.5 * (float)f1) - (float)40.0;
				temp2 = ((float)1.8 * (float)temp1) + (float)32.0;
				CRect rc;
				rc.left  = 275-50;
				rc.right = 690-50;
				rc.top   = 145-50;
				rc.bottom = 270-50;
				ptrDC = GetDC();
				DrawTemp(ptrDC, rc,temp2,temp1);		
				ReleaseDC(ptrDC);

				sprintf(str,"%d C",((int)buffer[0x0B])/2  - 40);
				m_Edit_Lo.SetWindowText(str);
				sprintf(str,"%d C",((int)buffer[0x0C])/2 - 40);
				m_Edit_Hi.SetWindowText(str);

			// display lo threshold led
				if (buffer[0x14] & 0x04)
			      m_Led_Lo_Alarm.SetLed(CLed::LED_COLOR_RED,CLed::LED_ON,CLed::LED_ROUND);
				else
			      m_Led_Lo_Alarm.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);

			// display hi threshold led
				if (buffer[0x14] & 0x02)
			      m_Led_Hi_Alarm.SetLed(CLed::LED_COLOR_RED,CLed::LED_ON,CLed::LED_ROUND);
				else
			      m_Led_Hi_Alarm.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);

				if (bClearLo) {
					bClearLo = false;
					status_reg = buffer[0x14] & ~0x04;
					Cmd_Insert(CMD_STATUS_REGISTER,&status_reg,NULL,NULL,NULL,NULL);
				}
				if (bClearHi) {
					bClearHi = false;
					status_reg = buffer[0x14] & ~0x02;
					Cmd_Insert(CMD_STATUS_REGISTER,&status_reg,NULL,NULL,NULL,NULL);
				}
		}
		if ((!bMission_In_Progress) && (read_page_status == STATUS_IDLE)) {
			Cmd_Insert(CMD_READ_TEMPERATURE,NULL,NULL,NULL,NULL,NULL);
		}
}



void CPageSix1Dialog::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if (nIDEvent == CLOCK_UPDATE_TIMER_ID) {
		if (TStackedPage::IsPageActive()) {
			g_OutputWindow.PrintLine("******** IsPageActive = true Six1");
			Debug.Printf1("Page5 tick");
			#ifdef _DEBUG
			   _CrtDbgReport(_CRT_WARN,"rPageOneDialog.cpp",__LINE__,"Demo",":  %s\n","timer page five");
			#endif

			if (InitControls) {
				OnInit();
				InitControls = 0;
			} else {
				   if ((!suspend_timers) && (!suspend_due_to_error))
						Refresh();
			}
		}
		else 	g_OutputWindow.PrintLine("******** IsPageActive = FALSE Six1");

	}
	
	TStackedPage::OnTimer(nIDEvent);
}


static CFont*  m_pFont;				// text font on the tabs
static CFont*  m_pFont2;				// text font on the tabs


void CPageSix1Dialog::DrawTemp(CDC* pDC, CRect& rBoundingRect,float temp_f,float temp_c)
{
	char str[80];
	//save the DC so we can restore it
	int nSaveDC = pDC->SaveDC();

	// create font
	LOGFONT logfont;
    CFont*   pfontOld;   // pointer to old font
    CFont*   pfontOld2;   // pointer to old font
    if( m_pFont == NULL ) {                    // if no tab font, create one
		memset( &logfont, 0, sizeof( LOGFONT ) );
		logfont.lfHeight = 12;
		strcpy(logfont.lfFaceName,"MS Sans Serif"); 
		m_pFont = new CFont();
		m_pFont->CreateFontIndirect(&logfont); 
	}
    if( m_pFont2 == NULL ) {                    // if no tab font, create one
		memset( &logfont, 0, sizeof( LOGFONT ) );
		logfont.lfHeight = 48;
		strcpy(logfont.lfFaceName,"Times New Roman"); 
		m_pFont2 = new CFont();
		m_pFont2->CreateFontIndirect(&logfont); 
	}
    pfontOld = pDC->SelectObject( m_pFont );                   // select tab font

	CPen blackpen;
	blackpen.CreatePen (PS_INSIDEFRAME, 1, RGB(0,0,0));
	CPen whitepen;
	whitepen.CreatePen (PS_INSIDEFRAME, 1, RGB(255,255,255));
	CPen pen;
	CPen* pPrevPen = pDC->SelectObject(&pen);

	// draw border	

	CBrush brush;
	brush.CreateSolidBrush(RGB(192,192,192));

	//save the current brush
	CBrush* oldBrush;
	oldBrush = pDC->SelectObject(&brush);

	CRect column;
	//draw the rectangle for the column

    pfontOld2 = pDC->SelectObject( m_pFont2 );                  // select tab font
	pDC->SetTextColor(RGB(0,0,0));
	pDC->SetBkColor(RGB(192,192,192));

	// display temperature
	sprintf(str," %3.1f F  ",temp_f);
	pDC->TextOut(rBoundingRect.left+4,
				rBoundingRect.top+4,
				str);

	sprintf(str," %3.1f C  ",temp_c);
	pDC->TextOut(rBoundingRect.left+4,
				rBoundingRect.top+4+50,
				str);

    pDC->SelectObject( m_pFont );                   // select tab font


	// figure out the starting date to begin cal
	if(oldBrush)
	{
		pDC->SelectObject(oldBrush);
	}

	if(pPrevPen)
	{
		pDC->SelectObject(pPrevPen);
	}

    pDC->SelectObject( pfontOld );         // select old font


	return;


	if (nSaveDC > 0)
	{
		pDC->RestoreDC(nSaveDC);
	}
	return;
}	
	

void CPageSix1Dialog::OnSetlo() 
{
	static unsigned char addr = 0x0B;
	static unsigned char lo;

	if (bMission_In_Progress) {
		MessageBox("Mission In Progress!  Action Cannot be Completed.","Set Threshold",MB_ICONSTOP);
		return;
	}
	CThresholdDlg ThresholdDlg;
	ThresholdDlg.DoModal();
	lo = (unsigned char)((ThresholdDlg.temperature + 40) * 2);
	Cmd_Insert(CMD_WRITE_REGISTER,&addr,&lo,NULL,NULL,NULL);
}

void CPageSix1Dialog::OnSethi() 
{
	static unsigned char addr = 0x0C;
	static unsigned char hi;

	if (bMission_In_Progress) {
		MessageBox("Mission In Progress!  Action Cannot be Completed.","Set Threshold",MB_ICONSTOP);
		return;
	}
	CThresholdDlg ThresholdDlg;
	ThresholdDlg.DoModal();
	hi = (unsigned char)((ThresholdDlg.temperature + 40) * 2);
	Cmd_Insert(CMD_WRITE_REGISTER,&addr,&hi,NULL,NULL,NULL);
}

void CPageSix1Dialog::OnClrlo() 
{
	bClearLo = true;
}

void CPageSix1Dialog::OnClrhi() 
{
	bClearHi = true;
}







