// PageTenDialog.cpp : implementation file
//
/*
  This Evaluation kit software is available free of charge and can be used,
  edited, or reproduced as you see fit. Dallas Semiconductor does not
  assume any liability for the accuracy or correctness of this code.

  It is free to use at your own risk.
  */

#include "stdafx.h"
#include "Sample.h"
#include "PageTenDialog.h"
#include "DS1678.h"
#include "DS1615io.h"
#include "Serial.h"
#include "Cmd_Pipe.h"
#include "datetimecls.h"
#include "SetAlarmDlg.h"

#include "OutputWindow.h"
COutputWindow g_OutputWindow;


#include <assert.h>

#include "Cdebug.h"
extern CDebug Debug;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern bool suspend_timers;
extern bool suspend_due_to_error;
static int ADC_UPDATE_TIMER_ID = 30;
static int TIMER_ID = 0;
static int InitControls = 1;

extern bool auto_poll;
#define READFROM_KEY  1
#define READFROM_FILE 2
extern int datasource;
/////////////////////////////////////////////////////////////////////////////
// CPageTenDialog dialog


CPageTenDialog::CPageTenDialog(CWnd* pParent /*=NULL*/)
	: TStackedPage(CPageTenDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPageTenDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CPageTenDialog::DoDataExchange(CDataExchange* pDX)
{
	TStackedPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageTenDialog)
	DDX_Control(pDX, IDC_LED_ALARM1, m_Led_Alarm1);
	DDX_Control(pDX, IDC_LED_ALARM2, m_Led_Alarm2);
	DDX_Control(pDX, IDC_LED_ALARM3, m_Led_Alarm3);
	DDX_Control(pDX, IDC_LED_ALARM4, m_Led_Alarm4);
	DDX_Control(pDX, IDC_LED_ALARM5, m_Led_Alarm5);
	DDX_Control(pDX, IDC_LED_ALARM6, m_Led_Alarm6);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageTenDialog, TStackedPage)
	//{{AFX_MSG_MAP(CPageTenDialog)
	ON_WM_TIMER()
	ON_WM_KILLFOCUS()
	ON_BN_CLICKED(IDC_EDIT_VOLTAGE, OnEditVoltage)
	ON_BN_CLICKED(IDC_CLRALARMS, OnClralarms)
	ON_WM_CANCELMODE()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


static unsigned char lastseconds = 0;
static bool read_datahist_queued = false;
static int read_timeout = 0;
static DWORD tick;
static int read_page_status = STATUS_IDLE;

static unsigned char buffer0[34];
static unsigned char page_start0 = 0;
static unsigned char page_end0   = 0;

static unsigned char buffer1[34];
static unsigned char page_start1 = 1;
static unsigned char page_end1   = 1;

/*unsigned char ro_modify;
int Flag_RollOver = 0;
int Start_Pin_Enable = 0;
int Start_Software = 0;
unsigned char sample_rate = 1;*/
static int mission_stopped_event = STATUS_IDLE;
static bool bMission_In_Progress;
static SYSTEMTIME SystemTime;
static unsigned char status_reg;

float running = 0.0;
int reentry = 0;

void CPageTenDialog::Refresh()  {
	// TODO: Add your control notification handler code here

	char str[128];
	int returnval;

	g_OutputWindow.PrintLine("Refresh");

	//if (!read_datahist_queued) {
	returnval = Cmd_Process();
	if (returnval == CMD_SUSPEND) {
		return;
	}
	if (returnval == CMD_SHUTDOWN) {
		return;
	}
	//}
	if (read_page_status == STATUS_IDLE) {
		g_OutputWindow.PrintLine("Cmd_Insert");
		// read page 0 control
		Cmd_Insert(CMD_READ_PAGE,buffer0,&page_start0,&page_end0,NULL,NULL);
		// read page 1 for DS1616 functions
		Cmd_Insert(CMD_READ_PAGE,buffer1,&page_start1,&page_end1,NULL,&read_page_status);
		reentry = 0;
	}
	if (read_page_status == STATUS_DONE) {
		g_OutputWindow.PrintLine("STATUS_DONE");
		reentry++;
		if (reentry != 1) AfxMessageBox("Error");
		assert(reentry == 1);
	  // display alarm flag leds
		if (buffer0[0x14] & 0x20) {
			bMission_In_Progress = true;
		} else bMission_In_Progress = false;

		if (buffer1[0x0A] & 0x20) {
			m_Led_Alarm1.SetLed(CLed::LED_COLOR_RED,CLed::LED_ON,CLed::LED_ROUND);
		} else {
			m_Led_Alarm1.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);
		}

		if (buffer1[0x0A] & 0x40) {
			m_Led_Alarm2.SetLed(CLed::LED_COLOR_RED,CLed::LED_ON,CLed::LED_ROUND);
		} else {
			m_Led_Alarm2.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);
		}

		if (buffer1[0x0A] & 0x08) {
			m_Led_Alarm3.SetLed(CLed::LED_COLOR_RED,CLed::LED_ON,CLed::LED_ROUND);
		} else {
			m_Led_Alarm3.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);
		}

		if (buffer1[0x0A] & 0x10) {
			m_Led_Alarm4.SetLed(CLed::LED_COLOR_RED,CLed::LED_ON,CLed::LED_ROUND);
		} else {
			m_Led_Alarm4.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);
		}

		if (buffer1[0x0A] & 0x02) {
			m_Led_Alarm5.SetLed(CLed::LED_COLOR_RED,CLed::LED_ON,CLed::LED_ROUND);
		} else {
			m_Led_Alarm5.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);
		}

		if (buffer1[0x0A] & 0x04) {
			m_Led_Alarm6.SetLed(CLed::LED_COLOR_RED,CLed::LED_ON,CLed::LED_ROUND);
		} else {
			m_Led_Alarm6.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);
		}

	  // display text thresholds in edit boxes
		sprintf(str,"%1.3f V",(float)buffer1[0x04] * 0.008);
		GetDlgItem(IDC_EDIT1)->SetWindowText(str);		
		sprintf(str,"%1.3f V",(float)buffer1[0x03] * 0.008);
		GetDlgItem(IDC_EDIT2)->SetWindowText(str);		
		sprintf(str,"%1.3f V",(float)buffer1[0x06] * 0.008);
		GetDlgItem(IDC_EDIT3)->SetWindowText(str);		
		sprintf(str,"%1.3f V",(float)buffer1[0x05] * 0.008);
		GetDlgItem(IDC_EDIT4)->SetWindowText(str);		
		sprintf(str,"%1.3f V",(float)buffer1[0x08] * 0.008);
		GetDlgItem(IDC_EDIT5)->SetWindowText(str);		
		sprintf(str,"%1.3f V",(float)buffer1[0x07] * 0.008);
		GetDlgItem(IDC_EDIT6)->SetWindowText(str);		


	  // display real time ADC voltages
		CRect rc;
		CDC* ptrDC;
		float voltage;
		ptrDC = GetDC();

		voltage = (float)buffer1[0x00] * 0.008;
		sprintf(str,"V1 %f",voltage);
		g_OutputWindow.PrintLine(str);
		rc.left  = 60;
		rc.top   = 50;
		DrawVoltage(ptrDC, rc,voltage);		
		voltage = (float)buffer1[0x01] * 0.008;
		rc.left  = 60+170;
		rc.top   = 50;
		DrawVoltage(ptrDC, rc,voltage);		
		voltage = (float)buffer1[0x02] * 0.008;
//		voltage = running+=0.001;
		rc.left  = 60+335;
		rc.top   = 50;
		DrawVoltage(ptrDC, rc,voltage);		

		ReleaseDC(ptrDC);

		read_page_status = STATUS_IDLE;


	}

	if ((!bMission_In_Progress) && (read_page_status == STATUS_IDLE)) {
		Cmd_Insert(CMD_READ_TEMPERATURE,NULL,NULL,NULL,NULL,NULL);
	}
}


static CFont*  m_pFont;				// text font on the tabs
static CFont*  m_pFont2;				// text font on the tabs


void CPageTenDialog::DrawVoltage(CDC* pDC, CRect& rBoundingRect,float voltage)
{
	char str[80];
	//save the DC so we can restore it
	int nSaveDC = pDC->SaveDC();

	// create font
	LOGFONT logfont;
    CFont*   pfontOld;   // pointer to old font
    CFont*   pfontOld2;   // pointer to old font
    if( m_pFont == NULL ) {                    // if no tab font, create one
		memset( &logfont, 0, sizeof( LOGFONT ) );
		logfont.lfHeight = 12;
		strcpy(logfont.lfFaceName,"MS Sans Serif"); 
		m_pFont = new CFont();
		m_pFont->CreateFontIndirect(&logfont); 
	}
    if( m_pFont2 == NULL ) {                    // if no tab font, create one
		memset( &logfont, 0, sizeof( LOGFONT ) );
		logfont.lfHeight = 38;
		strcpy(logfont.lfFaceName,"Times New Roman"); 
		m_pFont2 = new CFont();
		m_pFont2->CreateFontIndirect(&logfont); 
	}
    pfontOld = pDC->SelectObject( m_pFont );                   // select tab font

	CPen blackpen;
	blackpen.CreatePen (PS_INSIDEFRAME, 1, RGB(0,0,0));
	CPen whitepen;
	whitepen.CreatePen (PS_INSIDEFRAME, 1, RGB(255,255,255));
	CPen pen;
	CPen* pPrevPen = pDC->SelectObject(&pen);

	// draw border	

	CBrush brush;
	brush.CreateSolidBrush(RGB(192,192,192));

	//save the current brush
	CBrush* oldBrush;
	oldBrush = pDC->SelectObject(&brush);

	CRect column;
	//draw the rectangle for the column

    pfontOld2 = pDC->SelectObject( m_pFont2 );                  // select tab font
	pDC->SetTextColor(RGB(0,0,0));
	pDC->SetBkColor(RGB(192,192,192));

	// display voltage
	sprintf(str," %1.3f V  ",voltage);
	pDC->TextOut(rBoundingRect.left+4,
				rBoundingRect.top+4,
				str);

/*	sprintf(str," %3.1f C  ",temp_c);
	pDC->TextOut(rBoundingRect.left+4,
				rBoundingRect.top+4+30,
				str);
*/
    pDC->SelectObject( m_pFont );                   // select tab font


	// figure out the starting date to begin cal
	if(oldBrush)
	{
		pDC->SelectObject(oldBrush);
	}

	if(pPrevPen)
	{
		pDC->SelectObject(pPrevPen);
	}

    pDC->SelectObject( pfontOld );         // select old font


	return;


	if (nSaveDC > 0)
	{
		pDC->RestoreDC(nSaveDC);
	}
	return;
}	




/////////////////////////////////////////////////////////////////////////////
// CPageTenDialog message handlers


BOOL CPageTenDialog::OnInitDialog() 
{
	TStackedPage::OnInitDialog();
	

	m_Led_Alarm1.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);
	m_Led_Alarm2.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);
	m_Led_Alarm3.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);
	m_Led_Alarm4.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);
	m_Led_Alarm5.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);
	m_Led_Alarm6.SetLed(CLed::LED_COLOR_RED,CLed::LED_OFF,CLed::LED_ROUND);


	TIMER_ID = this->SetTimer(ADC_UPDATE_TIMER_ID,100,NULL);


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CPageTenDialog::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if (nIDEvent == ADC_UPDATE_TIMER_ID) {
		if (TStackedPage::IsPageActive()) {
			Debug.Printf1("Page1 tick");
			#ifdef _DEBUG
			   _CrtDbgReport(_CRT_WARN,"rPageTenDialog.cpp",__LINE__,"Demo",":  %s\n","timer page one");
			#endif

			if (InitControls) {
				//OnButton1();
				InitControls = 0;
			} else {
				   if ((!suspend_timers) && (!suspend_due_to_error))
					  Refresh();
			}
		}
	}
		// CGCColorStatic::OnTimer(nIDEvent);

	// If we are here then the current timer event is the clock's update event.	
	TStackedPage::OnTimer(nIDEvent);
}

void CPageTenDialog::OnKillFocus(CWnd* pNewWnd) 
{
	TStackedPage::OnKillFocus(pNewWnd);
}

void CPageTenDialog::OnKillActive(void) {
	TStackedPage::OnKillActive();
	Debug.Printf1("Page1 OnKillActive");
}

void CPageTenDialog::OnSetActive(void) {
	TStackedPage::OnSetActive();
}

unsigned char csaddr[10];
unsigned char adc_threshold[10];

void CPageTenDialog::OnEditVoltage() 
{
//	int val;
//	unsigned char data;
//	char str[20];
	int nResponse;

	if (bMission_In_Progress) {
		MessageBox("Mission In Progress!  Action Cannot be Completed.","Set Threshold",MB_ICONSTOP);
		return;
	}
	
	CVoltage_Dlg Dlg;
	Dlg.Set_Var_Pointer(adc_threshold);
	nResponse = Dlg.DoModal();
	if (nResponse == IDOK) {
		csaddr[0] = 0x24;
		Cmd_Insert(CMD_WRITE_REGISTER,&csaddr[0],&adc_threshold[0],NULL,NULL,NULL);
		csaddr[1] = 0x23;
		Cmd_Insert(CMD_WRITE_REGISTER,&csaddr[1],&adc_threshold[1],NULL,NULL,NULL);
		csaddr[2] = 0x26;
		Cmd_Insert(CMD_WRITE_REGISTER,&csaddr[2],&adc_threshold[2],NULL,NULL,NULL);
		csaddr[3] = 0x25;
		Cmd_Insert(CMD_WRITE_REGISTER,&csaddr[3],&adc_threshold[3],NULL,NULL,NULL);
		csaddr[4] = 0x28;
		Cmd_Insert(CMD_WRITE_REGISTER,&csaddr[4],&adc_threshold[4],NULL,NULL,NULL);
		csaddr[5] = 0x27;
		Cmd_Insert(CMD_WRITE_REGISTER,&csaddr[5],&adc_threshold[5],NULL,NULL,NULL);
	}
	return;	
}

void CPageTenDialog::OnClralarms() 
{
	if (bMission_In_Progress) {
		MessageBox("Mission In Progress!  Action Cannot be Completed.","Clear Alarms",MB_ICONSTOP);
		return;
	}
	adc_threshold[0] = 0x00;
	csaddr[0] = 0x2A;
	Cmd_Insert(CMD_WRITE_REGISTER,&csaddr[0],&adc_threshold[0],NULL,NULL,NULL);

}

void CPageTenDialog::OnButton1() 
{
	// TODO: Add your control notification handler code here
	RECT rect;
	rect.left = 10;
	rect.top  = 10;
	rect.right  = 300;
	rect.bottom = 300;
	g_OutputWindow.CreateOutputWindow((HINSTANCE)AfxGetInstanceHandle(),(HWND)AfxGetMainWnd()->m_hWnd,&rect);
	g_OutputWindow.ShowOutputWindow(true);
	g_OutputWindow.PrintLine("This is a test");
//	AfxMessageBox("test");
}

