// PageTwoDialog.cpp : implementation file
//
/*
  This Evaluation kit software is available free of charge and can be used,
  edited, or reproduced as you see fit. Dallas Semiconductor does not
  assume any liability for the accuracy or correctness of this code.

  It is free to use at your own risk.
  */

#include "stdafx.h"
#include "sample.h"
#include "PageTwoDialog.h"
#include "DS1678.h"
#include "Progress.h"
#include "Cdebug.h"
extern CDebug Debug;
#include "Cmd_Pipe.h"
#include "DS1615io.h"
#include "Common.h"
#include "PrintInformation.h"
#include "PrintDlg.h"
#include "TextPrint.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern bool suspend_timers;
extern bool suspend_due_to_error;

bool alarm_log;
extern bool auto_poll;
#define READFROM_KEY  1
#define READFROM_FILE 2
extern int datasource;
/////////////////////////////////////////////////////////////////////////////
// CPageTwoDialog dialog


CPageTwoDialog::CPageTwoDialog(CWnd* pParent /*=NULL*/)
	: TStackedPage(CPageTwoDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPageTwoDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CPageTwoDialog::DoDataExchange(CDataExchange* pDX)
{
	TStackedPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageTwoDialog)
	DDX_Control(pDX, IDC_LIST2, m_List2);
	DDX_Control(pDX, IDC_LIST, m_List);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageTwoDialog, TStackedPage)
	//{{AFX_MSG_MAP(CPageTwoDialog)
	ON_BN_CLICKED(IDC_DOWNLOAD, OnDownload)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_SAVETOFILE, OnSavetofile)
	ON_BN_CLICKED(IDC_PRINT, OnPrint)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


unsigned int data[2048];

/////////////////////////////////////////////////////////////////////////////
// CPageTwoDialog message handlers

char *colstr[] = {
  "Alarm #",
  "Date and Time Stamp",
  "Duration"
//  "Absolute Time"
};

int colwidth[] = {
  60,
  280,
  100,
  120
};

static int CLOCK_UPDATE_TIMER_ID = 32;
static int TIMER_ID = 0;
BOOL viewupdated;


BOOL CPageTwoDialog::OnInitDialog() 
{
	int i;
	for (i = 0; i < 2048; i++) data[i] = 0;
	data[1000] = 256;

	TStackedPage::OnInitDialog();

	
      TCHAR szBuf[128];
      LV_COLUMN lvc;
      for ( i = 0; i < 3; i++ )
      {
         wsprintf( szBuf, "%s", colstr[i]);
         lvc.mask     = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
         lvc.fmt      = LVCFMT_CENTER;
         lvc.pszText  = szBuf;
         lvc.iSubItem = i;         
         lvc.cx       = colwidth[i];
         m_List.InsertColumn( i, &lvc );
         m_List2.InsertColumn( i, &lvc );
      }

      // Will now insert the items and subitems into the list view.
      LV_ITEM lvItem;

      for ( int j = 0; j < 3; j++ )      
         for ( i = 0; i < 12; i++ )      
         {
//            wsprintf( szBuf, "%d, %d", i, j );
			switch (j) {
				case 0: wsprintf( szBuf, " "); break;
				case 1: wsprintf( szBuf, " "); break;
				case 2: wsprintf( szBuf, " "); break;
			}
            UINT nItem = 0;
            lvItem.mask = LVIF_TEXT | LVIF_IMAGE;
            lvItem.iItem = i;      
            lvItem.iSubItem = j;
            lvItem.iImage   = 3;
            lvItem.pszText = szBuf; 
            if ( !j ) {
               m_List.InsertItem( &lvItem );
               m_List2.InsertItem( &lvItem );
			}
            else {
               m_List.SetItem( &lvItem );            
               m_List2.SetItem( &lvItem );            
			}
         }


TIMER_ID = this->SetTimer(CLOCK_UPDATE_TIMER_ID,100,NULL);
viewupdated = FALSE;

/*
	// TODO: Add extra initialization here
	m_List.InsertColumn(0, "Event #");
	m_List.SetColumnWidth( 0, 50 );
//clistctl
  for (i = 0; i < 1024; i ++) {
	sprintf(str,"%d",i);
	m_List.InsertItem(i, str);
  }




    m_List.InsertColumn(1, "Hex Value");
	m_List.SetColumnWidth( 1, 100 );
  for (i = 0; i < 1024; i ++) {
	sprintf(str,"%04X",data[i]);
	m_List.SetItemText(i, 1, str);  
  }


    m_List.InsertColumn(2, "Elapsed Time");
	m_List.SetColumnWidth( 1, 100 );
  for (i = 0; i < 1024; i ++) {
	//sprintf(str,"%04X",data[i]);
	m_List.SetItemText(i, 2, "0 Seconds");  
  }
*/


//  m_List.InsertItem(1, "Test item 2");
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


#define SEC  0
#define MIN  1
#define HOUR 2

COleDateTimeSpan TicksToSpan(int mode,unsigned short ticks) {

  double dday = 0;
  COleDateTimeSpan day(dday);

  switch (mode) {
    case SEC: dday = (double)ticks / ((double)60.0 * (double)60.0 * (double)24.0);
			  day = dday;
			  return day;
			break;
    case MIN: dday = (double)ticks / ((double)60.0 * (double)24.0);
			  day = dday;
			  return day;
			break;
    case HOUR: dday = (double)ticks / (double)24.0;
			   day = dday;
			   return day;
			break;
  }

  return day;
}


unsigned char logdata[2048];

void CPageTwoDialog::OnDownload() 
{
	// TODO: Add your control notification handler code here
      //for ( int j = 0; j < 6; j++ )    
/*InitProgressThread();


CProgress Progress;
Progress.DoModal();

Refresh();


AfxMessageBox("test");
AfxMessageBox("test");
Sleep(10000);

unsigned short *wpdata;
COleDateTimeSpan date;

//DS1678ReadLogMemory(logdata);
wpdata = (unsigned short *)logdata;

SYSTEMTIME stamp;
GetDS1678StampTime(&stamp);
COleDateTime start(stamp.wYear, stamp.wMonth,  stamp.wDay, 
				   stamp.wHour, stamp.wMinute, stamp.wSecond );

      LV_ITEM lvItem;
      TCHAR szBuf[128];
      LV_COLUMN lvc;

	int j = 0;
	int i;
         for ( i = 0; i < 1024; i++ )      
         {
			// display event number
            wsprintf( szBuf, "%4d", i);
            UINT nItem = 0;
            lvItem.mask = LVIF_TEXT | LVIF_IMAGE;
            lvItem.iItem = i;      
            lvItem.iSubItem = j + 0; // column
            lvItem.iImage   = 3;
            lvItem.pszText = szBuf; 
            //if ( !j )
            //   m_List.InsertItem( &lvItem );
            //else
               m_List.SetItem( &lvItem ); 

			// display raw event hex value
            wsprintf( szBuf, "%04X", wpdata[i]);
            nItem = 0;
            lvItem.mask = LVIF_TEXT | LVIF_IMAGE;
            lvItem.iItem = i;      
            lvItem.iSubItem = j + 1; // column
            lvItem.iImage   = 3;
            lvItem.pszText = szBuf; 
            //if ( !j )
            //   m_List.InsertItem( &lvItem );
            //else
               m_List.SetItem( &lvItem ); 

			// display relative date and time value
			date = TicksToSpan(SEC,wpdata[i]);
            wsprintf( szBuf, "%lud %02lu:%02lu:%02lu", date.GetDays(),date.GetHours(),date.GetMinutes(),date.GetSeconds());
            nItem = 0;
            lvItem.mask = LVIF_TEXT | LVIF_IMAGE;
            lvItem.iItem = i;      
            lvItem.iSubItem = j + 2; // column
            lvItem.iImage   = 3;
            lvItem.pszText = szBuf; 
            //if ( !j )
            //   m_List.InsertItem( &lvItem );
            //else
               m_List.SetItem( &lvItem ); 
			   
			// display absolute date and time value based on start date
			start = start + date;
            wsprintf( szBuf, "%2lu/%2lu/%lu %02lu:%02lu:%02lu", start.GetMonth(),start.GetDay(),start.GetYear(),start.GetHour(),start.GetMinute(),start.GetSecond());
            nItem = 0;
            lvItem.mask = LVIF_TEXT | LVIF_IMAGE;
            lvItem.iItem = i;      
            lvItem.iSubItem = j + 3; // column
            lvItem.iImage   = 3;
            lvItem.pszText = szBuf; 
            //if ( !j )
            //   m_List.InsertItem( &lvItem );
            //else
               m_List.SetItem( &lvItem ); 
			   


         }
*/
}


unsigned long AlarmStampToLong(unsigned char *buffer) {

	long val,l1,l2,l3;

	l1 =  (unsigned long)buffer[0];
	l2 =  (unsigned long)buffer[1];
	l3 =  (unsigned long)buffer[2];
	val = l3 * 0x00010000L + l2 * 0x00000100L + l1;
	return val;
}

void DurationToString(unsigned char d,char *str) {
	int days,hours,minutes;
	int duration = (int)d;
	days = duration / (60 * 24);
	hours = (duration - (60 * 24 * days)) / 60;
	minutes = duration - (60 * 24 * days) - (hours * 60);
	sprintf(str,"%03dd %02dh %02dm",days,hours,minutes);
	char str2[256];
	sprintf(str2,"%02X %d %d %d",d,days,hours,minutes);
	Debug.Printf0(str2);
}

static struct PrintInfoStruct {
	long totalsamples;
	long missionsamples;
	SYSTEMTIME timestamp;
	SYSTEMTIME currenttime;
	char serialnumber[64];
	char usermemory_string[36];

	unsigned int sample_rate;
	char cursor_datetime[64];
	char cursor_temperature[16];
	char range_lowest[32],range_highest[32];
	char threshold_lo[32],threshold_hi[32];
	bool alarm_lo,alarm_hi;
	bool rollover;
	// temperature alarm...
} PrintInfo;

void CPageTwoDialog::SaveFileHeaderInfo(FILE *outfile,unsigned char *buffer,unsigned char *log_buffer) {
	int samprate,temp,roll,offset=0;
	int TLF,THF;
	float degrees,tlow,thigh;
	char str[64];
	long fsample = 0;;
	ldiv_t div_result;
	char temp_scale = 'F';

	long samples = DS1615BufferToCurrentSample(buffer);
	
	roll = buffer[0x0E] & 0x08;

	sprintf(str,"%02X/%02X/%02X %02X:%02X",
			  (int)buffer[0x18],
			  (int)buffer[0x17],
			  (int)buffer[0x19],
			  (int)buffer[0x16],
			  (int)buffer[0x15]);

	samprate = int(buffer[0x0d]);
	temp = int(buffer[0x0b]);
	degrees = ((float)0.5 * (float)temp) - (float)40.0;
	if (temp_scale == 'F')
		degrees = ((float)1.8 * (float)degrees) + (float)32.0;
	tlow = degrees;
	temp = int(buffer[0x0c]);
	degrees = ((float)0.5 * (float)temp) - (float)40.0;
	if (temp_scale == 'F')
		degrees = ((float)1.8 * (float)degrees) + (float)32.0;
	thigh = degrees;
	TLF = (buffer[0x14] & 0x04) >> 2;
	THF = (buffer[0x14] & 0x02) >> 1;

	if (samples > 2048 && roll == 0x08)
	{
		fsample = samples - long(2048);
		div_result = ldiv(samples, (long)2048);
		offset = (int)(samples - (div_result.quot * (long)2048));
	}
	if (samples <= 2048 || roll != 0x08)
	{
		if (samples > 2048 && roll != 0x08)
			samples = 2048;

		fprintf(outfile,"%ld, %d, %s, %.1f, %.1f, %d, %d, %c, %s\n",samples,samprate,str,tlow,thigh,TLF,THF,temp_scale,PrintInfo.usermemory_string);
	}
	else
	{
		samples = 2048;
		fprintf(outfile,"%ld, %d, %s, %.1f, %.1f, %d, %d, %c, %s\n",samples,samprate,str,tlow,thigh,TLF,THF,temp_scale,PrintInfo.usermemory_string);
	}
}



static unsigned char lastseconds = 0;
static bool read_datahist_queued = false;
static int read_timeout = 0;
static DWORD tick;
static int read_page_status = STATUS_IDLE;
static int page_processed = -1;
static unsigned char buffer[3000];
static unsigned char page_start = 17;
static unsigned char page_end   = 19;
static unsigned char page0_buffer[64];
static unsigned char page0_start = 0;
static unsigned char page0_end   = 0;

/*unsigned char ro_modify;
int Flag_RollOver = 0;
int Start_Pin_Enable = 0;
int Start_Software = 0;
unsigned char sample_rate = 1;*/
static int mission_stopped_event = STATUS_IDLE;
static char temp_scale = 'F';
static char filename[128];
static bool bsave_file = false;
static bool read_datalog = false;
int tt = 0;

static unsigned char user_page_start = 2;
static unsigned char user_page_end   = 2;
// define static vars for serial number
static unsigned char sn_page_start = 16;
static unsigned char sn_page_end = 16;
static unsigned char sn_buffer[34];
CString AlarmStr[64];
int AlarmStrNum;

void CPageTwoDialog::Refresh()  {
	// TODO: Add your control notification handler code here

	int returnval;
	char str[256];

//		if (!auto_poll && datasource == READFROM_KEY)
//			return;

		//if (!read_datahist_queued) {
		returnval = Cmd_Process();
		if (returnval == CMD_SUSPEND) {
			return;
		}
		if (returnval == CMD_SHUTDOWN) {
			return;
		}
		//}
		if (read_datalog == true) {
			if (read_page_status == STATUS_IDLE) {
				page_processed = -1;  // init this var for our progress control
				// firat read page 0 so that we can get the number of samples recorded
				Cmd_Insert(CMD_READ_PAGE,page0_buffer,&page0_start,&page0_end,NULL,NULL);
				// get the user memory
				Cmd_Insert(CMD_READ_PAGE,PrintInfo.usermemory_string,&user_page_start,&user_page_end,NULL,NULL);
				// read the page with the serial number
				Cmd_Insert(CMD_READ_PAGE,sn_buffer,&sn_page_start,&sn_page_end,NULL,NULL);
				// next queue a datalog read
				Cmd_Insert(CMD_READ_PAGE,buffer,&page_start,&page_end,&page_processed,&read_page_status);
				read_datalog = false;
			}
		}
		// if a read is queued then show progress
/*		if (read_page_status == STATUS_QUEUED) {
			if (page_processed != -1) {
				m_DataLog_Progress.SetPos((page_processed - 128) + 1);
			} else {
				m_DataLog_Progress.SetPos(0);
			}
		}*/
		if (read_page_status == STATUS_DONE) {
			    read_page_status = STATUS_IDLE;


		// PRINT STUFF BEGIN
			// setup print info in-case the user wants to print the plot
				unsigned long current;
				current = DS1615BufferToCurrentSample(page0_buffer);
				PrintInfo.missionsamples = current;
				DS1615BufferToTimeStamp(page0_buffer,&PrintInfo.timestamp);
				PrintInfo.totalsamples = DS1615BufferToTotalSamples(page0_buffer);
				DS1615BufferToCurrentTime(page0_buffer,&PrintInfo.currenttime);	
			// get alarm info for printout
				if (page0_buffer[0x14] & 0x04)
					PrintInfo.alarm_lo = true;
				else
					PrintInfo.alarm_lo = false;
				if (page0_buffer[0x14] & 0x02)
					PrintInfo.alarm_hi = true;
				else
					PrintInfo.alarm_hi = false;

			// get threshold hi / lo info for printout
				float temp1,temp2,f1;
				f1 = (float)page0_buffer[0x0B];
				temp1 = ((float)0.5 * (float)f1) - (float)40.0;
				temp2 = ((float)1.8 * (float)temp1) + (float)32.0;
				sprintf(PrintInfo.threshold_lo,"%.1fC / %.1fF",temp1,temp2);
				f1 = (float)page0_buffer[0x0C];
				temp1 = ((float)0.5 * (float)f1) - (float)40.0;
				temp2 = ((float)1.8 * (float)temp1) + (float)32.0;
				sprintf(PrintInfo.threshold_hi,"%.1fC / %.1fF",temp1,temp2);

		    // get sample rate info
				PrintInfo.sample_rate = DS1615BufferToSampleRate(page0_buffer);
			// make sure the user string data is zero-terminated
				PrintInfo.usermemory_string[32] = 0;

			// get the serial number
				char temp[8];
				PrintInfo.serialnumber[0] = 0;
				for (int s = 0; s < 8; s++) {
					sprintf(temp,"%02X ",sn_buffer[24 + s]);
					strcat(PrintInfo.serialnumber,temp);
				}
		// PRINT STUFF END


		  // draw F and C temperature
			float temphi1,temphi2;
			float templo1,templo2;
			CDC* ptrDC;

			f1 = (float)page0_buffer[0x0C];
			temphi1 = ((float)0.5 * (float)f1) - (float)40.0;
			temphi2 = ((float)1.8 * (float)temphi1) + (float)32.0;
			f1 = (float)page0_buffer[0x0B];
			templo1 = ((float)0.5 * (float)f1) - (float)40.0;
			templo2 = ((float)1.8 * (float)templo1) + (float)32.0;
			CRect rc;
			ptrDC = GetDC();
			rc.left  = 0;
			rc.top   = 135;
			DrawTemp(ptrDC, rc,temphi2,temphi1);
			rc.left  = 0;
			rc.top   = 340;
			DrawTemp(ptrDC, rc,templo2,templo1);
			ReleaseDC(ptrDC);

		  // update high and low tables
			LV_ITEM lvItem;
			int i,j;
			TCHAR szBuf[128];

			COleDateTimeSpan date;
			SYSTEMTIME stamp;
			DS1615BufferToTimeStamp(page0_buffer,&stamp);
			COleDateTime start(stamp.wYear, stamp.wMonth,  stamp.wDay, 
			   stamp.wHour, stamp.wMinute, stamp.wSecond );
			COleDateTime end;
			int hour24to12[24] = { 12,1,2,3,4,5,6,7,8,9,10,11,12,1,2,3,4,5,6,7,8,9,10,11 };
			unsigned long sample;

			FILE *outfile;
			if (bsave_file) {
				outfile = fopen(filename,"wt");
				SaveFileHeaderInfo(outfile,page0_buffer,buffer);
				fprintf(outfile,"\nHigh Threshold Time Stamps and Durations:\n");
			}
			AlarmStrNum = 0;
			AlarmStr[AlarmStrNum++] = "";
			AlarmStr[AlarmStrNum++] = "High Threshold Time Stamps and Durations:";
			sprintf(str,"High Threshold = %s",PrintInfo.threshold_hi);
			AlarmStr[AlarmStrNum++] = str;
			AlarmStr[AlarmStrNum++] = "";
			AlarmStr[AlarmStrNum++] = "       #               Date Time                  Duration";
			AlarmStr[AlarmStrNum++] = "";
			char fullstr[128];
			// display event number
			for (i = 0; i < 12; i++) {
				fullstr[0] = 0;
				for (j = 0; j < 3; j++) {
				  // update high temp alarm table
					sample = AlarmStampToLong(&buffer[(i + 12) * 4]);
					// subtract one sample time from alarm stamp... (current sample at t=0 starts
					//   out at current sample = 1, so current sample = 1 is at the start stamp
					if (sample >= 1) sample -= DS1615BufferToSampleRate(page0_buffer);
					switch (j) {
						case 0: wsprintf( szBuf, "      %02d",i+1); break;
						case 1: 
								if (sample == 0) {
									sprintf( szBuf,"    ");
									break;
								}
								date = TicksToSpan(MIN,sample * 
									DS1615BufferToSampleRate(page0_buffer));
								end = start + date;
								sprintf( szBuf, "%02lu/%02lu/%lu %02lu:%02lu:%02lu%s",
									end.GetMonth(),end.GetDay(),end.GetYear(),
									hour24to12[end.GetHour()],end.GetMinute(),
									end.GetSecond(),(end.GetHour()<12)?"am":"pm");
							break;
						case 2: 
							if (sample == 0) {
								sprintf( szBuf,"   ");
								break;
							}
									char str2[256];
									sprintf(str2,"index = %02d",i + 12);
									Debug.Printf0(str2);
							DurationToString(buffer[((i + 12) * 4) + 3] * 
									DS1615BufferToSampleRate(page0_buffer),szBuf); 
							break;
					}
					UINT nItem = 0;
					lvItem.mask = LVIF_TEXT | LVIF_IMAGE;
					lvItem.iItem = i;      
					lvItem.iSubItem = j; // column
					lvItem.iImage   = 3;
					lvItem.pszText = szBuf; 
					m_List.SetItem( &lvItem ); 
					if (bsave_file) fprintf(outfile,"%s   ",szBuf);
					strcat(fullstr,szBuf);
					strcat(fullstr,"   ");
				}
				AlarmStr[AlarmStrNum++] = fullstr;
				if (bsave_file) fprintf(outfile,"\n");
			}
		  // update low temp alarm table
			if (bsave_file) fprintf(outfile,"\nLow Threshold Time Stamps and Durations:\n");
			AlarmStr[AlarmStrNum++] = "";
			AlarmStr[AlarmStrNum++] = "Low Threshold Time Stamps and Durations:";
//			AlarmStr[AlarmStrNum++] = "";
			sprintf(str,"Low Threshold = %s",PrintInfo.threshold_lo);
			AlarmStr[AlarmStrNum++] = str;
			AlarmStr[AlarmStrNum++] = "";
			AlarmStr[AlarmStrNum++] = "       #               Date Time                  Duration";
			AlarmStr[AlarmStrNum++] = "";

			for (i = 0; i < 12; i++) {
				fullstr[0] = 0;
				for (j = 0; j < 3; j++) {
					sample = AlarmStampToLong(&buffer[(i + 0) * 4]);
					// subtract one sample time from alarm stamp... (current sample at t=0 starts
					//   out at current sample = 1, so current sample = 1 is at the start stamp
					if (sample >= 1) sample -= DS1615BufferToSampleRate(page0_buffer);
					switch (j) {
						case 0: wsprintf( szBuf, "      %02d",i+1); break;
						case 1: 
								if (sample == 0) {
									sprintf( szBuf,"    ");
									break;
								}
								date = TicksToSpan(MIN,sample * 
									DS1615BufferToSampleRate(page0_buffer));
								end = start + date;
								sprintf( szBuf, "%02lu/%02lu/%lu %02lu:%02lu:%02lu%s",
									end.GetMonth(),end.GetDay(),end.GetYear(),
									hour24to12[end.GetHour()],end.GetMinute(),
									end.GetSecond(),(end.GetHour()<12)?"am":"pm");
							break;
						case 2: 
							if (sample == 0) {
								sprintf( szBuf,"   ");
								break;
							}							
									char str2[256];
									sprintf(str2,"index = %02d",i + 0);
									Debug.Printf0(str2);
							DurationToString(buffer[((i + 0) * 4) + 3] * 
									DS1615BufferToSampleRate(page0_buffer),szBuf); 
							break;
					}
					lvItem.mask = LVIF_TEXT | LVIF_IMAGE;
					lvItem.iItem = i;      
					lvItem.iSubItem = j; // column
					lvItem.iImage   = 3;
					lvItem.pszText = szBuf; 
					m_List2.SetItem( &lvItem ); 
					if (bsave_file) fprintf(outfile,"%s   ",szBuf);
					strcat(fullstr,szBuf);
					strcat(fullstr,"   ");
				}
				AlarmStr[AlarmStrNum++] = fullstr;
				if (bsave_file) fprintf(outfile,"\n");
			}

			if (bsave_file) {
				bsave_file = false;
				fclose(outfile);
				strcat(filename," Saved.");
				MessageBox(filename,"Save Alarm Log to File");
			}
			bsave_file = false;

			// now that data is downloaded check to see if we should save the file
/*			if (bsave_file) {
				SaveDatalog(filename,page0_buffer,buffer,(long)current,temp_scale);
				bsave_file = false;
			}*/




			// set axis label to F or C
/*				if (temp_scale == 'F')
					m_OScopeCtrl.SetYUnits("Temperature (F)") ;
				else
					m_OScopeCtrl.SetYUnits("Temperature (C)") ;
			// display datalog
				unsigned long i,current;
				m_OScopeCtrl.DeletePoints();
			// DS1615_Read_Datalog(DataLog_Data);
				current = DS1615BufferToCurrentSample(page0_buffer);
				for (i = 0; i < 2048; i++) {
					DataLog_Data[i] = (unsigned int)buffer[i];
					degrees = ((double)0.5 * (double)DataLog_Data[i]) - (double)40.0;
					if (temp_scale == 'F')
						degrees = ((double)1.8 * (double)degrees) + (double)32.0;
					if (i < current)
					  m_OScopeCtrl.AddPoint(degrees);
				}
				m_OScopeCtrl.AppendPoint(i);

				double ymax;
				double ymin;
				if (current) {
					ymax = m_OScopeCtrl.FindMaxY();
					ymin = m_OScopeCtrl.FindMinY();
				} else {
					ymax = 0.0;
					ymin = 0.0;
				}
				sprintf(str,"Hi: %3.1f %c",ymax,temp_scale);
				GetDlgItem(IDC_TEXT_HI)->SetWindowText(str);
				sprintf(str,"Lo: %3.1f %c",ymin,temp_scale);
				GetDlgItem(IDC_TEXT_LO)->SetWindowText(str);

				// now that data is downloaded check to see if we should save the file
				if (bsave_file) {
					SaveDatalog(filename,page0_buffer,buffer,(long)current,temp_scale);
					bsave_file = false;
				}

			read_datalog = false;*/
		}
/*		if (m_OScopeCtrl.IsPointInfo) {
			m_OScopeCtrl.IsPointInfo = false;
			sprintf(str,"%3.1f %c",m_OScopeCtrl.value,temp_scale);
			GetDlgItem(IDC_TEXT_TEMPERATURE)->SetWindowText(str);

			// figure out relative date and time for this data index
			COleDateTimeSpan date;
			SYSTEMTIME stamp;
			DS1615BufferToTimeStamp(page0_buffer,&stamp);
			COleDateTime start(stamp.wYear, stamp.wMonth,  stamp.wDay, 
			   stamp.wHour, stamp.wMinute, stamp.wSecond );
			date = TicksToSpan(MIN,m_OScopeCtrl.index * DS1615BufferToSampleRate(page0_buffer));
			start = start + date;
			int hour24to12[24] = { 12,1,2,3,4,5,6,7,8,9,10,11,12,1,2,3,4,5,6,7,8,9,10,11 };
			sprintf( str, "%2lu/%2lu/%lu %02lu:%02lu:%02lu%s", start.GetMonth(),start.GetDay(),start.GetYear(),hour24to12[start.GetHour()],start.GetMinute(),start.GetSecond(),(start.GetHour()<12)?"am":"pm");
			// sprintf(str,"%d",m_OScopeCtrl.index);
			GetDlgItem(IDC_TEXT_TIME)->SetWindowText(str);
		}
*/
}



void CPageTwoDialog::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if (nIDEvent == CLOCK_UPDATE_TIMER_ID) {
		if (TStackedPage::IsPageActive()) {
			Debug.Printf1("Page2 tick");
			#ifdef _DEBUG
			   _CrtDbgReport(_CRT_WARN,"rPageOneDialog.cpp",__LINE__,"Demo",":  %s\n","timer page five");
			#endif

//			if (InitControls) {
//				OnInit();
//				InitControls = 0;
//			} else {

			   read_datalog = true;
				   if ((!suspend_timers) && (!suspend_due_to_error))
					Refresh();
//			}
		}
	}
	
	TStackedPage::OnTimer(nIDEvent);
}



static CFont*  m_pFont;				// text font on the tabs
static CFont*  m_pFont2;				// text font on the tabs


void CPageTwoDialog::DrawTemp(CDC* pDC, CRect& rBoundingRect,float temp_f,float temp_c)
{
	char str[80];
	//save the DC so we can restore it
	int nSaveDC = pDC->SaveDC();

	// create font
	LOGFONT logfont;
    CFont*   pfontOld;   // pointer to old font
    CFont*   pfontOld2;   // pointer to old font
    if( m_pFont == NULL ) {                    // if no tab font, create one
		memset( &logfont, 0, sizeof( LOGFONT ) );
		logfont.lfHeight = 6;
		strcpy(logfont.lfFaceName,"MS Sans Serif"); 
		m_pFont = new CFont();
		m_pFont->CreateFontIndirect(&logfont); 
	}
    if( m_pFont2 == NULL ) {                    // if no tab font, create one
		memset( &logfont, 0, sizeof( LOGFONT ) );
		logfont.lfHeight = 26;
		strcpy(logfont.lfFaceName,"Times New Roman"); 
		m_pFont2 = new CFont();
		m_pFont2->CreateFontIndirect(&logfont); 
	}
    pfontOld = pDC->SelectObject( m_pFont );                   // select tab font

	CPen blackpen;
	blackpen.CreatePen (PS_INSIDEFRAME, 1, RGB(0,0,0));
	CPen whitepen;
	whitepen.CreatePen (PS_INSIDEFRAME, 1, RGB(255,255,255));
	CPen pen;
	CPen* pPrevPen = pDC->SelectObject(&pen);

	// draw border	

	CBrush brush;
	brush.CreateSolidBrush(RGB(192,192,192));

	//save the current brush
	CBrush* oldBrush;
	oldBrush = pDC->SelectObject(&brush);

	CRect column;
	//draw the rectangle for the column

    pfontOld2 = pDC->SelectObject( m_pFont2 );                  // select tab font
	pDC->SetTextColor(RGB(0,0,0));
	pDC->SetBkColor(RGB(192,192,192));

	// display temperature
	sprintf(str," %3.1f F  ",temp_f);
	pDC->TextOut(rBoundingRect.left+4,
				rBoundingRect.top+4,
				str);

	sprintf(str," %3.1f C  ",temp_c);
	pDC->TextOut(rBoundingRect.left+4,
				rBoundingRect.top+4+20,
				str);

    pDC->SelectObject( m_pFont );                   // select tab font


	// figure out the starting date to begin cal
	if(oldBrush)
	{
		pDC->SelectObject(oldBrush);
	}

	if(pPrevPen)
	{
		pDC->SelectObject(pPrevPen);
	}

    pDC->SelectObject( pfontOld );         // select old font


	return;


	if (nSaveDC > 0)
	{
		pDC->RestoreDC(nSaveDC);
	}
	return;
}	


/*

void CPageTwoDialog::Refresh() 
{



	// TODO: Add your control notification handler code here
      //for ( int j = 0; j < 6; j++ )    

unsigned short *wpdata;
COleDateTimeSpan date;

//DS1678ReadLogMemory(logdata);
wpdata = (unsigned short *)logdata;

SYSTEMTIME stamp;
GetDS1678StampTime(&stamp);
COleDateTime start(stamp.wYear, stamp.wMonth,  stamp.wDay, 
				   stamp.wHour, stamp.wMinute, stamp.wSecond );

      LV_ITEM lvItem;
      TCHAR szBuf[128];
      LV_COLUMN lvc;

	int j = 0;
	int i;
         for ( i = 0; i < 1024; i++ )      
         {
			// display event number
            wsprintf( szBuf, "%4d", i);
            UINT nItem = 0;
            lvItem.mask = LVIF_TEXT | LVIF_IMAGE;
            lvItem.iItem = i;      
            lvItem.iSubItem = j + 0; // column
            lvItem.iImage   = 3;
            lvItem.pszText = szBuf; 
            //if ( !j )
            //   m_List.InsertItem( &lvItem );
            //else
               m_List.SetItem( &lvItem ); 

			// display raw event hex value
            wsprintf( szBuf, "%04X", wpdata[i]);
            nItem = 0;
            lvItem.mask = LVIF_TEXT | LVIF_IMAGE;
            lvItem.iItem = i;      
            lvItem.iSubItem = j + 1; // column
            lvItem.iImage   = 3;
            lvItem.pszText = szBuf; 
            //if ( !j )
            //   m_List.InsertItem( &lvItem );
            //else
               m_List.SetItem( &lvItem ); 

			// display relative date and time value
			date = TicksToSpan(SEC,wpdata[i]);
            wsprintf( szBuf, "%lud %02lu:%02lu:%02lu", date.GetDays(),date.GetHours(),date.GetMinutes(),date.GetSeconds());
            nItem = 0;
            lvItem.mask = LVIF_TEXT | LVIF_IMAGE;
            lvItem.iItem = i;      
            lvItem.iSubItem = j + 2; // column
            lvItem.iImage   = 3;
            lvItem.pszText = szBuf; 
            //if ( !j )
            //   m_List.InsertItem( &lvItem );
            //else
               m_List.SetItem( &lvItem ); 
			   
			// display absolute date and time value based on start date
			start = start + date;
            wsprintf( szBuf, "%2lu/%2lu/%lu %02lu:%02lu:%02lu", start.GetMonth(),start.GetDay(),start.GetYear(),start.GetHour(),start.GetMinute(),start.GetSecond());
            nItem = 0;
            lvItem.mask = LVIF_TEXT | LVIF_IMAGE;
            lvItem.iItem = i;      
            lvItem.iSubItem = j + 3; // column
            lvItem.iImage   = 3;
            lvItem.pszText = szBuf; 
            //if ( !j )
            //   m_List.InsertItem( &lvItem );
            //else
               m_List.SetItem( &lvItem ); 
			   


         }

}
*/
// thread code //

BOOL thread_finished_flag;

UINT DownLoadFunction(LPVOID lParam);//Global Prototype for thread function

//This class handles the progress dialog, and then launches a seperate thread to handle
//downloading files.
//**********************Default CONSTRUCTOR*********************
CPageTwoDialog::InitProgressThread()
{
thread_finished_flag = FALSE;

CWinThread * dl_thread = AfxBeginThread(::DownLoadFunction, this);//Start downloading thread

return 0;
}

//NOT A MEMEBER FUNCTION !!!!!
//This is the seperate thread function
//****************************DOWNLOADFUNCTION***********************************
UINT DownLoadFunction(LPVOID lParam)
{
CPageTwoDialog * pParent = (CPageTwoDialog *)lParam;//I want a try block to catch any exceptions
	    #ifdef _DEBUG
		   _CrtDbgReport(_CRT_WARN,"rPageOneDialog.cpp",__LINE__,"Demo",": %s\n","Thread Start");
	    #endif

/*if (thread_finished_flag == FALSE)
  DS1678ReadLogMemory(logdata);*/
//Sleep(20000);
thread_finished_flag = TRUE;
viewupdated = TRUE;

//pFtpI->thread_finished_flag = TRUE;//Let the main thread know we finished
return 0;//Don't care about return value
}


/*

int do_thread = 1;
HANDLE hThread;
DWORD dwThread;

void StartThread() {
	do_thread = 1;
    hThread = CreateThread(NULL, 0, Com_ReadComm, (LPDWORD)hCommPort,
                           0, &dwThread);
}

void EndThread() {
	do_thread = 0;
    if (WaitForSingleObject(hThread, 1000) == WAIT_TIMEOUT)
       TerminateThread(hThread, 1);
}

DWORD WINAPI Com_ReadComm(LPVOID hCommPort)
{
    DWORD dwCount;
    char c;

    while (do_thread)
    {

    }
	return 1;
}

*/
/*
void CPageTwoDialog::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if (nIDEvent == CLOCK_UPDATE_TIMER_ID) {
		if (TStackedPage::IsPageActive()) {
			Debug.Printf1("Page2 tick");
	//		if (viewupdated == TRUE) {
	//			viewupdated = FALSE;
	//			Sleep(2000);
	//			Refresh();
	//			//KillTimer(TIMER_ID);
	//			//TIMER_ID = 0;
	//			//AfxMessageBox("Done.");
	//		}
		}
	}

	TStackedPage::OnTimer(nIDEvent);
}
*/

void CPageTwoDialog::OnSavetofile() 
{
	// TODO: Add your control notification handler code here
	if (GetFilename(filename,"Save Alarm Log to File","AlarmStamp.txt","Text files *.txt\0*.dat\0All Files *.*\0*.*\0\0","txt")
		== -1) return;
//	AfxMessageBox("    Saving File    ");
	
	bsave_file = true;
}

void CPageTwoDialog::OnPrint() 
{
	// TODO: Add your control notification handler code here
  CString PrintString[128];
  int     PrintStringNum;
	
	bool b_print_information = true;


	CPrintInformation dlg2;
	int nResponse = dlg2.DoModal();
	if (nResponse == IDCANCEL)
	{
		b_print_information = false;
	}
	alarm_log = true;


	CPrintDlg dlg;
	nResponse = dlg.DoModal();
	if (nResponse == IDCANCEL)
	{
		alarm_log = false;
		return;
	}
	alarm_log = false;
	bool tabulated_output = true;

	char str[256];
	char str2[256];
	SYSTEMTIME time;
	int hour24to12[24] = { 12,1,2,3,4,5,6,7,8,9,10,11,12,1,2,3,4,5,6,7,8,9,10,11 };

/*			// setup print info in-case the user wants to print the plot
				PrintInfo.missionsamples = current;
				DS1615BufferToTimeStamp(page0_buffer,&PrintInfo.timestamp);
				PrintInfo.totalsamples = DS1615BufferToTotalSamples(page0_buffer);
				DS1615BufferToCurrentTime(page0_buffer,&PrintInfo.currenttime);	
				strcpy(PrintInfo.serialnumber,"00 00 00 00 00 00 00");*/

	// first string is the title of the plot
	PrintStringNum = 0;
	m_OScopeCtrl.TitleStr = dlg.title;

	PrintString[PrintStringNum++] = "";
	PrintString[PrintStringNum++] = "*** Threshold Alarm Report ***";
	PrintString[PrintStringNum++] = "";

    if (dlg.b_samplenum || dlg.b_sn || dlg.b_stamp || dlg.b_time || dlg.b_usermemory || dlg.b_samplerate
		|| dlg.b_alarminfo || dlg.b_rollover) {
		PrintString[PrintStringNum++] = " ";
		PrintString[PrintStringNum++] = "===================================================================================================";
		PrintString[PrintStringNum++] = "Device Status Information:";
		PrintString[PrintStringNum++] = " ";
	}

	if (dlg.b_samplenum) {
		sprintf(str,"Number of Mission Samples: %lu",PrintInfo.missionsamples);
		PrintString[PrintStringNum++] = str;
	}

	if (dlg.b_sn) {
		sprintf(str,"Serial Number: [%s]",PrintInfo.serialnumber);
		PrintString[PrintStringNum++] = str;
	}

	if (dlg.b_stamp) {
		time = PrintInfo.timestamp;
		sprintf( str, "Date Time of First Sample: %02lu/%02lu/%lu %02lu:%02lu:%02lu%s", time.wMonth,time.wDay,time.wYear,
			hour24to12[time.wHour],time.wMinute,time.wSecond,(time.wHour<12)?"am":"pm");
		PrintString[PrintStringNum++] = str;
	}

	if (dlg.b_time) {
		time = PrintInfo.currenttime;
		sprintf( str, "Current Date Time of Device: %02lu/%02lu/%lu %02lu:%02lu:%02lu%s", time.wMonth,time.wDay,time.wYear,
			hour24to12[time.wHour],time.wMinute,time.wSecond,(time.wHour<12)?"am":"pm");
		PrintString[PrintStringNum++] = str;
	}

	if (dlg.b_usermemory) {
		sprintf( str, "User Memory: \"%s\"", PrintInfo.usermemory_string);
		PrintString[PrintStringNum++] = str;
	}

	if (dlg.b_samplerate) {
		sprintf( str, "Sample Rate (mins): %lu", PrintInfo.sample_rate);
		PrintString[PrintStringNum++] = str;
	}

	if (dlg.b_alarminfo) {
		sprintf( str, "Alarm Threshold Low: %s", PrintInfo.threshold_lo);
		sprintf( str2, "   Alarm Threshold Hi : %s", PrintInfo.threshold_hi);
		strcat(str,str2);
		PrintString[PrintStringNum++] = str;
		sprintf( str, "Alarm Hi / Lo: %s / %s", PrintInfo.alarm_hi ? "Set" : "Clear", PrintInfo.alarm_lo ? "Set" : "Clear");
		PrintString[PrintStringNum++] = str;
	}

	if (dlg.b_rollover) {
		sprintf( str, "Rollover Occured: %s", PrintInfo.rollover ? "Yes" : "No");
		PrintString[PrintStringNum++] = str;
	}

	if (b_print_information) {
		PrintString[PrintStringNum++] = " ";
		PrintString[PrintStringNum++] = "===================================================================================================";
		PrintString[PrintStringNum++] = "HACCP Reporting Information:";
		PrintString[PrintStringNum++] = " ";
		PrintString[PrintStringNum++] = "Name of processor or importer: " + dlg2.field1;
		PrintString[PrintStringNum++] = "Location of processor or importer: " + dlg2.field2;
		PrintString[PrintStringNum++] = "Description of product: " + dlg2.field3;
		PrintString[PrintStringNum++] = "Production code: " + dlg2.field4;
		PrintString[PrintStringNum++] = "Corrective action or notes: " + dlg2.field5;
		PrintString[PrintStringNum++] = " ";
		PrintString[PrintStringNum++] = " ";
		PrintString[PrintStringNum++] = "Signature:    __________________________________  Date: ______________";
		PrintString[PrintStringNum++] = " ";
		PrintString[PrintStringNum++] = " ";
		PrintString[PrintStringNum++] = "===================================================================================================";
		PrintString[PrintStringNum++] = " ";
	}
	else {
		PrintString[PrintStringNum++] = " ";
		PrintString[PrintStringNum++] = "===================================================================================================";
	}

	// if tabulated output then assemble the info
	int i;
	int index_min = 0; //m_OScopeCtrl.GetMinRange();
	int index_max = 5; //m_OScopeCtrl.GetMaxRange();
	m_OScopeCtrl.lhead = NULL;
	s_printstrings2 slink,*newlink;
	newlink = &slink;

// append to the link list the user info
	for (i = 0; i < PrintStringNum;i++) {
		newlink->next = (s_printstrings2 *) new s_printstrings2;
		if (m_OScopeCtrl.lhead == NULL) {
			m_OScopeCtrl.lhead = newlink->next;
		}
		newlink = newlink->next;
		newlink->cstr = (CString *) new CString;

		*newlink->cstr = PrintString[i];
		newlink->next = NULL;
	}

	// append a link list of the tabulated output
	if (tabulated_output) {
		for (i = 0; i < AlarmStrNum;i++) {
			newlink->next = (s_printstrings2 *) new s_printstrings2;
			if (m_OScopeCtrl.lhead == NULL) {
				m_OScopeCtrl.lhead = newlink->next;
			}
			newlink = newlink->next;
			newlink->cstr = (CString *) new CString;

			*newlink->cstr = AlarmStr[i];
			newlink->next = NULL;
		}
	}

	m_OScopeCtrl.PrintGraph();

}
