// PortCls.cpp : implementation file
//
/*
  This Evaluation kit software is available free of charge and can be used,
  edited, or reproduced as you see fit. Dallas Semiconductor does not
  assume any liability for the accuracy or correctness of this code.

  It is free to use at your own risk.
  */

#include "stdafx.h"
#include "Sample.h"
#include "PortCls.h"
#include "Serial.h"
#include "Cmd_Pipe.h"
#include "DS1615io.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

bool auto_poll;

/////////////////////////////////////////////////////////////////////////////
// CPortCls dialog


CPortCls::CPortCls(CWnd* pParent /*=NULL*/)
	: CDialog(CPortCls::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPortCls)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CPortCls::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPortCls)
	DDX_Control(pDX, IDC_CHECK1, m_Check);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPortCls, CDialog)
	//{{AFX_MSG_MAP(CPortCls)
	ON_BN_CLICKED(IDC_BUTTON1, OnPort1)
	ON_BN_CLICKED(IDC_BUTTON2, OnPort2)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPortCls message handlers

static int CLOCK_UPDATE_TIMER_ID = 33;
static int TIMER_ID = 0;

BOOL CPortCls::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	int port;
	CButton* check;
	check = (CButton*)GetDlgItem(IDC_CHECK_AUTO);
	check->SetCheck(1);

	port = theApp.GetRegistrySerialPort();
	switch (port) {
	case 0: GetDlgItem(IDC_STATIC_LAST_PORT)->SetWindowText("No Previous Port Used");
		break;
	case 1: GetDlgItem(IDC_STATIC_LAST_PORT)->SetWindowText("COM1 Previously Used");
		break;
	case 2: GetDlgItem(IDC_STATIC_LAST_PORT)->SetWindowText("COM2 Previously Used");
		break;
	}

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}



int CPortCls::DoPort1() 
{
	return 0;
}

int CPortCls::DoPort2() 
{
	return 0;
}

int remember = 0;

void CPortCls::OnPort1() 
{
	port_number = 1;
	theApp.SetRegistrySerialPort(port_number);
	DoPort1();
//	if (remember) theApp.SetRegistrySerialPort(1);
	CDialog::OnOK();
}

void CPortCls::OnPort2() 
{
	port_number = 2;
	theApp.SetRegistrySerialPort(port_number);
	DoPort2();
//	if (remember) theApp.SetRegistrySerialPort(2);
	CDialog::OnOK();
}


void CPortCls::OnOK() 
{
	// TODO: Add extra validation here
	int port;
	char str[120];

	CButton* check;
	check = (CButton*)GetDlgItem(IDC_CHECK_AUTO);
	if (check->GetCheck() == 1) auto_poll = true; else auto_poll = false;

	port_number = 0;
	port = theApp.GetRegistrySerialPort();
	if (port != 0) {
		port_number = port;
		sprintf(str,"Using Port %d",port);
		//AfxMessageBox(str);
		CDialog::OnOK();
	} else
		AfxMessageBox("There was no Previous Port");
	
}

void CPortCls::OnCheck1() 
{
	// TODO: Add your control notification handler code here
	//theApp.RegistryPortCheck();
	remember ^= 1;
}

void CPortCls::OnCancel() 
{
	// TODO: Add extra cleanup here
	port_number = 0;
	
	CDialog::OnCancel();
}


int CPortCls::What_Port() {
	return port_number;
}

extern bool suspend_timers;
extern bool suspend_due_to_error;

/*void CPortCls::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if (nIDEvent == CLOCK_UPDATE_TIMER_ID) {
		CDialog::OnTimer(nIDEvent);
		if (!suspend_timers && !suspend_due_to_error)
			Refresh();
	}
}
*/


static unsigned char page1_buffer[64];
static unsigned char page1_start = 1;
static unsigned char page1_end   = 1;
static bool read_datalog = false;
static int read_page_status = STATUS_IDLE;

void CPortCls::Refresh()  {
	// TODO: Add your control notification handler code here

	int returnval;
//	char str[256];

//		if (!auto_poll && datasource == READFROM_KEY)
//			return;

		//if (!read_datahist_queued) {
	returnval = Cmd_Process();
	if (returnval == CMD_SUSPEND) {
		return;
	}
	if (returnval == CMD_SHUTDOWN) {
		return;
	}
	//}
	if (read_datalog == true) {
		if (read_page_status == STATUS_IDLE) {
			// read page 1 for extra register fields in the DS1616
			Cmd_Insert(CMD_READ_PAGE,page1_buffer,&page1_start,&page1_end,NULL,NULL);
			read_datalog = false;
		}
	}
	if (read_page_status == STATUS_DONE) {
		read_page_status = STATUS_IDLE;
		read_datalog = false;
	}
}



void CPortCls::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if (nIDEvent == CLOCK_UPDATE_TIMER_ID) {
		CDialog::OnTimer(nIDEvent);
		if (!suspend_timers && !suspend_due_to_error)
			Refresh();
	}
}



