// SampleDelay.cpp : implementation file
//
/*
  This Evaluation kit software is available free of charge and can be used,
  edited, or reproduced as you see fit. Dallas Semiconductor does not
  assume any liability for the accuracy or correctness of this code.

  It is free to use at your own risk.
  */

#include "stdafx.h"
#include "sample.h"
#include "SampleDelay.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSampleDelay dialog


CSampleDelay::CSampleDelay(CWnd* pParent /*=NULL*/)
	: CDialog(CSampleDelay::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSampleDelay)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CSampleDelay::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSampleDelay)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSampleDelay, CDialog)
	//{{AFX_MSG_MAP(CSampleDelay)
	ON_NOTIFY(DTN_DATETIMECHANGE, IDC_DATE, OnDatetimechangeDate)
	ON_NOTIFY(DTN_DATETIMECHANGE, IDC_TIME, OnDatetimechangeTime)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSampleDelay message handlers

void CSampleDelay::OnOK() 
{
	// TODO: Add extra validation here
	if (m_lminutes < 0 || m_lminutes > 65535) {
		MessageBox("Sample Delay in Minutes must be between 0 and 65535","Set Sample Delay",MB_ICONSTOP);
		return;
	}
	CDialog::OnOK();
}

void CSampleDelay::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}



#define SEC  0
#define MIN  1
#define HOUR 2

static COleDateTimeSpan TicksToSpan(int mode,unsigned short ticks) {

  double dday = 0;
  COleDateTimeSpan day(dday);

  switch (mode) {
    case SEC: dday = (double)ticks / ((double)60.0 * (double)60.0 * (double)24.0);
			  day = dday;
			  return day;
			break;
    case MIN: dday = (double)ticks / ((double)60.0 * (double)24.0);
			  day = dday;
			  return day;
			break;
    case HOUR: dday = (double)ticks / (double)24.0;
			   day = dday;
			   return day;
			break;
  }

  return day;
}


BOOL CSampleDelay::OnInitDialog() 
{
	CDialog::OnInitDialog();
//	SYSTEMTIME timestruct;
	char str[256];

	// initialize the time and date controls to the current sample delay
	COleDateTimeSpan span = TicksToSpan(MIN,m_lminutes);
	COleDateTime start(current.wYear, current.wMonth,  current.wDay, 
					   current.wHour, current.wMinute, 0 );
	start = start + span;

	CDateTimeCtrl* ctrl;
	ctrl = (CDateTimeCtrl*)GetDlgItem(IDC_DATE);
	ctrl->SetTime(start);
	ctrl = (CDateTimeCtrl*)GetDlgItem(IDC_TIME);
	ctrl->SetTime(start);

	// clear the seconds to 0 in the time control
	SYSTEMTIME time;
	ctrl = (CDateTimeCtrl*)GetDlgItem(IDC_TIME);
	ctrl->GetTime(&time);
	time.wSecond = 0;
	ctrl->SetTime(&time);

	Recalculate();

	// display the 1615 current time
	int hour24to12[24] = { 12,1,2,3,4,5,6,7,8,9,10,11,12,1,2,3,4,5,6,7,8,9,10,11 };
	sprintf( str, "%02lu/%02lu/%lu %02lu:%02lu%s", current.wMonth,current.wDay,current.wYear,
		hour24to12[current.wHour],current.wMinute,(current.wHour<12)?"am":"pm");
	CEdit* ctime_dlg = (CEdit*)GetDlgItem(IDC_EDIT_CURRENT_TIME);
	ctime_dlg->SetWindowText(str);
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSampleDelay::Recalculate() {

	SYSTEMTIME time;
	SYSTEMTIME date;
	SYSTEMTIME timestruct;
	CDateTimeCtrl* ctrl = (CDateTimeCtrl*)GetDlgItem(IDC_DATE);
	ctrl->GetTime(&date);
	ctrl = (CDateTimeCtrl*)GetDlgItem(IDC_TIME);
	ctrl->GetTime(&time);

	timestruct.wYear		= date.wYear;
	timestruct.wMonth		= date.wMonth;
	timestruct.wDay			= date.wDay;
	timestruct.wDayOfWeek	= date.wDayOfWeek;

	timestruct.wHour			= time.wHour;
	timestruct.wMinute			= time.wMinute;
	timestruct.wSecond			= time.wSecond;
	timestruct.wMilliseconds	= time.wMilliseconds;

	COleDateTimeSpan span;
//	SYSTEMTIME stamp;
	COleDateTime start(current.wYear, current.wMonth,  current.wDay, 
					   current.wHour, current.wMinute, 0 );
	COleDateTime end(timestruct.wYear, timestruct.wMonth,  timestruct.wDay, 
					   timestruct.wHour, timestruct.wMinute, 0 );

	span = end - start;
	double minutes = span.GetTotalMinutes();
	m_lminutes = (long)minutes;
	char str[256];
	sprintf(str,"%lu",m_lminutes);

	CEdit* min_dlg = (CEdit*)GetDlgItem(IDC_EDIT_MINUTES);
	min_dlg->SetWindowText(str);
}


void CSampleDelay::SetCurrentTime(SYSTEMTIME timenow) {
	current = timenow;
}


void CSampleDelay::OnDatetimechangeDate(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	Recalculate();
	*pResult = 0;
}

void CSampleDelay::OnDatetimechangeTime(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	Recalculate();
	*pResult = 0;
}
