// SampleDlg.cpp : implementation file
//
/*
  This Evaluation kit software is available free of charge and can be used,
  edited, or reproduced as you see fit. Dallas Semiconductor does not
  assume any liability for the accuracy or correctness of this code.

  It is free to use at your own risk.
  */

#include "stdafx.h"
#include "Sample.h"
#include "SampleDlg.h"
#include "AboutDlg.h"
#include "BetaDlg.h"

#include "PageOneDialog.h"
#include "PageTwoDialog.h"
#include "PageThreeDialog.h"
#include "PageFourDialog.h"
#include "PageFiveDialog.h"
#include "PageSix1Dialog.h"
#include "PageSevenDialog.h"
#include "PageEightDialog.h"
#include "PageNineDialog.h"
#include "PageTenDialog.h"
#include "PageElevenDialog.h"
#include "DS1678.h"
#include "Serial.h"
#include "PortCls.h"
#include "MemoryToFile.h"
#include "EditUserSimple.h"
#include "EditUserMemory.h"
#include "DataSource.h"
#include "Cmd_Pipe.h"
#include "DS1615io.h"
#include "ExpandDlgDlg.h"
#include "AboutDlg2.h"

#include "Cdebug.h"
CDebug Debug;

bool b_Port_Initialized = false;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern bool D_Edit;
unsigned char memimage[6145];

extern bool auto_poll;
//extern int datasource;

#define READFROM_KEY  1
#define READFROM_FILE 2
extern int datasource;
int initmemoryimage_file(char *filename);
bool force_plot_refresh = false;



/////////////////////////////////////////////////////////////////////////////
// CSampleDlg dialog

CSampleDlg::CSampleDlg(CWnd* pParent /*=NULL*/)
	: TStackedDialog(IDC_PLACEHOLDER, CSampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSampleDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
  m_bTimerActive  = FALSE;
}

void CSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	TStackedDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSampleDlg)
	DDX_Control(pDX, IDC_COMBO, m_Combo);
  //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSampleDlg, TStackedDialog)
	//{{AFX_MSG_MAP(CSampleDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELCHANGE(IDC_COMBO, OnSelchangeCombo)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_PAGE1, OnButtonPage1)
	ON_BN_CLICKED(IDC_BUTTON_PAGE2, OnButtonPage2)
	ON_BN_CLICKED(IDC_BUTTON_PAGE3, OnButtonPage3)
	ON_BN_CLICKED(IDC_BUTTON_PAGE4, OnButtonPage4)
	ON_BN_CLICKED(IDC_BUTTON_PAGE5, OnButtonPage5)
	ON_BN_CLICKED(IDC_BUTTON_PAGE6, OnButtonPage6)
	ON_BN_CLICKED(IDC_BUTTON_PAGE7, OnButtonPage7)
	ON_BN_CLICKED(IDC_BUTTON_PAGE8, OnButtonPage8)
	ON_BN_CLICKED(IDC_BUTTON_PAGE10, OnButtonPage10)
	ON_BN_CLICKED(IDC_ABOUT, OnAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


char datasource_file[128];

/////////////////////////////////////////////////////////////////////////////
// CSampleDlg message handlers

static unsigned char page1_buffer[64];
static unsigned char page1_start = 1;
static unsigned char page1_end   = 1;
static bool read_datalog = false;
static int read_page_status = STATUS_IDLE;

int silicon = 0;
extern bool suspend_timers;
extern bool suspend_due_to_error;
static int CLOCK_UPDATE_TIMER_ID = 35;
static int TIMER_ID = 0;

void CSampleDlg::Refresh()  {
	// TODO: Add your control notification handler code here

	int returnval;
//	char str[256];

//		if (!auto_poll && datasource == READFROM_KEY)
//			return;

		//if (!read_datahist_queued) {
	returnval = Cmd_Process();
	if (returnval == CMD_SUSPEND) {
		return;
	}
	if (returnval == CMD_SHUTDOWN) {
		return;
	}
	//}
	if (read_datalog == true) {
		if (read_page_status == STATUS_IDLE) {
			// read page 1 for extra register fields in the DS1616
			Cmd_Insert(CMD_READ_PAGE,page1_buffer,&page1_start,&page1_end,NULL,&read_page_status);
			read_datalog = false;
		}
	}
	if (read_page_status == STATUS_DONE) {
		read_page_status = STATUS_IDLE;
		read_datalog = false;
		bool all_zeros = true;
		for (int i = 0; i < 0x0B; i++) {
			if (page1_buffer[i] != 0x00) all_zeros = false;
		}
		if (all_zeros) silicon = 1615;
		  else silicon = 1616;
		//if (silicon == 1615) AfxMessageBox("DS1615 Silicon Detected");
		//if (silicon == 1616) AfxMessageBox("DS1616 Silicon Detected");

		KillTimer(TIMER_ID);   
		Finish_Init_Procedure();
	}
}




void CSampleDlg::OnTimer(UINT nIDEvent) 
{
  // If timer is active, select the next stacked page and rollover
  // to first one if end is reached
//  SetNextPage();
	if (nIDEvent == CLOCK_UPDATE_TIMER_ID) {
		CDialog::OnTimer(nIDEvent);
		if (!suspend_timers && !suspend_due_to_error)
			Refresh();
	}
  
	TStackedDialog::OnTimer(nIDEvent);
}



BOOL CSampleDlg::OnInitDialog()
{
	bool b_DetectSilicon = true;

//	CBetaDlg BDlg;
//	BDlg.DoModal();

	TStackedDialog::OnInitDialog();
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_page6.SubclassDlgItem( IDC_BUTTON_PAGE6, this );
	//m_page6.SetIcon( IDI_ICON12, 32, 32 );
	m_page6.SetBitmap( IDB_BITMAPTRY1,31,35);
//	m_page6.SetMaskedBitmap( IDB_BITMAPTRY, 23, 6, RGB( 255, 0, 0 ) );
	m_page6.SetMaskedBitmap( IDB_BITMAPTRY1, 31, 35, RGB( 255, 0, 0 ) );

	m_About.SubclassDlgItem( IDC_ABOUT, this );
	m_About.SetBitmap( IDB_BITMAPABOUT,30,11);
	m_About.SetMaskedBitmap( IDB_BITMAPABOUT, 30, 11, RGB( 255, 0, 0 ) );



  // Init Port, Ask for port if needed.
	int status; //, i;
//	int port;
tryagain:
//	CPortCls Port;

// find prev port used
	
	CExpandDlgDlg Port;
	Port.SetPreviousPort(theApp.GetRegistrySerialPort());
	int nResponse = Port.DoModal();

	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
		HBITMAP bitmap;
		switch (Port.ReturnSelected()) {
			case COM1:			//AfxMessageBox("COM1");	
					auto_poll = true;
					datasource = READFROM_KEY;
					status = InitComPort("COM1", 9600, 1);	
					b_Port_Initialized = true;
					if (status == COM_OPEN_ERROR) {
						MessageBox("Error: Can not open Port 1","Select Serial Port",MB_ICONSTOP);
						goto tryagain;
		//				AfxGetMainWnd()->SendMessage(WM_CLOSE);
					}
				break;
			case COM2:			//AfxMessageBox("COM2");			
					auto_poll = true;
					datasource = READFROM_KEY;
					status = InitComPort("COM2", 9600, 1);	
					b_Port_Initialized = true;
					if (status == COM_OPEN_ERROR) {
						MessageBox("Error: Can not open Port 2","Select Serial Port",MB_ICONSTOP);
						goto tryagain;
		//				AfxGetMainWnd()->SendMessage(WM_CLOSE);
					}
				break;
			case PREVIOUSPORT:	//AfxMessageBox("PREVIOUSPORT");	
				break;
			case DS1615IMAGE:	//AfxMessageBox("DS1615IMAGE");	
					auto_poll = true;
					datasource = READFROM_FILE;
					if (initmemoryimage_file("DS1615.img") < 0) {
						AfxMessageBox("Error cannot find default DS1615 image file");
					}
					datasource = READFROM_FILE;
					m_page6.SetBitmap( IDB_BITMAPTRY2,31,35);
					m_page6.SetMaskedBitmap( IDB_BITMAPTRY2, 31, 35, RGB( 255, 0, 0 ) );

					// change the image on the screen to indicate which source mode
					bitmap = LoadBitmap(
						AfxGetResourceHandle( ),					// handle to application instance
						MAKEINTRESOURCE(IDB_BITMAP_SOURCEDISK));	// address of bitmap resource name
				break;
			case DS1616IMAGE:	//AfxMessageBox("DS1616IMAGE");	
					auto_poll = true;
					datasource = READFROM_FILE;
					if (initmemoryimage_file("DS1616.img") < 0) {
						AfxMessageBox("Error cannot find default DS1615 image file");
					}
					datasource = READFROM_FILE;
					m_page6.SetBitmap( IDB_BITMAPTRY2,31,35);
					m_page6.SetMaskedBitmap( IDB_BITMAPTRY2, 31, 35, RGB( 255, 0, 0 ) );

					// change the image on the screen to indicate which source mode
					bitmap = LoadBitmap(
						AfxGetResourceHandle( ),					// handle to application instance
						MAKEINTRESOURCE(IDB_BITMAP_SOURCEDISK));	// address of bitmap resource name
				break;
			case EXIT:			//AfxMessageBox("EXIT");			
				break;
		}
	}
	else if (nResponse == IDCANCEL)
	{
		AfxGetMainWnd()->SendMessage(WM_CLOSE);
		b_DetectSilicon = false;
	}

/*	switch (Port.What_Port()) {
	  case 0:
			 AfxGetMainWnd()->SendMessage(WM_CLOSE);
		  break;
	  case 1:
			status = InitComPort("COM1", 9600, 1);		
			if (status == COM_OPEN_ERROR) {
				MessageBox("Error: Can not open Port 1","Select Serial Port",MB_ICONSTOP);
				goto tryagain;
//				AfxGetMainWnd()->SendMessage(WM_CLOSE);
			}
		  break;
	  case 2:
			status = InitComPort("COM2", 9600, 1);		
			if (status == COM_OPEN_ERROR) {
				MessageBox("Error: Can not open Port 2","Select Serial Port",MB_ICONSTOP);
				goto tryagain;
//				AfxGetMainWnd()->SendMessage(WM_CLOSE);
			}
		  break;
	}*/
	if (status == COM_OPEN_ERROR)
		AfxGetMainWnd()->SendMessage(WM_CLOSE);

	// the Cmd_Process loop is needed to read from the 
	if (b_DetectSilicon) {
		TIMER_ID = this->SetTimer(CLOCK_UPDATE_TIMER_ID,100,NULL);
		read_datalog = true;
		//Sleep(100);
		//AfxMessageBox("Detecting Silicon");
	}


 	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSampleDlg::Finish_Init_Procedure() {

	// Fill combo box with list of clickable pages
	m_Combo.AddString("Mission Control");					// 0
	m_Combo.AddString("Date/Time");		// 1
	m_Combo.AddString("DataLog Graph");						// 2
	m_Combo.AddString("Histogram Graph");					// 3
	m_Combo.AddString("Temperature Alarm Log");				// 4

	if (silicon == 1615)
		SetWindowText("DS1615 Demo Software");
	else
		SetWindowText("DS1616 Demo Software");

	// Add pages to stacked dialog
	AddPage(IDD_PAGE1);

	if (silicon == 1615)
	  AddPage(IDD_PAGE2);
	else
	  AddPage(IDD_PAGE11);

	if (silicon == 1615)
	  AddPage(IDD_PAGE3);
	else
	  AddPage(IDD_PAGE8);

	AddPage(IDD_PAGE4);
	AddPage(IDD_PAGE5);
	AddPage(IDD_PAGE6);

	if (silicon == 1615)
	  AddPage(IDD_PAGE7);
	else
	  AddPage(IDD_PAGE9);

	if (silicon == 1616)
	  AddPage(IDD_PAGE10);


	m_page1.SubclassDlgItem( IDC_BUTTON_PAGE1, this );
	m_page1.SetIcon( IDI_ICON4, 16, 16 );
	m_page1.SetMaskedBitmap( IDI_ICON4, 16, 16, RGB( 255, 0, 0 ) );

	m_page2.SubclassDlgItem( IDC_BUTTON_PAGE2, this );
	m_page2.SetIcon( IDI_ICON10, 16, 16 );
	m_page2.SetMaskedBitmap( IDI_ICON10, 16, 16, RGB( 255, 0, 0 ) );

	m_page3.SubclassDlgItem( IDC_BUTTON_PAGE3, this );
	m_page3.SetIcon( IDI_ICON3, 16, 16 );
	m_page3.SetMaskedBitmap( IDI_ICON3, 16, 16, RGB( 255, 0, 0 ) );

	m_page4.SubclassDlgItem( IDC_BUTTON_PAGE4, this );
	m_page4.SetIcon( IDI_ICON5, 16, 16 );
	m_page4.SetMaskedBitmap( IDI_ICON5, 16, 16, RGB( 255, 0, 0 ) );

	m_page5.SubclassDlgItem( IDC_BUTTON_PAGE5, this );
	m_page5.SetIcon( IDI_ICON1, 16, 16 );
	m_page5.SetMaskedBitmap( IDI_ICON1, 16, 16, RGB( 255, 0, 0 ) );

	m_page7.SubclassDlgItem( IDC_BUTTON_PAGE7, this );
	m_page7.SetIcon( IDI_ICON7, 16, 16 );
	m_page7.SetMaskedBitmap( IDI_ICON7, 16, 16, RGB( 255, 0, 0 ) );

	m_page8.SubclassDlgItem( IDC_BUTTON_PAGE8, this );
	m_page8.SetIcon( IDI_ICON_MEMORYSAVE, 16, 16 );
	m_page8.SetMaskedBitmap( IDI_ICON_MEMORYSAVE, 16, 16, RGB( 255, 0, 0 ) );
//IDI_ICON_MEMORYSAVE
	if (silicon == 1616) {
//		AfxMessageBox("test");
	  m_page10.SubclassDlgItem( IDC_BUTTON_PAGE10, this );
	  m_page10.SetIcon( IDI_ICON_MEMORYSAVE1, 16, 16 );
	  m_page10.SetMaskedBitmap( IDI_ICON_MEMORYSAVE1, 16, 16, RGB( 255, 0, 0 ) );
	}

	// Select active page to the "Mission Control" Page
	SetPage(IDD_PAGE5);
	m_page5.SetState( TRUE );	// Deactivate

	
	/*	int status;
	status = InitComPort("COM1", 9600, 1);		
	if (status == COM_OPEN_ERROR) {
	  AfxMessageBox("Error: Can not open Port 1");
	}
	*/
	datasource_file[0] = 0;

	int i;
	for (i = 0; i < 6144; i++)
		memimage[i] = 0;

	memimage[3] = 0x01;	memimage[4] = 0x01;
	memimage[5] = 0x01;	memimage[12] = 0xFA;
	memimage[14] = 0x80; memimage[17] = 0x7E;
	memimage[20] = 0x80;

}



// Must be implemented
// Create a dialog object based on dialog resource id
TStackedPage *CSampleDlg::CreatePage(UINT nId)
{
	switch (nId) {
		case IDD_PAGE1: return new CPageOneDialog; 
		case IDD_PAGE2: return new CPageTwoDialog;
		case IDD_PAGE3: return new CPageThreeDialog;
		case IDD_PAGE4: return new CPageFourDialog;
		case IDD_PAGE5: return new CPageFiveDialog;
		case IDD_PAGE6: return new CPageSix1Dialog;
		case IDD_PAGE7: return new CPageSevenDialog;
		case IDD_PAGE8: return new CPageEightDialog;
		case IDD_PAGE9: return new CPageNineDialog;
		case IDD_PAGE10: return new CPageTenDialog;
		case IDD_PAGE11: return new CPageElevenDialog;
	}
  return NULL;    // this will assert
}

// Update the controls based on the currently active page
void CSampleDlg::OnPageChanged(UINT nId, BOOL bActivated)
{
  if (bActivated) {
	m_page1.SetState( FALSE );	// Deactivate
	m_page2.SetState( FALSE );	// Deactivate
	m_page3.SetState( FALSE );	// Deactivate
	m_page4.SetState( FALSE );	// Deactivate
	m_page5.SetState( FALSE );	// Deactivate
	m_page6.SetState( FALSE );	// Deactivate
	m_page7.SetState( FALSE );	// Deactivate
    switch (nId) {
    case IDD_PAGE1:		// Clock Page
      m_Combo.SetCurSel(1);
	  m_page1.SetState( TRUE );	// Deactivate
      break;
    case IDD_PAGE2:		// Temperature Page
      m_Combo.SetCurSel(4);
	  m_page2.SetState( TRUE );	// Deactivate
      break;
    case IDD_PAGE3:		// Datalog Page
      m_Combo.SetCurSel(2);
	  m_page3.SetState( TRUE );	// Deactivate
      break;
    case IDD_PAGE4:		// --- extra page ---
      m_Combo.SetCurSel(3);
	  m_page4.SetState( TRUE );	// Deactivate
      break;
    case IDD_PAGE5:		// Mission Control Page
      m_Combo.SetCurSel(0);
	  m_page5.SetState( TRUE );	// Deactivate
      break;
    case IDD_PAGE6:		// old temperature page
      m_Combo.SetCurSel(2);
	  m_page6.SetState( TRUE );	// Deactivate
      break;
    case IDD_PAGE7:		// Histogram Page
      m_Combo.SetCurSel(3);
	  m_page7.SetState( TRUE );	// Deactivate
      break;
    case IDD_PAGE8:		// Histogram Page
      m_Combo.SetCurSel(3);
	  m_page3.SetState( TRUE );	// Deactivate
      break;
    case IDD_PAGE9:		// Histogram Page
      m_Combo.SetCurSel(3);
	  m_page7.SetState( TRUE );	// Deactivate
      break;
    case IDD_PAGE11:	// Temperature Page
      m_Combo.SetCurSel(4);
	  m_page2.SetState( TRUE );	// Deactivate
      break;
    }
  } else {
		m_page1.Disable( FALSE );
		m_page2.Disable( FALSE );
		m_page3.Disable( FALSE );
		m_page4.Disable( FALSE );
		m_page5.Disable( FALSE );
		m_page6.Disable( FALSE );
		m_page7.Disable( FALSE );
		m_page8.Disable( FALSE );
  }
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CSampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSampleDlg::OnSelchangeCombo() 
{
  // CLick on a combobox
  // Select stacked page
  int nIndex = m_Combo.GetCurSel();
  switch (nIndex) {
  case 0: SetPage(IDD_PAGE5); break;	// let the user select the : Mission Page
  case 1: SetPage(IDD_PAGE1); break;	// let the user select the : Clock Page
  case 2: SetPage(IDD_PAGE3); break;	// let the user select the : Datalog Page
  case 3: SetPage(IDD_PAGE7); break;	// let the user select the : Histogram Page
  case 4: SetPage(IDD_PAGE2); break;	// let the user select the : Alarm Page
  }
}




void CSampleDlg::OnScan() 
{
  if (m_bTimerActive) {
    KillTimer(100);
    m_bTimerActive = FALSE;
  } else {
    SetTimer(100,1000,NULL);
    m_bTimerActive = TRUE;
  }
}

// ----------------------
//    Date / Time Page
// ----------------------
void CSampleDlg::OnButtonPage1() 
{
	// TODO: Add your control notification handler code here
  SetPage(IDD_PAGE1);	
}

// ---------------------------
//    Alarm Temperature Page
// ---------------------------
void CSampleDlg::OnButtonPage2() 
{
	// TODO: Add your control notification handler code here
  if (silicon == 1615)
    SetPage(IDD_PAGE2);	
  else
    SetPage(IDD_PAGE11);	
	
}

// ----------------------
//    Datalog Plot Page
// ----------------------
void CSampleDlg::OnButtonPage3() 
{
	// TODO: Add your control notification handler code here
  if (silicon == 1615)
    SetPage(IDD_PAGE3);	
  else
    SetPage(IDD_PAGE8);	
	
}

// ----------------------
//    Edit User Memory
// ----------------------
void CSampleDlg::OnButtonPage4() 
{
	// TODO: Add your control notification handler code here
//  SetPage(IDD_PAGE4);
	int nResponse;

	if (D_Edit == TRUE){
		CEditUserMemory dlg;
		nResponse = dlg.DoModal();
		}
	else{
		CEditUserSimple dlg;
		nResponse = dlg.DoModal();
		}

//	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
	}
	else if (nResponse == IDCANCEL)
	{
	}
}

// ----------------------
//  Mission Control Page
// ----------------------
void CSampleDlg::OnButtonPage5() 
{
	// TODO: Add your control notification handler code here
  SetPage(IDD_PAGE5);	
	
}

void CSampleDlg::OnButtonPage6() 
{
	// TODO: Add your control notification handler code here
	CDataSource dlg;
	// initialize the dialog with whatever data source is in use
	strcpy(dlg.m_filename, datasource_file);
	if (datasource == READFROM_KEY) 
		dlg.m_selection = IDC_RADIO_KEY;
	else
		dlg.m_selection = IDC_RADIO_DISK;
	// do the source selection dialog
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		if (dlg.m_selection == IDC_RADIO_KEY) {
			m_page6.SetBitmap( IDB_BITMAPTRY1,31,35);
			m_page6.SetMaskedBitmap( IDB_BITMAPTRY1, 31, 35, RGB( 255, 0, 0 ) );

			// change the image on the screen to indicate which source mode
			HBITMAP bitmap;
			bitmap = LoadBitmap(
				AfxGetResourceHandle( ),					// handle to application instance
				MAKEINTRESOURCE(IDB_BITMAP_SOURCEDEVICE));	// address of bitmap resource name
			int status;
			if (!b_Port_Initialized) {
tryagain:
				CExpandDlgDlg Port;
				Port.SetPreviousPort(theApp.GetRegistrySerialPort());
				int nResponse = Port.DoModal();

				if (nResponse == IDOK) {
					// TODO: Place code here to handle when the dialog is
					//  dismissed with OK
//					HBITMAP bitmap;
					switch (Port.ReturnSelected()) {
						case COM1:			//AfxMessageBox("COM1");	
								auto_poll = true;
								datasource = READFROM_KEY;
								status = InitComPort("COM1", 9600, 1);	
								if (status == COM_OPEN_ERROR) {
									MessageBox("Error: Can not open Port 1","Select Serial Port",MB_ICONSTOP);
									goto tryagain;
					//				AfxGetMainWnd()->SendMessage(WM_CLOSE);
								}
								b_Port_Initialized = true;
								datasource = READFROM_KEY;
							break;
						case COM2:			//AfxMessageBox("COM2");			
								auto_poll = true;
								datasource = READFROM_KEY;
								status = InitComPort("COM2", 9600, 1);
								if (status == COM_OPEN_ERROR) {
									MessageBox("Error: Can not open Port 2","Select Serial Port",MB_ICONSTOP);
									goto tryagain;
					//				AfxGetMainWnd()->SendMessage(WM_CLOSE);
								}
								b_Port_Initialized = true;
								datasource = READFROM_KEY;
							break;
					}	
				} else {
					auto_poll = true;
					datasource = READFROM_FILE;
				}
			}
		}
		else {
			datasource = READFROM_FILE;
			m_page6.SetBitmap( IDB_BITMAPTRY2,31,35);
			m_page6.SetMaskedBitmap( IDB_BITMAPTRY2, 31, 35, RGB( 255, 0, 0 ) );

			// change the image on the screen to indicate which source mode
			HBITMAP bitmap;
			bitmap = LoadBitmap(
				AfxGetResourceHandle( ),					// handle to application instance
				MAKEINTRESOURCE(IDB_BITMAP_SOURCEDISK));	// address of bitmap resource name
//			CStatic* image;
//			image = (CStatic *)GetDlgItem(IDC_PICTURE_DATASOURCE);
//			image->SetBitmap(bitmap);

			strcpy(datasource_file,dlg.m_filename);
			if (initmemoryimage_file(dlg.m_filename) < 0) {
				datasource = READFROM_KEY;
				MessageBox("Error In Data File","Using Data file as source",MB_OK | MB_ICONEXCLAMATION);
			}
		}
		force_plot_refresh = true;

	}
	else if (nResponse == IDCANCEL)
	{
	}
}

// -------------------------
//    Histogram Plot Page
// -------------------------
void CSampleDlg::OnButtonPage7() 
{
	// TODO: Add your control notification handler code here
  if (silicon == 1615)
    SetPage(IDD_PAGE7);	
  else
    SetPage(IDD_PAGE9);	
	
}

// ----------------------------
//    Save All Memory to File
// ----------------------------
void CSampleDlg::OnButtonPage8() 
{
	// TODO: Add your control notification handler code here
	CMemoryToFile dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
	}
	else if (nResponse == IDCANCEL)
	{
	}
}
void CSampleDlg::OnAbout() 
{
	// TODO: Add your control notification handler code here
/*	AboutDlg AboutDlg;
	AboutDlg.DoModal();	*/
//	CBetaDlg BDlg;
//	BDlg.DoModal();
	AboutDlg dlg;
	dlg.DoModal();

}

void CSampleDlg::OnButtonPage10() 
{
	// TODO: Add your control notification handler code here
    SetPage(IDD_PAGE10);	
	
}
