// OScopeCtrl.cpp : implementation file//
/*
  This Evaluation kit software is available free of charge and can be used,
  edited, or reproduced as you see fit. Dallas Semiconductor does not
  assume any liability for the accuracy or correctness of this code.

  It is free to use at your own risk.
  */

#include "stdafx.h"
#include "math.h"

#include "Sample.h"
#include "TextPrint.h"

#include "Cdebug.h"
extern CDebug Debug;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__ ;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGraphCtrl
CTextPrint::CTextPrint()
{
}  // CGraphCtrl

/////////////////////////////////////////////////////////////////////////////
CTextPrint::~CTextPrint()
{
} // ~CGraphCtrl



static s_printstrings2 *lprinthead;
static bool printing_done = false;
static int currenty = 0;

void CTextPrint::PrintGraph() {

	printing_done = false;
	OnFilePrint2();

}


void CTextPrint::OnPrint(CDC * pDC, CPrintInfo * pInfo)
{

	char str[256];
	sprintf(str,"CPrintInfo->m_rectDraw %d %d %d %d",
	pInfo->m_rectDraw.left,
	pInfo->m_rectDraw.top,
	pInfo->m_rectDraw.right,
	pInfo->m_rectDraw.bottom);
//	AfxMessageBox(str);

//	sprintf(str,"HORZSIZE %d, VERTSIZE %d",pDC->GetDeviceCaps(HORZSIZE),pDC->GetDeviceCaps(VERTSIZE));
//	AfxMessageBox(str);
//	sprintf(str,"HORZRES %d, VERTRES %d",pDC->GetDeviceCaps(HORZRES),pDC->GetDeviceCaps(VERTRES));
//	AfxMessageBox(str);
//	sprintf(str,"LOGPIXELSX %d, LOGPIXELSY %d",pDC->GetDeviceCaps(LOGPIXELSX),pDC->GetDeviceCaps(LOGPIXELSY));
//	AfxMessageBox(str);
//	sprintf(str,"pInfo->m_nCurPage %d",pInfo->m_nCurPage);
//	AfxMessageBox(str);


	// figure out logical units per mm 
	float xunits_per_mm;
	xunits_per_mm = pInfo->m_rectDraw.right / 215;	// I am calling a standard sheet of 
	float yunits_per_mm;							// 8.5x11 paper  215mm x 280mm
	yunits_per_mm = pInfo->m_rectDraw.bottom / 280;

	CRect rect = pInfo->m_rectDraw;
	rect.bottom = rect.bottom / 2;

	// bring left and right edges in 1cm
	rect.left += xunits_per_mm * 10;
	rect.right -= xunits_per_mm * 10;

	// shift plot down 1cm
	rect.top += yunits_per_mm * 10;
	rect.bottom += yunits_per_mm * 10;


	// draw text
	CFont axisFont, yUnitFont, *oldFont ;
	CString strTemp ;
	int xpixels_per_inch = pDC->GetDeviceCaps(LOGPIXELSX);
	int ypixels_per_inch = pDC->GetDeviceCaps(LOGPIXELSY);
	int font_height = ypixels_per_inch / 7;	// 1/8 inch font height

// create font (horizontal and vertical)
	axisFont.CreateFont (font_height, 0, 0, 0, 300,		// set at 0 degrees
					   FALSE, FALSE, 0, ANSI_CHARSET,
					   OUT_DEFAULT_PRECIS, 
					   CLIP_DEFAULT_PRECIS,
					   DEFAULT_QUALITY, 
					   DEFAULT_PITCH|FF_SWISS|TMPF_TRUETYPE , "Arial") ;
	oldFont = pDC->SelectObject(&axisFont) ;
	pDC->SetTextAlign (TA_LEFT|TA_TOP) ;

	currenty = font_height*2;
	// display title of plot at top of plot on all pages
	pDC->TextOut (pDC->GetDeviceCaps(HORZRES)/2,font_height , TitleStr);

	// if tabulated, display that first
	s_printstrings2 *ptemp;
	// if this is the first page then point to the head of the string list
	if (pInfo->m_nCurPage == 1) {
		lprinthead = lhead;
	}
	while (lprinthead) {
		pDC->TextOut (rect.left, currenty , *lprinthead->cstr);
		currenty+=font_height;
		// delete CString
		delete lprinthead->cstr;
		ptemp = lprinthead->next;
		// delete the CString structure
		delete lprinthead;
		lprinthead = ptemp;
		// check if we are getting to the end of the page
		//  ... if so, end this page and make the framework loop around to start another one
		if (currenty > (pDC->GetDeviceCaps(VERTRES) - (font_height * 5))) {
//			AfxMessageBox("more");
			// because there is more that one page... display the page number
			sprintf(str,"Page %d",pInfo->m_nCurPage);
			pDC->TextOut (pDC->GetDeviceCaps(HORZRES)/2,pDC->GetDeviceCaps(VERTRES) - font_height - font_height/2 , str);
			goto exit_print;	// we have more info than what can fit on a page
		}
	}

	// this is the last page to print
	printing_done = true;
//	AfxMessageBox("done");
	// if there are multiple pages then display the page number of the last page
	if (pInfo->m_nCurPage != 1) {
		sprintf(str,"Page %d",pInfo->m_nCurPage);
		pDC->TextOut (pDC->GetDeviceCaps(HORZRES)/2,pDC->GetDeviceCaps(VERTRES) - font_height - font_height/2 , str);
	}
	goto all_done;

exit_print:
	printing_done = false;
all_done:
	// restore font
	pDC->SelectObject(oldFont) ;
}


void CTextPrint::OnPrepareDC(CDC * pDC, CPrintInfo * pInfo)
{
//	AfxMessageBox("OnPrepareDC");
	if (printing_done == true) {
		pInfo->m_bContinuePrinting = false;
//		AfxMessageBox("false");
	}
	else {
		pInfo->m_bContinuePrinting = true;
//		AfxMessageBox("true");
	}
}
